#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
using namespace std;

struct Participant {
    int id, score, grade, age;
    string gender;
};

bool compareParticipants(const Participant& a, const Participant& b) {
    if (a.score != b.score) {
        return a.score > b.score;
    }
    return a.id < b.id;
}

int main() {
    int n;
    cin >> n;

    vector<Participant> part(n);
    for (int i = 0; i < n; i++) {
        cin >> part[i].id >> part[i].gender >> part[i].grade >> part[i].age >> part[i].score;
    }

    sort(part.begin(), part.end(), compareParticipants);
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        string olympiad;
        cin >> olympiad;

        vector<int> selected;
        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            for (int j = 0; j < min(4, n); j++) {
                selected.push_back(part[j].id);
            }
        }
        else if (olympiad == "EGOI") {
            for (int j = 0; j < n && selected.size() < 4; j++) {
                if (part[j].gender == "female") {
                    selected.push_back(part[j].id);
                }
            }
        }
        else if (olympiad == "EJOI") {
            for (int j = 0; j < n && selected.size() < 4; j++) {
                if (part[j].age <= 15) {
                    selected.push_back(part[j].id);
                }
            }
        }
        else if (olympiad == "BalkOI") {
            for (int j = 0; j < n && selected.size() < 4; j++) {
                if (part[j].grade != 11) {
                    selected.push_back(part[j].id);
                }
            }
        }
        else if (olympiad == "JBOI") {
            for (int j = 0; j < n && selected.size() < 4; j++) {
                if (part[j].grade != 10 && part[j].grade != 11) {
                    selected.push_back(part[j].id);
                }
            }
        }

        cout << olympiad;
        for (int id : selected) {
            cout << id;
        }
    }

    return 0;
}