from collections import defaultdict

def process_orders(n, m, sizes, available, winners):
    remaining = defaultdict(lambda: defaultdict(int))
    to_order = defaultdict(lambda: defaultdict(int))

    for color in range(1, n+1):
        for size in range(1, m+1):
            remaining[color][size] = available[color-1][size-1]

    for winner in winners:
        color, size = winner
        found = False
        for s in range(size, m+1):
            if remaining[color][s] > 0:
                remaining[color][s] -= 1
                found = True
                break
        if not found:
            for c in range(1, n+1):
                if remaining[c][size] > 0:
                    remaining[c][size] -= 1
                    found = True
                    break
        for s in range(size+1, m+1):
            for c in range(1, n+1):
                if remaining[c][s] > 0:
                    remaining[c][s] -= 1
                    found = True
                    break
            if found:
                break
        if not found:
            to_order[color][size] += 1

    return remaining, to_order
n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [tuple(map(str, input().split())) for _ in range(k)]
remaining, to_order = process_orders(n, m, sizes, available, winners)
for color in range(1, n+1):
    print(" ".join(map(str, [remaining[color][size] for size in range(1, m+1)])))
for color in range(1, n+1):
    print(" ".join(map(str, [to_order[color][size] for size in range(1, m+1)])))
