def process_requests(num_colors, num_sizes, inventory, requests, sizes):
    remaining_inventory = [[0] * num_sizes for _ in range(num_colors)]
    to_be_ordered = [[0] * num_sizes for _ in range(num_colors)]

    for request in requests:
        color_index, size = request
        size_index = sizes.index(size)
        found = False

        for i in range(num_colors):
            color = i
            if inventory[color][size_index] > 0:
                inventory[color][size_index] -= 1
                remaining_inventory[color][size_index] += 1
                found = True
                break
            else:
                for j in range(size_index + 1, num_sizes):
                    if inventory[color][j] > 0:
                        inventory[color][j] -= 1
                        remaining_inventory[color][j] += 1
                        found = True
                        break

        if not found:
            for i in range(color + 1, num_colors):
                for j in range(num_sizes):
                    if inventory[i][j] > 0:
                        inventory[i][j] -= 1
                        remaining_inventory[i][j] += 1
                        found = True
                        break
                if found:
                    break

        if not found:
            to_be_ordered[color][size_index] += 1

    return remaining_inventory, to_be_ordered


# Input
num_colors, num_sizes = map(int, input().split())
sizes = input().split()
colors = [list(map(int, input().split())) for _ in range(num_colors)]
num_requests = int(input())
requests = [input().split() for _ in range(num_requests)]

# Process requests
remaining_inventory, to_be_ordered = process_requests(num_colors, num_sizes, colors, requests, sizes)

# Output remaining inventory
for row in remaining_inventory:
    print(" ".join(map(str, row)))

# Output T-shirts to be ordered
for row in to_be_ordered:
    print(" ".join(map(str, row)))
