#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    map<string, int> sizeMap = {{"XS", 0}, {"S", 1}, {"M", 2}, {"L", 3}, {"XL", 4}, {"2XL", 5}};
    vector<string> sizes(m);
    for(int i = 0; i < m; i++) {
        cin >> sizes[i];
    }

    vector<vector<int>> tshirts(n, vector<int>(m));
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> tshirts[i][j];
        }
    }

    int k;
    cin >> k;
    vector<pair<int, string>> requests(k);
    for(int i = 0; i < k; i++) {
        cin >> requests[i].first >> requests[i].second;
        requests[i].first--; // adjust for 0-based indexing
    }

    vector<vector<int>> remaining = tshirts;
    vector<vector<int>> order(n, vector<int>(m, 0));

    for(auto& request : requests) {
        int color = request.first;
        int size = sizeMap[request.second];
        bool found = false;

        for(int j = size; j < m && !found; j++) {
            for(int i = color; i < n && !found; i++) {
                if(remaining[i][j] > 0) {
                    remaining[i][j]--;
                    found = true;
                }
            }
        }

        if(!found) {
            order[color][size]++;
        }
    }

    for(auto& row : remaining) {
        for(auto& item : row) {
            cout << item << " ";
        }
        cout << "\n";
    }

    for(auto& row : order) {
        for(auto& item : row) {
            cout << item << " ";
        }
        cout << "\n";
    }

    return 0;
}
