from math import inf
class SegmentTree:
    def __init__(self, data):
        self.size = len(data)
        self.arr = [0] * (2 * self.size)
        self.arr[self.size:] = data
        for i in range(self.size - 1, 0, -1):
            self.arr[i] = max(self.arr[2 * i], self.arr[2 * i + 1])
    def query(self, left, right):
        left += self.size
        right += self.size
        res = -inf
        while left < right:
            if left % 2:
                res = max(res, self.arr[left])
                left += 1
            if right % 2:
                right -= 1
                res = max(res, self.arr[right])
            left //= 2
            right //= 2
        return res
n, m = map(int, input().split())
colors = list(map(int, input().split()))
tree = SegmentTree(colors)
remaining_colors = m
max_unselected_segment = tree.query(0, n)
while remaining_colors > 0:
    if max_unselected_segment % 2 == 0:
        max_unselected_segment //= 2
    else:
        max_unselected_segment = max_unselected_segment // 2 + 1
    remaining_colors -= 1
print(max_unselected_segment)