#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<std::string> sizes(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
    }

    std::vector<std::vector<int>> available(n, std::vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> available[i][j];
        }
    }

    int k;
    std::cin >> k;

    std::vector<std::vector<int>> requested(n, std::vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int c;
        std::string s;
        std::cin >> c >> s;
        int sizeIndex = std::find(sizes.begin(), sizes.end(), s) - sizes.begin();
        requested[c - 1][sizeIndex]++;
    }

    // Process requests
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            while (requested[i][j] > 0 && available[i][j] > 0) {
                // Give the requested color and size if available
                requested[i][j]--;
                available[i][j]--;
            }

            if (requested[i][j] > 0) {
                // Find the next available size with priority on color
                for (int k = j + 1; k < m; ++k) {
                    if (requested[i][k] > 0 && available[i][k] > 0) {
                        requested[i][k]--;
                        available[i][k]--;
                        break;
                    }
                }
            }
        }
    }

    // Output remaining and requested counts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << available[i][j] << ' ';
        }
        std::cout << std::endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << requested[i][j] << ' ';
        }
        std::cout << std::endl;
    }

    return 0;
}
