#include <iostream>
#include <vector>
#include <algorithm>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant &a, const Participant &b) {
    return a.score > b.score || (a.score == b.score && a.id < b.id);
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade
                 >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    while (m--) {
        std::string olympiad;
        std::cin >> olympiad;

        std::vector<Participant> team;

        if (olympiad == "IOI") {
            std::sort(participants.begin(), participants.end(), compareParticipants);
            team.insert(team.end(), participants.begin(), participants.begin() + std::min(4, n));
        } else if (olympiad == "CEOI" || olympiad == "BaltOI" || olympiad == "BalkOI") {
            std::sort(participants.begin(), participants.end(), compareParticipants);
            team.insert(team.end(), participants.begin(), participants.begin() + std::min(4, n));
        } else if (olympiad == "EGOI") {
            std::sort(participants.begin(), participants.end(), compareParticipants);
            int girlsCount = std::count_if(participants.begin(), participants.end(), [](const Participant &p) {
                return p.gender == "female";
            });
            team.insert(team.end(), participants.begin(), participants.begin() + std::min(4, girlsCount));
        } else if (olympiad == "EJOI") {
            std::sort(participants.begin(), participants.end(), compareParticipants);
            team.insert(team.end(), participants.begin(), participants.begin() + std::min(4, n));
            auto ageNotExceed15 = std::remove_if(team.begin(), team.end(), [](const Participant &p) {
                return p.age > 15;
            });
            team.erase(ageNotExceed15, team.end());
        } else if (olympiad == "JBOI") {
            std::sort(participants.begin(), participants.end(), compareParticipants);
            team.insert(team.end(), participants.begin(), participants.begin() + std::min(4, n));
            auto gradeNotExceed10 = std::remove_if(team.begin(), team.end(), [](const Participant &p) {
                return p.grade >= 10;
            });
            team.erase(gradeNotExceed10, team.end());
        }

        std::cout << olympiad << std::endl;
        for (const auto &participant : team) {
            std::cout << participant.id << std::endl;
        }
    }

    return 0;
}
