#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    long long left = 1, right = 1e18;
    while (left < right) {
        long long mid = (left + right + 1) / 2;
        vector<long long> segments;

        // Count the length of each segment
        long long current_segment = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] <= mid) {
                current_segment += a[i];
            } else {
                segments.push_back(current_segment);
                current_segment = 0;
            }
        }
        segments.push_back(current_segment);

        // Count the number of segments with length greater than or equal to mid
        long long count = 0;
        for (long long segment : segments) {
            count += max(0LL, segment - mid + 1);
        }

        // Adjust the search space
        if (count >= m) {
            left = mid;
        } else {
            right = mid - 1;
        }
    }

    cout << left << endl;

    return 0;
}
