def process_gifts(n, m, sizes, initial_counts, winners):
    remaining_counts = [[0] * m for _ in range(n)]
    needed_counts = [[0] * m for _ in range(n)]

    for i in range(n):
        remaining_counts[i] = initial_counts[i][:]

    for winner in winners:
        color, size = winner[1], winner[2]
        size_index = sizes.index(size)

        found = False

        for j in range(size_index, m):
            if remaining_counts[color][j] > 0:
                remaining_counts[color][j] -= 1
                found = True
                break

        if not found:
            for j in range(size_index):
                if remaining_counts[color][j] > 0:
                    remaining_counts[color][j] -= 1
                    needed_counts[color][j] += 1
                    found = True
                    break

        if not found:
            for j in range(m):
                if remaining_counts[color][j] > 0:
                    remaining_counts[color][j] -= 1
                    needed_counts[color][j] += 1
                    break

    return remaining_counts, needed_counts


n, m = map(int, input().split())
sizes = input().split()
initial_counts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(map(str, input().split())) for _ in range(k)]


remaining_counts, needed_counts = process_gifts(n, m, sizes, initial_counts, winners)

for row in remaining_counts:
    print(*row)

for row in needed_counts:
    print(*row)
