def print_ornament(n, m):
    # Initialize the ornament matrix.
    ornament = [["." for _ in range(m)] for _ in range(n)]

    # Set the initial positions of the rays.
    ray1_x = 0
    ray1_y = 0
    ray2_x = n - 1
    ray2_y = 0

    # Draw the rays until they disappear.
    while True:
        # Draw ray 1.
        while True:
            ornament[ray1_y][ray1_x] = "x"

            # Check if ray 1 reaches the bottom edge.
            if ray1_y == n - 1:
                break

            # Check if ray 1 hits the vertical edge.
            if ray1_x == 0:
                ray1_y += 1
                continue

            # Reflect ray 1.
            ray1_x -= 1
            ray1_y += 1

        # Draw ray 2.
        while True:
            ornament[ray2_y][ray2_x] = "x"

            # Check if ray 2 reaches the bottom edge.
            if ray2_y == n - 1:
                break

            # Check if ray 2 hits the vertical edge.
            if ray2_x == m - 1:
                ray2_y += 1
                # Reset ray2_x to zero to avoid out-of-bounds indexing
                ray2_x = 0
                continue

            # Reflect ray 2.
            ray2_x += 1
            ray2_y += 1

        # Check if both rays have disappeared.
        if ray1_x == 0 and ray1_y == n - 1 and ray2_x == m - 1 and ray2_y == n - 1:
            break

        # Move the initial positions of the rays to the next row.
        ray1_y += 1
        ray1_x = 0
        ray2_y += 1
        ray2_x = n - 1

    # Print the ornament.
    for row in ornament:
        print("".join(row))

