def distribute_tshirts(n, m, sizes, tshirt_counts, k, winners):
    remaining_tshirts = [[0] * m for _ in range(n)]
    needed_tshirts = [[0] * m for _ in range(n)]

    for i in range(k):
        team_index, size = winners[i]
        size_index = sizes.index(size)

        # Check if the requested size and color are available
        if tshirt_counts[int(team_index) - 1][size_index] > 0:
            tshirt_counts[int(team_index) - 1][size_index] -= 1
            remaining_tshirts[int(team_index) - 1][size_index] += 1
        else:
            # Find a T-shirt of the same size and different color
            found_alternative = False
            for j in range(n):
                if tshirt_counts[j][size_index] > 0:
                    tshirt_counts[j][size_index] -= 1
                    remaining_tshirts[j][size_index] += 1
                    found_alternative = True
                    break

            # If no alternative of the same size, look for larger sizes with color priority
            if not found_alternative:
                for size in range(size_index + 1, m):
                    for j in range(n):
                        if tshirt_counts[j][size] > 0:
                            tshirt_counts[j][size] -= 1
                            remaining_tshirts[j][size] += 1
                            found_alternative = True
                            break
                    if found_alternative:
                        break

            # If no alternative is found, mark the T-shirt as needed
            if not found_alternative:
                needed_tshirts[int(team_index) - 1][size_index] += 1

    return remaining_tshirts, needed_tshirts

# Input parsing
n, m = map(int, input().split())
sizes = input().split()
tshirt_counts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [input().split() for _ in range(k)]

# Call the function
remaining, needed = distribute_tshirts(n, m, sizes, tshirt_counts, k, winners)

# Output the results
for row in remaining:
    print(" ".join(map(str, row)))

for row in needed:
    print(" ".join(map(str, row)))