def distribute_tshirts(n, m, sizes, tshirt_counts, k, winners):
    remaining_tshirts = [row[:] for row in tshirt_counts]
    needed_tshirts = [[0] * m for _ in range(n)]

    for i in range(k):
        team_index, size = winners[i][0] - 1, sizes.index(winners[i][1])

        # Check if the requested size and color is available
        if remaining_tshirts[team_index][size] > 0:
            remaining_tshirts[team_index][size] -= 1
        else:
            # Look for a T-shirt of the same size but different color
            found_alternative = False
            for j in range(n):
                if remaining_tshirts[j][size] > 0:
                    remaining_tshirts[j][size] -= 1
                    found_alternative = True
                    break

            # If no alternative of the same size, look for larger sizes
            if not found_alternative:
                for larger_size in range(size + 1, m):
                    for j in range(n):
                        if remaining_tshirts[j][larger_size] > 0:
                            remaining_tshirts[j][larger_size] -= 1
                            found_alternative = True
                            break
                    if found_alternative:
                        break

            # If no alternative is found, mark the T-shirt as needed
            if not found_alternative:
                needed_tshirts[team_index][size] += 1

    return remaining_tshirts, needed_tshirts

# Input parsing
n, m = map(int, input().split())
sizes = input().split()
tshirt_counts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [map(str, input().split()) for _ in range(k)]

# Call the function
remaining, needed = distribute_tshirts(n, m, sizes, tshirt_counts, k, winners)

# Output the results
for row in remaining:
    print(" ".join(map(str, row)))

for row in needed:
    print(" ".join(map(str, row)))
