def main():
    # Input
    n, m = map(int, input().split())
    sizes = input().split()
    tshirts = [[int(x) for x in input().split()] for _ in range(n)]
    winners = int(input())
    orders = [input().split() for _ in range(winners)]

    # Process orders
    for c, s in orders:
        color = int(c) - 1
        size_index = sizes.index(s)
        found = False

        # Check if the requested size and color are available
        if tshirts[color][size_index] > 0:
            tshirts[color][size_index] -= 1
            found = True
        else:
            # Look for a T-shirt of the same size but a different color
            for i in range(n):
                if tshirts[i][size_index] > 0:
                    tshirts[i][size_index] -= 1
                    found = True
                    break

            # If not found, look for T-shirts of the next larger size
            for i in range(size_index + 1, m):
                if any(tshirts[j][i] > 0 for j in range(n)):
                    for j in range(n):
                        if tshirts[j][i] > 0:
                            tshirts[j][i] -= 1
                            tshirts[j][size_index] += 1
                            found = True
                            break
                    break

        # Record absent T-shirts
        if not found:
            tshirts[color][size_index] -= 1

    # Output remaining and needed T-shirts
    for i in range(n):
        print(" ".join(map(str, tshirts[i])))

    for i in range(n):
        needed_tshirts = [max(0, -x) for x in tshirts[i]]
        print(" ".join(map(str, needed_tshirts)))

if __name__ == "__main__":
    main()
