def can_choose(colors, m, length):
    # Calculate the number of colors that can be chosen with the given length
    chosen_colors = sum(min(length, ai) for ai in colors)
    return chosen_colors >= m + 1

def max_unmarked_length(n, m, colors):
    # Binary search for the maximum length
    left, right = 1, max(colors)
    result = 0

    while left <= right:
        mid = (left + right) // 2

        if can_choose(colors, m, mid):
            result = mid
            left = mid + 1
        else:
            right = mid - 1

    return result

# Input
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Output
print(max_unmarked_length(n, m, colors))
