def max_sequence_length(n, m, a):
    max_length = 0

    # Find the maximum length among all color wheels
    for i in range(n):
        max_length = max(max_length, a[i])

    # Calculate the remaining colors to be chosen
    remaining_colors = m - n

    # If no additional colors need to be chosen, return the current max_length
    if remaining_colors <= 0:
        return max_length

    # Distribute the remaining colors among the color wheels
    max_length += remaining_colors // n * max(a)

    # Handle any remaining colors
    remaining_colors %= n
    if remaining_colors > 0:
        max_length += max(a[:remaining_colors])

    return max_length

# Input processing
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output the result
print(max_sequence_length(n, m, a))
