import math
import heapq

def getMaxLen(n, a, m):
    used = [False] * (10**6 + 1)
    heap = []

    for i in range(n):
        used[a[i]] = True
        a[i] += 1
        while a[i] <= 10**6 and used[a[i]]:
            a[i] += 1
        heapq.heappush(heap, -a[i])

    for _ in range(m):
        max_a = -heapq.heappop(heap)
        max_a -= 1
        while max_a > 1 and used[max_a]:
            max_a -= 1
        if max_a == 1:
            return len(heap) + 1
        heapq.heappush(heap, -max_a)
        used[max_a] = True

    return len(heap)

if __name__ == "__main__":
    n, m = map(int, input().split())
    a = list(map(int, input().split()))
    print(getMaxLen(n, a, m))