def determine_teams(participants, olympiad):
    if olympiad in ['IOI', 'CEOI']:
        return sorted(participants, key=lambda x: (-x['score'], x['id']))[:4]
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p['gender'] == 'female']
        return sorted(female_participants, key=lambda x: (-x['score'], x['id']))[:4]
    elif olympiad == 'EJOI':
        under_15_participants = [p for p in participants if p['age'] <= 15]
        return sorted(under_15_participants, key=lambda x: (-x['score'], x['id']))[:4]
    elif olympiad == 'BaltOI':
        return sorted(participants, key=lambda x: (-x['score'], x['id']))[:6]
    elif olympiad == 'BalkOI':
        not_11th_grade_participants = [p for p in participants if p['grade'] != 11]
        return sorted(not_11th_grade_participants, key=lambda x: (-x['score'], x['id']))[:4]
    elif olympiad == 'JBOI':
        not_11th_10th_grade_participants = [p for p in participants if p['grade'] not in [11, 10]]
        return sorted(not_11th_10th_grade_participants, key=lambda x: (-x['score'], x['id']))[:4]
    else:
        return []

def main():
    n = int(input())
    participants = []
    for _ in range(n):
        pid, gender, grade, age, score = input().split()
        participants.append({
            'id': int(pid),
            'gender': gender,
            'grade': int(grade),
            'age': int(age),
            'score': int(score)
        })

    m = int(input())
    olympiads = [input() for _ in range(m)]

    for olympiad in olympiads:
        teams = determine_teams(participants, olympiad)
        print(olympiad)
        for participant in teams:
            print(participant['id'])

if __name__ == "__main__":
    main()
