function teamComposition(participants, olympiads) {
  let result = {};

  olympiads.forEach((olympiad) => {
    const teams = [];

    if (olympiad === 'IOI' || olympiad === 'CEOI' || olympiad === 'BaltOI') {
      const participantsSorted = participants.sort((a, b) => b.score - a.score);

      for (let i = 0; i < Math.min(6, participantsSorted.length); i++) {
        teams.push(participantsSorted[i].id);
      }
    } else if (olympiad === 'EGOI') {
      const females = participants.filter((participant) => participant.gender === 'female');
      const femalesSorted = females.sort((a, b) => b.score - a.score);

      for (let i = 0; i < Math.min(4, femalesSorted.length); i++) {
        teams.push(femalesSorted[i].id);
      }
    } else if (olympiad === 'EJOI') {
      const juniors = participants.filter((participant) => participant.age <= 15);
      const juniorsSorted = juniors.sort((a, b) => b.score - a.score);

      for (let i = 0; i < Math.min(4, juniorsSorted.length); i++) {
        teams.push(juniorsSorted[i].id);
      }
    } else if (olympiad === 'BalkOI') {
      const nonGrades11 = participants.filter((participant) => participant.grade !== 11);
      const nonGrades11Sorted = nonGrades11.sort((a, b) => b.score - a.score);

      for (let i = 0; i < Math.min(4, nonGrades11Sorted.length); i++) {
        teams.push(nonGrades11Sorted[i].id);
      }
    } else if (olympiad === 'JBOI') {
      const nonGrades11and10 = participants.filter((participant) => participant.grade !== 11 && participant.grade !== 10);
      const nonGrades11and10Sorted = nonGrades11and10.sort((a, b) => b.score - a.score);

      for (let i = 0; i < Math.min(4, nonGrades11and10Sorted.length); i++) {
        teams.push(nonGrades11and10Sorted[i].id);
      }
    }

    result[olympiad] = teams;
  });

  return result;
}

// Sample input
const participants = [
  { id: 1000001, gender: 'female', grade: 10, age: 16, score: 400 },
  { id: 1000002, gender: 'male', grade: 10, age: 17, score: 500 },
  // ... Other participants
];

const olympiads = ['IOI', 'EGOI', 'BaltOI'];

const composition = teamComposition(participants, olympiads);
for (const olympiad in composition) {
  console.log(olympiad);
  console.log(composition[olympiad].join('\n'));
}
