#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool sortByScoreDesc(const Participant &a, const Participant &b) {
    return a.score > b.score;
}

bool sortByAge(const Participant &a, const Participant &b) {
    return a.age < b.age;
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), sortByScoreDesc);

    int m;
    cin >> m;

    map<string, int> teamSizes = {
        {"IOI", 4},
        {"CEOI", 4},
        {"EGOI", 4},
        {"EJOI", 4},
        {"BaltOI", 6},
        {"BalkOI", 4},
        {"JBOI", 4}
    };

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        int teamSize = teamSizes[olympiad];

        if (olympiad == "EGOI") {
            vector<Participant> females;
            for (const auto &participant : participants) {
                if (participant.gender == "female") {
                    females.push_back(participant);
                }
            }
            sort(females.begin(), females.end(), sortByScoreDesc);
            if (females.size() < teamSize) {
                teamSize = females.size();
            }
            for (int j = 0; j < teamSize; ++j) {
                cout << females[j].id << endl;
            }
        } else if (olympiad == "EJOI") {
            vector<Participant> youngParticipants;
            for (const auto &participant : participants) {
                if (participant.age <= 15) {
                    youngParticipants.push_back(participant);
                }
            }
            sort(youngParticipants.begin(), youngParticipants.end(), sortByScoreDesc);
            if (youngParticipants.size() < teamSize) {
                teamSize = youngParticipants.size();
            }
            for (int j = 0; j < teamSize; ++j) {
                cout << youngParticipants[j].id << endl;
            }
        } else if (olympiad == "BalkOI") {
            vector<Participant> non11thGraders;
            for (const auto &participant : participants) {
                if (participant.grade != 11) {
                    non11thGraders.push_back(participant);
                }
            }
            sort(non11thGraders.begin(), non11thGraders.end(), sortByScoreDesc);
            if (non11thGraders.size() < teamSize) {
                teamSize = non11thGraders.size();
            }
            for (int j = 0; j < teamSize; ++j) {
                cout << non11thGraders[j].id << endl;
            }
        } else if (olympiad == "JBOI") {
            vector<Participant> non10th11thGraders;
            for (const auto &participant : participants) {
                if (participant.grade != 10 && participant.grade != 11) {
                    non10th11thGraders.push_back(participant);
                }
            }
            sort(non10th11thGraders.begin(), non10th11thGraders.end(), sortByScoreDesc);
            if (non10th11thGraders.size() < teamSize) {
                teamSize = non10th11thGraders.size();
            }
            for (int j = 0; j < teamSize; ++j) {
                cout << non10th11thGraders[j].id << endl;
            }
        } else {
            if (participants.size() < teamSize) {
                teamSize = participants.size();
            }
            for (int j = 0; j < teamSize; ++j) {
                cout << participants[j].id << endl;
            }
        }
    }

    return 0;
}

