from collections import defaultdict

def find_team_members(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EGOI":
        females = [p for p in participants if p[1] == "female"]
        return sorted(females, key=lambda x: (-x[4], x[0]))[:min(4, len(females))]
    elif olympiad == "EJOI":
        juniors = [p for p in participants if p[3] <= 15]
        return sorted(juniors, key=lambda x: (-x[4], x[0]))[:min(4, len(juniors))]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == "BalkOI":
        non_11_graders = [p for p in participants if p[2] != 11]
        return sorted(non_11_graders, key=lambda x: (-x[4], x[0]))[:min(4, len(non_11_graders))]
    elif olympiad == "JBOI":
        non_11_10_graders = [p for p in participants if p[2] != 11 and p[2] != 10]
        return sorted(non_11_10_graders, key=lambda x: (-x[4], x[0]))[:min(4, len(non_11_10_graders))]

n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participant_info[0] = int(participant_info[0])
    participant_info[3] = int(participant_info[3])
    participant_info[4] = int(participant_info[4])
    participants.append(participant_info)

m = int(input())
requested_olympiads = [input() for _ in range(m)]

participants_by_olympiad = defaultdict(list)

for olympiad in requested_olympiads:
    team_members = find_team_members(olympiad, participants)
    for member in team_members:
        participants_by_olympiad[olympiad].append(member[0])

for olympiad in requested_olympiads:
    print(olympiad)
    for member_id in sorted(participants_by_olympiad[olympiad]):
        print(member_id)
