def find_longest_subsegment(colors):
    max_length = 0
    current_length = 0

    for color in colors:
        if color == 0:
            current_length += 1
        else:
            max_length = max(max_length, current_length)
            current_length = 0

    return max(max_length, current_length)


def main():
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    result = 0

    for _ in range(m):
        longest_subsegment = find_longest_subsegment(colors)
        result = max(result, longest_subsegment)

        # Find the longest segment of non-crossed colors
        start = 0
        end = len(colors) - 1

        while colors[start] == 1 or colors[end] == 1:
            if colors[start] == 1:
                start += 1
            if colors[end] == 1:
                end -= 1

        # Mark the color in the middle as crossed
        middle = (start + end) // 2
        colors[middle] = 1

    print(result)


if __name__ == "__main__":
    main()
