def find_item_to_move(weights, boxes):
    max_weight_before = max(sum(weights[i] for i in range(4) if boxes[i] == 1),
                           sum(weights[i] for i in range(4) if boxes[i] == 2))

    min_move_weight = float('inf')
    item_to_move = -1

    for i in range(4):
        for j in range(1, 3):
            if boxes[i] != j:
                current_weight = max_weight_before - weights[i] * (boxes[i] - j)
                if current_weight < min_move_weight:
                    min_move_weight = current_weight
                    item_to_move = i + 1  # Item numbers are 1-based

    return item_to_move

def main():
    weights = list(map(int, input().split()))
    boxes = list(map(int, input().split()))

    result = find_item_to_move(weights, boxes)
    print(result)

if __name__ == "__main__":
    main()
