def знайти_кількість_днів(день: int, місяць: int) -> int:
    """Знаходження кількості днів відповідного місяця.

    Args:
        день (int): День місяця.
        місяць (int): Номер місяця.

    Returns:
        int: Кількість днів відповідного місяця.
    """
    дні_в_місяці = [0, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30]
    return дні_в_місяці[місяць]

def чи_народилися_в_один_день(д1: int, м1: int, д2: int, м2: int) -> bool:
    """Перевірка, чи народилися в один день за різними календарями.

    Args:
        д1 (int): День за Байтуліанським календарем.
        м1 (int): Місяць за Байтуліанським календарем.
        д2 (int): День за Бітуліанським календарем.
        м2 (int): Місяць за Бітуліанським календарем.

    Returns:
        bool: True, якщо народилися в один день; False, якщо ні.
    """
    дні_в_місяці_д1 = знайти_кількість_днів(д1, м1)
    дні_в_місяці_д2 = знайти_кількість_днів(д2, м2)

    return дні_в_місяці_д1 == дні_в_місяці_д2

if __name__ == "__main__":
    # Зчитуємо введені дані
    день1 = int(input())
    місяць1 = int(input())
    день2 = int(input())
    місяць2 = int(input())

    # Перевіряємо, чи народилися в один день
    результат = чи_народилися_в_один_день(день1, місяць1, день2, місяць2)

    # Виводимо результат
    if результат:
        print("YES")
    else:
        print("NO")