def check(mid, wheels, m):
    # Функція для перевірки, чи можна вибрати ще m кольорів після закреслення mid кольорів
    count = 0
    for wheel in wheels:
        count += max(0, len(wheel) - mid) if wheel else 0
    return count >= m

def max_unmarked_length(n, m, wheels):
    # Ініціалізація лівої та правої меж для бінарного пошуку
    left, right = 0, max(max(wheel, default=0) for wheel in wheels)

    while left < right:
        mid = (left + right + 1) // 2
        if check(mid, wheels, m):
            left = mid
        else:
            right = mid - 1

    return left

def main():
    # Зчитування вхідних даних
    n, m = map(int, input().split())
    wheels = [list(map(int, input().split()))[1:] for _ in range(n)]

    # Обчислення та виведення результату
    result = max_unmarked_length(n, m, wheels)
    print(result)

if __name__ == "__main__":
    main()
