def min_max_weight(items):
    left, right = 0, sum(items)

    while left < right:
        mid = (left + right) // 2

        # Check if it's possible to move items to achieve max weight <= mid
        if can_move(items, mid):
            right = mid
        else:
            left = mid + 1

    return left

def can_move(items, max_weight):
    # Check if it's possible to move items to achieve max weight <= max_weight
    moved_weight = 0
    current_box_weight = 0

    for item_weight in items:
        if item_weight > max_weight:
            return False

        if current_box_weight + item_weight <= max_weight:
            current_box_weight += item_weight
        else:
            moved_weight += current_box_weight
            current_box_weight = item_weight

    moved_weight += current_box_weight

    return moved_weight <= max_weight

# Input
weights = list(map(int, input().split()))

# Output
result = min_max_weight(weights)
print(result)
