#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> count(n, vector<int>(m, 0));
    vector<vector<int>> needed(n, vector<int>(m, 0));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> count[i][j];
        }
    }

    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            // If the T-shirt is available, distribute it
            if (count[i][j] > 0) {
                count[i][j]--;
            } else {
                // Find an alternative T-shirt
                int k = j + 1;
                while (k < m && count[i][k] == 0) {
                    k++;
                }

                if (k < m) {
                    count[i][k]--;
                } else {
                    // If no alternative sizes are available, mark the T-shirt as needed
                    needed[i][j]++;
                }
            }
        }
    }

    // Output superfluous T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << count[i][j] << " ";
        }
        cout << endl;
    }

    // Output needed T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << needed[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
