#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long find_max_length(vector<long long>& colors, long long m) {
    long long left = 1, right = accumulate(colors.begin(), colors.end(), 0LL) + m;

    while (left < right) {
        long long mid = (left + right) / 2;
        long long count = 0;
        long long last = 0;

        for (long long color : colors) {
            if (color - last - 1 >= mid) {
                count += (color - last - 1) / mid;
            }
            last = color;
        }

        if (count + (last < accumulate(colors.begin(), colors.end(), 0LL)) >= m) {
            left = mid + 1;
        } else {
            right = mid;
        }
    }

    return left - 1;
}

int main() {
    long long n, m;
    cin >> n >> m;

    vector<long long> colors(n);
    for (long long i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    long long result = find_max_length(colors, m);
    cout << result << endl;

    return 0;
}
