def find_available_color_and_size(color, size, available):
  if available[color][size] > 0:
      available[color][size] -= 1
      return True
  return False

def find_available_color_of_smaller_size(color, size, available):
  for i in range(size - 1, -1, -1):
      if available[color][i] > 0:
          available[color][i] -= 1
          return True
  return False

def find_available_color_of_larger_size(color, size, available):
  for i in range(size + 1, len(available[0])):
      if available[color][i] > 0:
          available[color][i] -= 1
          return True
  return False

def process_orders(n, m, sizes, orders):
  available = [[0] * m for _ in range(n)]

  for _ in range(n):
      row = list(map(int, input().split()))
      for j in range(m):
          available[_][j] = row[j]

  k = int(input())
  not_delivered = []

  for _ in range(k):
      c, s = input().split()
      color = int(c) - 1
      size = sizes.index(s)

      if not find_available_color_and_size(color, size, available):
          if not find_available_color_of_smaller_size(color, size, available):
              if not find_available_color_of_larger_size(color, size, available):
                  not_delivered.append((color, size))

  return available, not_delivered

def print_results(available, not_delivered):
  for row in available:
      print(*row)

  for item in not_delivered:
      print(item[0] + 1, sizes[item[1]])

n, m = map(int, input().split())
sizes = input().split()

available, not_delivered = process_orders(n, m, sizes, [])
print_results(available, not_delivered)
