from heapq import nlargest, nsmallest

def compose_teams(participants, olympiads):
    teams = {olympiad: [] for olympiad in olympiads}

    for olympiad in olympiads:
        if olympiad == "IOI" or olympiad == "CEOI" or olympiad == "BaltOI":
            top_participants = nlargest(4, participants, key=lambda x: x[4])
        elif olympiad == "EGOI":
            top_participants = nlargest(4, filter(lambda x: x[1] == "female", participants), key=lambda x: x[4])
        elif olympiad == "EJOI":
            top_participants = nlargest(4, filter(lambda x: x[3] <= 15, participants), key=lambda x: x[4])
        elif olympiad == "BalkOI":
            top_participants = nlargest(4, filter(lambda x: x[2] != 11, participants), key=lambda x: x[4])
        elif olympiad == "JBOI":
            top_participants = nlargest(4, filter(lambda x: x[2] not in {10, 11}, participants), key=lambda x: x[4])

        teams[olympiad] = [participant[0] for participant in top_participants]

    return teams

def main():
    n = int(input())
    participants = [tuple(input().split()) for _ in range(n)]
    participants = [(int(pid), gender, int(grade), int(age), int(score)) for pid, gender, grade, age, score in participants]

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    teams = compose_teams(participants, olympiads)

    for olympiad in olympiads:
        print(olympiad)
        for participant_id in sorted(teams[olympiad]):
            print(participant_id)

if __name__ == "__main__":
    main()