#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; i++) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> requested(n, vector<int>(m));
    for (int i = 0; i < k; i++) {
        int color;
        string size;
        cin >> color >> size;
        requested[color - 1][distance(sizes.begin(), findsizes.begin(), sizes.end(), size))]++;
    }

    vector<vector<int>> remaining = available;
    vector<vector<int>> to_order(n, vector<int>(m));

    for (int i = 0; i < k; i++) {
        int color;
        string size;
        cin >> color >> size;
        color--;

        int size_index = distance(sizes.begin(), find(sizes.begin(), sizes.end(), size));

        if (available[color][size_index] > 0) {
            available[color][size_index]--;
        } else {
            int next_size_index = size_index;
            while (next_size_index < m && available[color][next_size_index] == 0) {
                next_size_index++;
            }

            if (next_size_index < m) {
                available[color][next_size_index]--;
                to_order[color][next_size_index]++;
            } else {
                int next_color = color + 1;
                while (next_color < n && available[next_color][size_index] == 0) {
                    next_color++;
                }

                if (next_color < n) {
                    available[next_color][size_index]--;
                    to_order[next_color][size_index]++;
                } else {
                    to_order[color][size_index]++;
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
