from collections import defaultdict

def solve(n, m, sizes, available, k, requests):
    remaining_tshirts = defaultdict(lambda: defaultdict(int))
    needed_tshirts = defaultdict(lambda: defaultdict(int))

    for i in range(k):
        color, size = requests[i]
        size_index = sizes.index(size)

        if available[color][size_index] > 0:
            available[color][size_index] -= 1
        else:
            found = False

            for c in range(n):
                if available[c][size_index] > 0:
                    available[c][size_index] -= 1
                    remaining_tshirts[c][size_index] += 1
                    found = True
                    break

            while not found:
                size_index += 1
                if size_index >= m:
                    break

                for c in range(n):
                    if available[c][size_index] > 0:
                        available[c][size_index] -= 1
                        remaining_tshirts[c][size_index] += 1
                        found = True
                        break

            if not found:
                needed_tshirts[color][sizes[size_index]] += 1

    return remaining_tshirts, needed_tshirts

n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [tuple(input().split()) for _ in range(k)]

remaining, needed = solve(n, m, sizes, available, k, requests)

for color in range(n):
    print(" ".join(map(str, [remaining[color][size_index] for size_index in range(m)])))

for color in range(n):
    print(" ".join(map(str, [needed[color][sizes[size_index]] for size_index in range(m)])))
