#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m));
    vector<vector<int>> to_order(n, vector<int>(m));

    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        cin >> c >> s;
        --c;

        int size_index = find(sizes.begin(), sizes.end(), string(1, s)) - sizes.begin();

        if (available[c][size_index] > 0) {
            --available[c][size_index];
        } else {
            int alt_color = -1;
            for (int j = 0; j < n; ++j) {
                if (available[j][size_index] > 0) {
                    alt_color = j;
                    break;
                }
            }

            if (alt_color != -1) {
                --available[alt_color][size_index];
            } else {
                for (int j = size_index + 1; j < m; ++j) {
                    bool found = false;
                    for (int l = 0; l < n; ++l) {
                        if (available[l][j] > 0) {
                            alt_color = l;
                            found = true;
                            break;
                        }
                    }

                    if (found) {
                        --available[alt_color][j];
                        to_order[alt_color][j]++;
                        break;
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << available[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}

