#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) cin >> sizes[i];

    vector<vector<int>> available(n, vector<int>(m));
    for (auto &row : available)
        for (int &count : row) cin >> count;

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m)), to_order(n, vector<int>(m));

    while (k--) {
        int c;
        char s;
        cin >> c >> s;
        --c;

        int size_index = -1;
        for (int i = 0; i < m; ++i)
            if (sizes[i][0] == s) size_index = i;

        if (available[c][size_index]) {
            --available[c][size_index];
        } else {
            int alt_color = -1;
            for (int j = 0; j < n && alt_color == -1; ++j)
                if (available[j][size_index]) alt_color = j;

            if (alt_color == -1)
                for (int j = size_index + 1; j < m && alt_color == -1; ++j)
                    for (int l = 0; l < n && alt_color == -1; ++l)
                        if (available[l][j]) alt_color = l;

            if (alt_color != -1) {
                --available[alt_color][size_index];
            } else {
                ++to_order[c][size_index];
            }
        }
    }

    for (const auto &row : available) {
        for (int count : row) cout << count << ' ';
        cout << endl;
    }

    for (const auto &row : to_order) {
        for (int count : row) cout << count << ' ';
        cout << endl;
    }

    return 0;
}
