#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant &p1, const Participant &p2) {
    return p1.score > p2.score || (p1.score == p2.score && p1.id < p2.id);
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    map<string, int> olympiads;
    vector<vector<int>> selectedIds(m);

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;
        olympiads[olympiad] = i;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "EGOI") {
            for (int j = 0; j < min(4, n); ++j) {
                if ((olympiad == "EGOI" && participants[j].gender == "female") || (olympiad == "EGOI" && participants[j].age <= 15) || (olympiad != "EGOI")) {
                    selectedIds[i].push_back(participants[j].id);
                }
            }
        } else if (olympiad == "EJOI") {
            for (int j = 0; j < min(4, n); ++j) {
                if (participants[j].age <= 15) {
                    selectedIds[i].push_back(participants[j].id);
                }
            }
        } else if (olympiad == "BaltOI") {
            for (int j = 0; j < min(6, n); ++j) {
                selectedIds[i].push_back(participants[j].id);
            }
        } else if (olympiad == "BalkOI") {
            for (int j = 0; j < min(4, n); ++j) {
                if (participants[j].grade != 11) {
                    selectedIds[i].push_back(participants[j].id);
                }
            }
        } else if (olympiad == "JBOI") {
            for (int j = 0; j < min(4, n); ++j) {
                if (participants[j].grade != 11 && participants[j].grade != 10) {
                    selectedIds[i].push_back(participants[j].id);
                }
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        cout << selectedIds[olympiads[olympiads.begin()->first]].size() << endl;
        for (int id : selectedIds[olympiads[olympiads.begin()->first]]) {
            cout << id << endl;
        }
    }

    return 0;
}

