function createOrnament(n, m) {
    const ornament = Array.from({ length: n }, () => Array(m).fill('.'));

    for (let i = 0; i < n; i++) {
        for (let j = 0; j < m; j++) {
            if ((i + j) % 2 === 0) {
                ornament[i][j] = 'x';
            }
        }
    }

    return ornament;
}

function printOrnament(ornament) {
    for (const row of ornament) {
        console.log(row.join(''));
    }
}

function main() {
    const readline = require('readline');
    const rl = readline.createInterface({
        input: process.stdin,
        output: process.stdout
    });

    rl.question('Введіть висоту та ширину відповідно (наприклад, "6 4"): ', (input) => {
        const [n, m] = input.split(' ').map(Number);
        const ornament = createOrnament(n, m);
        printOrnament(ornament);

        rl.close();
    });
}

main();
