def process_gifts(n, m, sizes, available, winners):
    remaining = [[0] * m for _ in range(n)]
    to_order = [[0] * m for _ in range(n)]

    for i in range(n):
        for j in range(m):
            remaining[i][j] = available[i][j]

    for i in range(len(winners)):
        color, size = winners[i][1], winners[i][0]
        size_index = sizes.index(size)

        # Check if the requested size and color is available
        if remaining[color - 1][size_index] > 0:
            remaining[color - 1][size_index] -= 1
        else:
            # Find a shirt with the same size but different color
            found_alternative = False
            for alt_color in range(n):
                if remaining[alt_color][size_index] > 0:
                    remaining[alt_color][size_index] -= 1
                    to_order[alt_color][size_index] += 1
                    found_alternative = True
                    break

            if not found_alternative:
                # Find the next larger size with the same color
                for alt_size in range(size_index + 1, m):
                    if remaining[color - 1][alt_size] > 0:
                        remaining[color - 1][alt_size] -= 1
                        to_order[color - 1][alt_size] += 1
                        found_alternative = True
                        break

                # If still no alternative is found, mark the shirt as missing
                if not found_alternative:
                    to_order[color - 1][size_index] += 1

    return remaining, to_order

# Reading input
n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [tuple(map(int, input().split())) for _ in range(k)]

# Processing gifts
remaining, to_order = process_gifts(n, m, sizes, available, winners)

# Printing output
for row in remaining:
    print(" ".join(map(str, row)))

for row in to_order:
    print(" ".join(map(str, row)))
