using System;
using System.Collections.Generic;
using System.Linq;

class Program
{
    static void Main()
    {
        string[] sizes = { "XS", "S", "M", "L", "XL", "2XL" };

        // Введення кількості різних кольорів та розмірів футболок
        int[] nm = Console.ReadLine().Split().Select(int.Parse).ToArray();
        int n = nm[0];
        int m = nm[1];

        // Введення розмірів футболок, які доставила Міс М
        string[] availableSizes = Console.ReadLine().Split();

        // Зчитування кількості футболок кожного кольору та розміру
        int[,] shirtsCount = new int[n, m];
        for (int i = 0; i < n; i++)
        {
            int[] counts = Console.ReadLine().Split().Select(int.Parse).ToArray();
            for (int j = 0; j < m; j++)
            {
                shirtsCount[i, j] = counts[j];
            }
        }

        // Зчитування кількості переможців та їхніх бажань
        int k = int.Parse(Console.ReadLine());
        List<Tuple<int, string>> winners = new List<Tuple<int, string>>();
        for (int i = 0; i < k; i++)
        {
            string[] winnerData = Console.ReadLine().Split();
            int colorIndex = int.Parse(winnerData[0]) - 1;
            string size = winnerData[1];
            winners.Add(new Tuple<int, string>(colorIndex, size));
        }

        // Обробка запитів переможців
        int[,] remainingShirts = new int[n, m];
        int[,] neededShirts = new int[n, m];

        foreach (var winner in winners)
        {
            int colorIndex = winner.Item1;
            string size = winner.Item2;

            // Пошук футболки за умовами алгоритму
            bool shirtFound = false;
            for (int i = Array.IndexOf(sizes, size); i < m; i++)
            {
                if (shirtsCount[colorIndex, i] > 0)
                {
                    shirtsCount[colorIndex, i]--;
                    remainingShirts[colorIndex, i]++;
                    shirtFound = true;
                    break;
                }
            }

            if (!shirtFound)
            {
                for (int i = 0; i < Array.IndexOf(sizes, size); i++)
                {
                    int availableColor = -1;
                    for (int j = 0; j < n; j++)
                    {
                        if (shirtsCount[j, i] > 0)
                        {
                            if (availableColor == -1 || j < availableColor)
                            {
                                availableColor = j;
                            }
                        }
                    }

                    if (availableColor != -1)
                    {
                        shirtsCount[availableColor, i]--;
                        remainingShirts[availableColor, i]++;
                        shirtFound = true;
                        break;
                    }
                }
            }

            if (!shirtFound)
            {
                for (int i = Array.IndexOf(sizes, size) + 1; i < m; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (shirtsCount[j, i] > 0)
                        {
                            shirtsCount[j, i]--;
                            remainingShirts[j, i]++;
                            shirtFound = true;
                            break;
                        }
                    }

                    if (shirtFound)
                        break;
                }
            }

            if (!shirtFound)
            {
                neededShirts[colorIndex, Array.IndexOf(sizes, size)]++;
            }
        }

        // Виведення результатів
        for (int i = 0; i < n; i++)
        {
            Console.WriteLine(string.Join(" ", remainingShirts.Cast<int>().Skip(i * m).Take(m)));
        }

        for (int i = 0; i < n; i++)
        {
            Console.WriteLine(string.Join(" ", neededShirts.Cast<int>().Skip(i * m).Take(m)));
        }
    }
}
