#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

struct Order {
    int color;
    char size;
};

int main() {
    int n, m;
    cin >> n >> m;

    vector<char> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<Order> orders(k);
    for (int i = 0; i < k; ++i) {
        cin >> orders[i].color >> orders[i].size;
    }

    vector<vector<int>> remaining = available;
    priority_queue<pair<int, pair<int, char>>> extra; // (remaining, (color, size))

    // Process orders
    for (const auto& order : orders) {
        int color = order.color - 1;
        char size = order.size;

        if (remaining[color][size - 'XS'] > 0) {
            // Take the requested size and color if available
            remaining[color][size - 'XS']--;
        } else {
            // Find the next available size with priority on color
            bool found = false;
            for (char next_size = size; next_size <= '2'; ++next_size) {
                for (int i = 0; i < n; ++i) {
                    if (remaining[i][next_size - 'XS'] > 0) {
                        remaining[i][next_size - 'XS']--;
                        found = true;
                        extra.push({i, {next_size, sizes[next_size - 'XS']}});
                        break;
                    }
                }
                if (found) break;
            }

            if (!found) {
                // The requested size and color is not available
                extra.push({color, {size, sizes[size - 'XS']}});
            }
        }
    }

    // Output remaining and extra
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << ' ';
        }
        cout << '\n';
    }

    vector<vector<int>> to_order(n, vector<int>(m));

    while (!extra.empty()) {
        auto [color, data] = extra.top();
        extra.pop();
        to_order[color][data.first - 'XS']++;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << ' ';
        }
        cout << '\n';
    }

    return 0;
}

