def solve(n, m, sizes, quantities, winners):
    # Ініціалізація таблиць
    remaining = [[quantities[i][j] for j in range(m)] for i in range(n)]
    ordered = [[0 for j in range(m)] for i in range(n)]

    # Перебір переможців та роздача футболок
    for winner in winners:
        color, size = int(winner[0]) - 1, sizes.index(winner[1])

        # Пошук футболки потрібного розміру та кольору
        if remaining[color][size] > 0:
            remaining[color][size] -= 1
        else:
            found = False

            # Шукаємо футболку іншого кольору того ж розміру
            for i in range(n):
                if remaining[i][size] > 0:
                    remaining[i][size] -= 1
                    ordered[i][size] += 1
                    found = True
                    break

            # Якщо не знайшли, шукаємо футболку більшого розміру
            if not found:
                for j in range(size + 1, m):
                    for i in range(n):
                        if remaining[i][j] > 0:
                            remaining[i][j] -= 1
                            ordered[i][j] += 1
                            found = True
                            break
                    if found:
                        break

    return remaining, ordered

# Зчитуємо вхідні дані
n, m = map(int, input().split())
sizes = input().split()
quantities = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(map(str, input().split())) for _ in range(k)]

# Розв'язуємо задачу
remaining, ordered = solve(n, m, sizes, quantities, winners)

# Виводимо результат
for row in remaining:
    print(*row)

for row in ordered:
    print(*row)
