def get_team_participants(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        result = sorted(participants, key=lambda x: x[4], reverse=True)[:4]
        print(f"IOI/CEOI Participants: {result}")
        return result
    elif olympiad == "EGOI":
        females = [participant for participant in participants if participant[1] == "female"]
        result = sorted(females, key=lambda x: x[4], reverse=True)[:min(4, len(females))]
        print(f"EGOI Participants: {result}")
        return result
    elif olympiad == "EJOI":
        under_16 = [participant for participant in participants if int(participant[3]) <= 15]
        result = sorted(under_16, key=lambda x: x[4], reverse=True)[:min(4, len(under_16))]
        print(f"EJOI Participants: {result}")
        return result
    elif olympiad == "BaltOI":
        result = sorted(participants, key=lambda x: x[4], reverse=True)[:6]
        print(f"BaltOI Participants: {result}")
        return result
    elif olympiad == "BalkOI":
        non_11th_graders = [participant for participant in participants if int(participant[2]) != 11]
        result = sorted(non_11th_graders, key=lambda x: x[4], reverse=True)[:min(4, len(non_11th_graders))]
        print(f"BalkOI Participants: {result}")
        return result
    elif olympiad == "JBOI":
        non_11th_10th_graders = [participant for participant in participants if int(participant[2]) not in [10, 11]]
        result = sorted(non_11th_10th_graders, key=lambda x: x[4], reverse=True)[:min(4, len(non_11th_10th_graders))]
        print(f"JBOI Participants: {result}")
        return result

# Reading input
n = int(input())
participants = [list(map(str, input().split())) for _ in range(n)]
m = int(input())
olympiads = [input() for _ in range(m)]

# Processing and printing output
for olympiad in olympiads:
    team_participants = get_team_participants(olympiad, participants)
    if team_participants:
        team_participants = sorted(team_participants, key=lambda x: x[0])
        print(olympiad)
        for participant in team_participants:
            print(participant[0])
    else:
        print(f"No participants for {olympiad}")
