using System;
using System.Linq;
using System.Collections.Generic;

public class Program
{
    public static void Main()
    {
        var nm = Console.ReadLine().Split().Select(int.Parse).ToArray();
        var n = nm[0];
        var m = nm[1];

        var sizes = Console.ReadLine().Split();
        var sizeIndex = new Dictionary<string, int>();
        for (int i = 0; i < m; i++)
        {
            sizeIndex[sizes[i]] = i;
        }

        var tshirts = new int[n, m];
        for (int i = 0; i < n; i++)
        {
            var counts = Console.ReadLine().Split().Select(int.Parse).ToArray();
            for (int j = 0; j < m; j++)
            {
                tshirts[i, j] = counts[j];
            }
        }

        var k = int.Parse(Console.ReadLine());
        var requests = new (int, string)[k];
        for (int i = 0; i < k; i++)
        {
            var request = Console.ReadLine().Split();
            requests[i] = (int.Parse(request[0]) - 1, request[1]);
        }

        var remaining = (int[,])tshirts.Clone();
        var needed = new int[n, m];

        foreach (var (color, size) in requests)
        {
            var sizeIdx = sizeIndex[size];
            if (remaining[color, sizeIdx] > 0)
            {
                remaining[color, sizeIdx]--;
            }
            else
            {
                needed[color, sizeIdx]++;
                for (int i = sizeIdx + 1; i < m; i++)
                {
                    if (remaining[color, i] > 0)
                    {
                        remaining[color, i]--;
                        break;
                    }
                }
            }
        }

        for (int i = 0; i < n; i++)
        {
            Console.WriteLine(string.Join(" ", Enumerable.Range(0, m).Select(j => remaining[i, j])));
        }

        for (int i = 0; i < n; i++)
        {
            Console.WriteLine(string.Join(" ", Enumerable.Range(0, m).Select(j => needed[i, j])));
        }
    }
}
