def process_requests(n, m, sizes, available, winners):
    remaining = [[0] * m for _ in range(n)]
    needed = [[0] * m for _ in range(n)]

    for i in range(len(available)):
        for j in range(m):
            remaining[i][j] = available[i][j]

    for winner in winners:
        color, size = winner
        size_index = sizes.index(size)

        if available[color - 1][size_index] > 0:
            available[color - 1][size_index] -= 1
        else:
            found_alternative = False

            for i in range(size_index + 1, m):
                if available[color - 1][i] > 0:
                    available[color - 1][i] -= 1
                    found_alternative = True
                    break

            if not found_alternative:
                for i in range(color, n):
                    if available[i][size_index] > 0:
                        available[i][size_index] -= 1
                        found_alternative = True
                        break

                    for j in range(size_index + 1, m):
                        if available[i][j] > 0:
                            available[i][j] -= 1
                            found_alternative = True
                            break

                    if found_alternative:
                        break

            if not found_alternative:
                needed[color - 1][size_index] += 1

    return remaining, needed

# Reading input values
n, m = map(int, input().split())
sizes = input().split()
available = []
for _ in range(n):
    available.append(list(map(int, input().split())))

k = int(input())
winners = []
for _ in range(k):
    c, s = input().split()
    winners.append((int(c), s))

# Processing requests
remaining, needed = process_requests(n, m, sizes, available, winners)

# Output the results
for row in remaining:
    print(*row)

for row in needed:
    print(*row)
