def find_tshirts(n, m, sizes, tshirts, winners):
    tshirts_left = [[0] * m for _ in range(n)]
    tshirts_needed = [[0] * m for _ in range(n)]

    for color, size in winners:
        size_index = sizes.index(size)
        found = False

        for s in range(size_index, m):
            if tshirts[color - 1][s] > 0:
                tshirts[color - 1][s] -= 1
                tshirts_left[color - 1][s] += 1
                found = True
                break

        if not found:
            for s in range(size_index):
                if tshirts[color - 1][s] > 0:
                    tshirts[color - 1][s] -= 1
                    tshirts_left[color - 1][s] += 1
                    found = True
                    break

        if not found:
            for c in range(color, n):
                for s in range(m):
                    if tshirts[c][s] > 0:
                        tshirts[c][s] -= 1
                        tshirts_left[c][s] += 1
                        found = True
                        break
                if found:
                    break

        if not found:
            tshirts_needed[color - 1][size_index] += 1

    return tshirts_left, tshirts_needed

# Input processing
n, m = map(int, input().split())
sizes = input().split()
tshirts = [list(map(int, input().split())) for _ in range(n)]
num_winners = int(input())
winners = [list(map(str, input().split())) for _ in range(num_winners)]

# Finding T-shirts for winners
tshirts_left, tshirts_needed = find_tshirts(n, m, sizes, tshirts, winners)

# Outputting the results
for color in tshirts_left:
    print(*color)

for color in tshirts_needed:
    print(*color)
