from collections import defaultdict

def find_tshirt(color, size, tshirts, size_dict, colors):
    for s in range(size_dict[size], len(tshirts[0])):
        if tshirts[colors[color]][s] > 0:
            tshirts[colors[color]][s] -= 1
            return True
    return False

n, m = map(int, input().split())
sizes = input().split()
size_dict = {size: idx for idx, size in enumerate(sizes)}
tshirts = [list(map(int, input().split())) for _ in range(n)]

k = int(input())
requests = [(int(color), size) for color, size in [input().split() for _ in range(k)]]

colors = {i + 1: i for i in range(n)}
unsatisfied = defaultdict(int)

for req in requests:
    color, size = req
    if size in size_dict and not find_tshirt(color, size, tshirts, size_dict, colors):
        unsatisfied[(color, size)] += 1

for row in tshirts:
    print(' '.join(map(str, row)))

for i in range(n):
    for j in range(len(sizes)):
        print(unsatisfied[(i + 1, j)], end=' ')
    print()
