from collections import defaultdict

def find_tshirts(colors, sizes, tshirts, winners):
    inventory = [[tshirts[i][j] for j in range(len(sizes))] for i in range(len(colors))]
    remaining = [[0 for _ in range(len(sizes))] for _ in range(len(colors))]
    needed = [[0 for _ in range(len(sizes))] for _ in range(len(colors))]

    size_index = {size: i for i, size in enumerate(sizes)}

    for winner in winners:
        color, size = winner
        size_pos = size_index[size]
        color_pos = int(color) - 1  # Convert color to 0-based index

        found = False

        # Check if the requested size and color are available
        if inventory[color_pos][size_pos] > 0:
            inventory[color_pos][size_pos] -= 1
            found = True
        else:
            # Look for a T-shirt with the same size but different color
            for i in range(len(colors)):
                if inventory[i][size_pos] > 0:
                    inventory[i][size_pos] -= 1
                    remaining[i][size_pos] += 1
                    found = True
                    break

            # If not found, try larger sizes
            if not found:
                for i in range(size_pos + 1, len(sizes)):
                    if inventory[color_pos][i] > 0:
                        inventory[color_pos][i] -= 1
                        remaining[color_pos][i] += 1
                        found = True
                        break

        # If not found, mark as needed
        if not found:
            needed[color_pos][size_pos] += 1

    return remaining, needed

# Read input
n, m = map(int, input().split())
sizes = input().split()
tshirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [input().split() for _ in range(k)]

# Calculate remaining and needed T-shirts
remaining, needed = find_tshirts(range(n), sizes, tshirts, winners)

# Print remaining and needed T-shirts
for row in remaining:
    print(*row)

for row in needed:
    print(*row)
