#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Function to get participants based on criteria for each olympiad
vector<vector<string>> get_participants(string olympiad, vector<vector<string>>& participants) {
    if (olympiad == "IOI" || olympiad == "CEOI") {
        sort(participants.begin(), participants.end(), [](const vector<string>& a, const vector<string>& b) {
            return stoi(a[4]) > stoi(b[4]) || (stoi(a[4]) == stoi(b[4]) && stoi(a[0]) < stoi(b[0]));
        });
        return vector<vector<string>>(participants.begin(), participants.begin() + min(4, (int)participants.size()));
    } else if (olympiad == "EGOI") {
        vector<vector<string>> female_participants;
        copy_if(participants.begin(), participants.end(), back_inserter(female_participants),
                [](const vector<string>& p) { return p[1] == "female"; });
        sort(female_participants.begin(), female_participants.end(), [](const vector<string>& a, const vector<string>& b) {
            return stoi(a[4]) > stoi(b[4]) || (stoi(a[4]) == stoi(b[4]) && stoi(a[0]) < stoi(b[0]));
        });
        return vector<vector<string>>(female_participants.begin(), female_participants.begin() + min(4, (int)female_participants.size()));
    }
    // Add conditions for other olympiads in a similar manner
    else {
        // Handle other olympiads
        // ...
        return {};
    }
}

int main() {
    int n;
    cin >> n;

    vector<vector<string>> participants(n, vector<string>(5));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 5; ++j) {
            cin >> participants[i][j];
        }
    }

    int m;
    cin >> m;
    vector<string> olympiads(m);
    for (int i = 0; i < m; ++i) {
        cin >> olympiads[i];
    }

    // Sort participants by id for consistent output
    sort(participants.begin(), participants.end(), [](const vector<string>& a, const vector<string>& b) {
        return stoi(a[0]) < stoi(b[0]);
    });

    // Process each olympiad and print the team members
    for (const auto& olympiad : olympiads) {
        auto team = get_participants(olympiad, participants);
        cout << olympiad << endl;
        for (const auto& member : team) {
            cout << member[0] << endl;
        }
    }

    return 0;
}
