# Function to get participants based on criteria for each olympiad
def get_participants(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        return sorted(female_participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EJOI":
        young_participants = [p for p in participants if p[3] <= 15]
        return sorted(young_participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == "BalkOI":
        non_11th_grade = [p for p in participants if p[2] != 11]
        return sorted(non_11th_grade, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "JBOI":
        non_11th_10th_grade = [p for p in participants if p[2] != 11 and p[2] != 10]
        return sorted(non_11th_10th_grade, key=lambda x: (-x[4], x[0]))[:4]

n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participant_info[0] = int(participant_info[0])  # Converting id to integer
    participant_info[3] = int(participant_info[3])  # Converting age to integer
    participant_info[4] = int(participant_info[4])  # Converting score to integer
    participants.append(participant_info)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Sort participants by id for consistent output
participants.sort(key=lambda x: x[0])

# Process each olympiad and print the team members
for olympiad in olympiads:
    team = get_participants(olympiad, participants)
    print(olympiad)
    for member in team:
        print(member[0])
