def select_participants(olympiad, participants):
    if olympiad in ["IOI", "CEOI"]:
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        return sorted(female_participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EJOI":
        young_participants = [p for p in participants if p[3] <= 15]
        return sorted(young_participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == "BalkOI":
        non_11th_grade = [p for p in participants if p[2] != 11]
        return sorted(non_11th_grade, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "JBOI":
        non_11th_10th_grade = [p for p in participants if p[2] not in [11, 10]]
        return sorted(non_11th_10th_grade, key=lambda x: (-x[4], x[0]))[:4]

# Input processing
num_participants = int(input("Enter the number of participants: "))
participants = []
for _ in range(num_participants):
    participant_info = input("Enter participant details (id, gender, grade, age, score): ").split()
    participant_info[0] = int(participant_info[0])  # Convert id to integer
    participant_info[3] = int(participant_info[3])  # Convert age to integer
    participant_info[4] = int(participant_info[4])  # Convert score to integer
    participants.append(participant_info)

num_olympiads = int(input("Enter the number of olympiads: "))
olympiads = [input("Enter olympiad name: ").strip() for _ in range(num_olympiads)]

# Sort participants by ID for consistent output
participants.sort(key=lambda x: x[0])

# Process each olympiad and print the team members
for olympiad in olympiads:
    selected_participants = select_participants(olympiad, participants)
    print(f"\nParticipants for {olympiad}:")
    for participant in selected_participants:
        print(participant[0])
