#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool isPossible(const vector<long long>& colors, long long length, long long m) {
    long long current = 0;
    int count = 0;

    for (long long color : colors) {
        if (color <= current) {
            ++count;
        } else {
            count = 0;
        }
        if (count >= length) {
            ++m;
            count = 0;
        }
    }
    return m > 0;
}

int main() {
    int n;
    long long m;
    cin >> n >> m;

    vector<long long> colors(n);
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    long long left = 0, right = 1e18;
    long long result = 0;

    while (left <= right) {
        long long mid = left + (right - left) / 2;
        if (isPossible(colors, mid, m)) {
            result = mid;
            left = mid + 1;
        } else {
            right = mid - 1;
        }
    }

    cout << result << endl;

    return 0;
}
