from collections import defaultdict

def create_teams(participants, olympiad, team_size):
    participants.sort(key=lambda x: (-x[4], x[0]))

    teams = defaultdict(list)

    for participant in participants:
        gender, grade, age, score = participant[1], participant[2], participant[3], participant[4]

        if olympiad == 'IOI' or olympiad == 'CEOI':
            teams[olympiad].append(participant[0])
        elif olympiad == 'EGOI' and gender == 'female':
            teams[olympiad].append(participant[0])
        elif olympiad == 'EJOI' and age <= 15:
            teams[olympiad].append(participant[0])
        elif olympiad == 'BaltOI':
            teams[olympiad].append(participant[0])
            if len(teams[olympiad]) == team_size:
                break
        elif olympiad == 'BalkOI' and grade != 11:
            teams[olympiad].append(participant[0])
        elif olympiad == 'JBOI' and grade not in {10, 11}:
            teams[olympiad].append(participant[0])

        if all(len(teams[olympiad]) == team_size for olympiad in teams):
            break

    return teams

n = int(input())
participants = []

for _ in range(n):
    data = input().split()
    data[0] = int(data[0])  # Convert id to integer
    data[3] = int(data[3])  # Convert age to integer
    data[4] = int(data[4])  # Convert score to integer
    participants.append(data)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    teams = create_teams(participants, olympiad, 4)
    print(olympiad)
    for team in teams[olympiad]:
        print(team)