import sys
from operator import itemgetter

def read_participant():
    return list(map(lambda x: int(x) if x.isdigit() else x, sys.stdin.readline().split()))

def create_teams(participants, olympiad, team_size):
    participants.sort(key=itemgetter(4, 0), reverse=True)

    teams = []

    conditions = {
        'IOI': lambda x: True,
        'CEOI': lambda x: True,
        'EGOI': lambda x: x[1] == 'female',
        'EJOI': lambda x: x[3] <= 15,
        'BaltOI': lambda x: True,
        'BalkOI': lambda x: x[2] != 11,
        'JBOI': lambda x: x[2] not in {10, 11},
    }

    for idx, participant in enumerate(participants):
        if conditions[olympiad](participant):
            teams.append(participant[0])

        if len(teams) == team_size:
            break

    return teams

def main():
    n = int(sys.stdin.readline())
    participants = [read_participant() for _ in range(n)]

    m = int(sys.stdin.readline())
    olympiads = [sys.stdin.readline().strip() for _ in range(m)]

    for olympiad in olympiads:
        teams = create_teams(participants, olympiad, 4)
        print(olympiad)
        for team in sorted(teams):
            print(team)

if __name__ == "__main__":
    main()