def create_teams(participants, olympiad, team_size):
    participants.sort(key=lambda x: (-x[4], x[0]))
    conditions = {
        'IOI': lambda x: True,
        'CEOI': lambda x: True,
        'EGOI': lambda x: x[1] == 'female',
        'EJOI': lambda x: x[3] <= 15,
        'BaltOI': lambda x: True,
        'BalkOI': lambda x: x[2] != 11,
        'JBOI': lambda x: x[2] not in {10, 11},
    }
    return sorted([p[0] for p in participants if conditions[olympiad](p)][:team_size])

n = int(input())
participants = [list(map(lambda x: int(x) if x.isdigit() else x, input().split())) for _ in range(n)]

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    teams = create_teams(participants, olympiad, 4)
    print(olympiad)
    print(*teams)
        