def can_use_middle(arr, target):
    count = 0
    for a in arr:
        count += a
        if count >= target:
            return True
    return False

def max_subsequence_length(arr, n, m):
    left, right = 1, n
    result = 0

    while left <= right:
        mid = (left + right) // 2

        if can_use_middle(arr, mid) and mid % 2 == 1:
            result = mid
            left = mid + 1
        else:
            right = mid - 1

    return result

def main():
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    total_colors = sum(colors)
    max_length = max_subsequence_length(colors, total_colors, m)

    print(max_length)

if __name__ == "__main__":
    main()