from collections import defaultdict

n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participants.append({
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    })

m = int(input())
olympiads = [input().strip() for _ in range(m)]

participants.sort(key=lambda x: x['score'], reverse=True)

qualified_participants = defaultdict(list)

for participant in participants:
    if 'IOI' in olympiads:
        qualified_participants['IOI'].append(participant['id'])

    if 'CEOI' in olympiads:
        qualified_participants['CEOI'].append(participant['id'])

    if 'EGOI' in olympiads and participant['gender'] == 'female':
        qualified_participants['EGOI'].append(participant['id'])

    if 'EJOI' in olympiads and participant['age'] <= 15:
        qualified_participants['EJOI'].append(participant['id'])

    if 'BaltOI' in olympiads:
        qualified_participants['BaltOI'].append(participant['id'])

    if 'BalkOI' in olympiads and participant['grade'] != 11:
        qualified_participants['BalkOI'].append(participant['id'])

    if 'JBOI' in olympiads and participant['grade'] not in {10, 11}:
        qualified_participants['JBOI'].append(participant['id'])

for olympiad in olympiads:
    qualified_participants[olympiad].sort()

for olympiad in olympiads:
    print(olympiad)
    for participant_id in qualified_participants[olympiad]:
        print(participant_id)