const readline = require('readline');

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout
});

function processTShirts(colors, sizes, inventory, winners) {

  let remainingInventory = JSON.parse(JSON.stringify(inventory));
  

  let requiredPurchases = Array.from(Array(colors), () => Array(sizes).fill(0));

  for (let i = 0; i < winners.length; i++) {
    const [colorIndex, sizeIndex] = winners[i];
    

    if (remainingInventory[colorIndex][sizeIndex] > 0) {

      remainingInventory[colorIndex][sizeIndex]--;
    } else {

      requiredPurchases[colorIndex][sizeIndex]++;
    }
  }


  for (let i = 0; i < colors; i++) {
    console.log(remainingInventory[i].join(' '));
  }

  for (let i = 0; i < colors; i++) {
    console.log(requiredPurchases[i].join(' '));
  }
}


let colors, sizes;
let sizesArray, inventory;
let winnersCount, winners;

rl.question('', (nm) => {
  [colors, sizes] = nm.split(' ').map(Number);

  rl.question('', (sizesInput) => {
    sizesArray = sizesInput.split(' ');

    rl.question('', () => {
      inventory = [];
      for (let i = 0; i < colors; i++) {
        inventory.push(rl.line.trim().split(' ').map(Number));
      }

      rl.question('', (k) => {
        winnersCount = Number(k);

        winners = [];
        for (let i = 0; i < winnersCount; i++) {
          winners.push(rl.line.trim().split(' '));
        }


        processTShirts(colors, sizes, inventory, winners);

        rl.close();
      });
    });
  });
});

