#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 100;
const int MAX_M = 6;

void processTShirts(int n, int m, vector<string>& sizesArray, vector<vector<int>>& inventory, int winnersCount, vector<pair<int, char>>& winners) {
    // Initialize remaining inventory
    vector<vector<int>> remainingInventory(n + 1, vector<int>(m + 1, 0));

    // Initialize required purchases
    vector<vector<int>> requiredPurchases(n + 1, vector<int>(m + 1, 0));

    // Process winners' requests
    for (int i = 0; i < winnersCount; i++) {
        int colorIndex = winners[i].first;
        int sizeIndex = winners[i].second - 'A' + 1;

        // Check if the requested T-shirt is available
        if (remainingInventory[colorIndex][sizeIndex] > 0) {
            // Decrease the remaining inventory
            remainingInventory[colorIndex][sizeIndex]--;
        } else {
            // If not available, add it to the required purchases
            requiredPurchases[colorIndex][sizeIndex]++;
        }
    }

    // Output remaining inventory
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cout << remainingInventory[i][j] << " ";
        }
        cout << endl;
    }

    // Output required purchases
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cout << requiredPurchases[i][j] << " ";
        }
        cout << endl;
    }
}

int main() {
    // Read input values
    int n, m;
    cin >> n >> m;

    vector<string> sizesArray(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> sizesArray[i];
    }

    vector<vector<int>> inventory(n + 1, vector<int>(m + 1, 0));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> inventory[i][j];
        }
    }

    int winnersCount;
    cin >> winnersCount;

    vector<pair<int, char>> winners(winnersCount);
    for (int i = 0; i < winnersCount; i++) {
        cin >> winners[i].first >> winners[i].second;
    }

    // Process T-shirts
    processTShirts(n, m, sizesArray, inventory, winnersCount, winners);

    return 0;
}
