import heapq

def max_unmarked_sequence_length(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0
    
    heap = [-x for x in a]
    heapq.heapify(heap)
    
    unmarked_sequence_length = lambda x: (-(x // 2) - 1) if x % 2 == 0 else -x // 2
    
    for _ in range(m):
        longest_seq = -heapq.heappop(heap)
        mid = unmarked_sequence_length(longest_seq)
        
        heapq.heappush(heap, -mid)
        unmarked_sequence_length_sum = unmarked_sequence_length(longest_seq) * 2
        if unmarked_sequence_length_sum > 0:
            heapq.heappush(heap, -unmarked_sequence_length_sum)

    return -heapq.heappop(heap)

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence_length(n, m, a)
print(result)


