#include <iostream>

// Структура, що представляє дату
struct Date {
    int day;
    int month;

    // Конструктор для ініціалізації дати
    Date(int d, int m) : day(d), month(m) {}
};

// Функція порівняння двох дат народження
bool areBirthdaysEqual(const Date& date1, const Date& date2) {
    return (date1.day == date2.day) && (date1.month == date2.month);
}

int main() {
    // Зчитуємо дані за Байтуліанським календарем
    int dayByteulian, monthByteulian;
    std::cin >> dayByteulian >> monthByteulian;

    // Зчитуємо дані за Бітуліанським календарем
    int dayBitulian, monthBitulian;
    std::cin >> dayBitulian >> monthBitulian;

    // Створюємо об'єкти для дат народження
    Date birthdayByteulian(dayByteulian, monthByteulian);
    Date birthdayBitulian(dayBitulian, monthBitulian);

    // Викликаємо функцію для порівняння дат народження
    if (areBirthdaysEqual(birthdayByteulian, birthdayBitulian)) {
        std::cout << "Same birthday!" << std::endl;
    } else {
        std::cout << "Not the same" << std::endl;
    }

    return 0;
}

