#include <iostream>
#include <vector>

using namespace std;

// Функція для знаходження речі, яку потрібно перемістити
int find_item_to_move(vector<int>& weights, vector<int>& boxes) {
    // Знаходимо ваги коробок
    vector<int> box_weights(2, 0);
    for (int i = 0; i < 4; ++i) {
        box_weights[boxes[i] - 1] += weights[i];
    }

    // Знаходимо, яку річ перемістити
    for (int i = 0; i < 4; ++i) {
        int other_box = (boxes[i] == 2) ? 1 : 2;
        // Спробуємо перекласти річ у іншу коробку та перевіримо результат
        int new_box_weight = box_weights[other_box - 1] + weights[i];
        int other_box_weight = box_weights[boxes[i] - 1] - weights[i];
        // Якщо максимальна вага коробки стане меншою, ніж раніше, повертаємо номер речі
        if (max(new_box_weight, other_box_weight) < max(box_weights[0], box_weights[1])) {
            return i + 1;
        }
    }

    // Якщо немає оптимального переміщення, повертаємо -1
    return -1;
}

int main() {
    vector<int> weights(4);
    vector<int> boxes(4);

    // Ввідні дані
    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }
    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
    }

    // Знаходимо річ для переміщення
    int result = find_item_to_move(weights, boxes);
    cout << result << endl;

    return 0;
}

