 #include <iostream>
#include <vector>
#include <unordered_map>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::unordered_map<std::string, int> sizeOrder = {{"XS", 0}, {"S", 1}, {"M", 2}, {"L", 3}, {"XL", 4}, {"2XL", 5}};
    std::vector<std::vector<int>> stock(n, std::vector<int>(m, 0));
    std::vector<int> colorCount(m, 0);
    std::vector<int> sizeCount(m, 0);

    for (int i = 0; i < m; ++i) {
        std::string size;
        std::cin >> size;
        sizeCount[sizeOrder[size]] = i;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> stock[i][j];
            colorCount[j] += stock[i][j];
        }
    }

    int k;
    std::cin >> k;

    for (int i = 0; i < k; ++i) {
        int ci;
        std::string si;
        std::cin >> ci >> si;
        int sizeIdx = sizeCount[sizeOrder[si]];

        if (stock[ci - 1][sizeIdx] > 0) {
            stock[ci - 1][sizeIdx]--;
        } else {
            for (int j = sizeIdx + 1; j < m; ++j) {
                if (colorCount[j] > 0) {
                    std::cout << ci << " " << sizeCount[j] + 1 << "\n";
                    colorCount[j]--;
                    break;
                }
            }
        }
    }

    return 0;
}








