#include <iostream>
#include <vector>
#include <map>

struct TShirt {
    int color;
    int size;
    int count;
};

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<std::string> sizes(m);
    std::map<std::string, int> sizeIndex;
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
        sizeIndex[sizes[i]] = i;
    }

    std::vector<std::vector<int>> tshirtsCount(n, std::vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> tshirtsCount[i][j];
        }
    }

    int k;
    std::cin >> k;

    std::vector<TShirt> availableTShirts;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            availableTShirts.push_back({i, j, tshirtsCount[i][j]});
        }
    }

    std::vector<std::vector<int>> remainingTShirts(n, std::vector<int>(m, 0));
    std::vector<std::vector<int>> orderTShirts(n, std::vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int c;
        std::string s;
        std::cin >> c >> s;
        int sizeIdx = sizeIndex[s];

        bool found = false;

        for (auto& shirt : availableTShirts) {
            if (shirt.size == sizeIdx && shirt.color == c - 1 && shirt.count > 0) {
                remainingTShirts[shirt.color][shirt.size]++;
                shirt.count--;
                found = true;
                break;
            }
        }

        if (!found) {
            for (auto& shirt : availableTShirts) {
                if (shirt.size == sizeIdx && shirt.count > 0) {
                    remainingTShirts[shirt.color][shirt.size]++;
                    shirt.count--;
                    break;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << (tshirtsCount[i][j] - remainingTShirts[i][j]) << ' ';
        }
        std::cout << '\n';
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << remainingTShirts[i][j] << ' ';
        }
        std::cout << '\n';
    }

    return 0;
}




