#include <iostream>
#include <vector>
#include <map>

struct Olympiad {
    std::string name;
    std::vector<int> participants;
};

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    std::map<std::string, Olympiad> olympiads;
    for (int i = 0; i < m; ++i) {
        std::string olympiadName;
        std::cin >> olympiadName;
        olympiads[olympiadName].name = olympiadName;
    }

    for (int i = 0; i < n; ++i) {
        for (auto& entry : olympiads) {
            bool eligible = false;

            if (entry.second.name == "IOI" && participants[i].grade >= 7 && participants[i].age <= 18) {
                eligible = true;
            } else if (entry.second.name == "CEOI" && participants[i].grade >= 9 && participants[i].age <= 20) {
                eligible = true;
            } else if (entry.second.name == "EGOI" && participants[i].grade >= 8 && participants[i].age <= 19) {
                eligible = true;
            } // Add conditions for other olympiads

            if (eligible) {
                entry.second.participants.push_back(participants[i].id);
                break;  // Break to the next olympiad after finding eligibility
            }
        }
    }

    for (const auto& entry : olympiads) {
        std::cout << entry.second.name << '\n';
        for (int id : entry.second.participants) {
            std::cout << id << ' ';
        }
        std::cout << '\n';
    }

    return 0;
}

