#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Функція для знаходження максимального незакресленого підвідрізку
pair<long long, int> findMaxSegment(const vector<long long>& segments) {
    long long maxSegmentLength = 0;
    int chosenIndex = -1;

    for (int i = 0; i < segments.size(); ++i) {
        if (i == 0 || (i > 0 && segments[i] - segments[i - 1] > maxSegmentLength)) {
            maxSegmentLength = segments[i] - (i > 0 ? segments[i - 1] : 0);
            chosenIndex = i;
        }
    }

    return {maxSegmentLength, chosenIndex};
}

// Функція для позначення вибраних кольорів як використаних
void markUsedColors(vector<long long>& segments, int index) {
    segments[index] = (segments[index] % 2 == 0)
                          ? (segments[index] + segments[index - 1]) / 2
                          : segments[index];
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> colorSegments(n);
    for (auto& segment : colorSegments) {
        cin >> segment;
    }

    long long maxLength = 0;
    for (int i = 0; i < m; ++i) {
        auto [maxSegmentLength, chosenIndex] = findMaxSegment(colorSegments);

        // Позначаємо вибраний колір як використаний
        markUsedColors(colorSegments, chosenIndex);

        // Оновлюємо максимальну довжину
        maxLength = max(maxLength, maxSegmentLength);
    }

    cout << maxLength << endl;

    return 0;
}
