#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<std::string> sizes(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
    }

    std::vector<std::vector<int>> inventory(n, std::vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> inventory[i][j];
        }
    }

    int k;
    std::cin >> k;

    std::vector<std::pair<std::string, std::string>> orders(k);

    for (int i = 0; i < k; ++i) {
        std::cin >> orders[i].first >> orders[i].second;
    }

    std::vector<std::vector<int>> redundant(n, std::vector<int>(m, 0));
    std::vector<std::vector<int>> missing(n, std::vector<int>(m, 0));

    auto assign_shirt = [&](const std::string& color, const std::string& size) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (inventory[i][j] > 0 && sizes[j] == size && color == "none") {
                    inventory[i][j] -= 1;
                    return true;
                } else if (inventory[i][j] > 0 && sizes[j] == size && color == sizes[j]) {
                    inventory[i][j] -= 1;
                    return true;
                }
            }
        }
        return false;
    };

    for (const auto& order : orders) {
        const auto& color = order.first;
        const auto& size = order.second;

        int size_index = -1;
        for (int j = 0; j < m; ++j) {
            if (sizes[j] == size) {
                size_index = j;
                break;
            }
        }

        if (!assign_shirt(color, size)) {
            for (int i = 0; i < n; ++i) {
                if (inventory[i][size_index] > 0) {
                    inventory[i][size_index] -= 1;
                    redundant[i][size_index] += 1;
                    break;
                }
            }
        }

        for (int j = size_index + 1; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                if (inventory[i][j] > 0) {
                    inventory[i][j] -= 1;
                    redundant[i][j] += 1;
                    break;
                }
            }
        }

        for (int j = 0; j < size_index; ++j) {
            for (int i = 0; i < n; ++i) {
                if (inventory[i][j] > 0) {
                    inventory[i][j] -= 1;
                    redundant[i][j] += 1;
                    break;
                }
            }
        }
    }

    // Виводимо результати
    for (const auto& row : redundant) {
        for (int value : row) {
            std::cout << value << ' ';
        }
        std::cout << '\n';
    }

    for (const auto& row : missing) {
        for (int value : row) {
            std::cout << value << ' ';
        }
        std::cout << '\n';
    }

    return 0;
}
