def max_subarray_length(n, m, a):
    total_colors = sum(a) + m  # Total number of colors Miss M wants to choose

    # If there are no remaining colors to choose, return the sum of all original colors
    if total_colors <= n:
        return sum(a)

    # If there are more colors to choose, find the maximum length of the subarray
    # considering the original colors as well as the additional colors Miss M wants to choose
    max_length = max(a)
    
    # Calculate the remaining number of colors Miss M can choose
    remaining_colors = total_colors - n
    
    # Calculate the maximum possible length of the subarray
    max_length += min(remaining_colors, n - 1)
    
    return max_length


# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_subarray_length(n, m, a)
print(result)
