def find_max_subarray(arr, m):
    n = len(arr)
    prefix_sum = [0] * (n + 1)

    for i in range(n):
        prefix_sum[i + 1] = prefix_sum[i] + arr[i]

    def check(length):
        for i in range(n - length + 1):
            subarray_sum = prefix_sum[i + length] - prefix_sum[i]
            if subarray_sum <= m:
                return True
        return False

    left, right = 0, n
    while left < right:
        mid = (left + right) // 2
        if check(mid):
            left = mid + 1
        else:
            right = mid

    return left - 1

def main():
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    result = find_max_subarray(colors, m)
    print(result)

if __name__ == "__main__":
    main()