def get_multi_input():
    return [i for i in input().split(' ')]

def get_template(amount, genders=["male", "female"], befage=20, nogrades=[]):
    return [i for i in reversed(sorted(participants, key=lambda x: x.score)) if i.gender in genders and i.age < befage and i.grade not in nogrades][:amount]

def get_IOI(participants):
    return get_template(4)

def get_CEOI(participants):
    return get_template(4)

def get_EGOI(participants):
    return get_template(4, genders=["female"])

def get_EJOI(participants):
    return get_template(4, befage=15)

def get_BaltOI(participants):
    return get_template(6)

def get_BalkOI(participants):
    return get_template(4, nogrades=[11])

def get_JBOI(participants):
    return get_template(4, nogrades=[10, 11])

class Participant:
    def __init__(self, id, gender, grade, age, score):
        if not id in range(10**6, 10**7+1):
            raise Exception()
        if not gender in ("male", "female"):
            raise Exception()
        if not grade in range(1, 12):
            raise Exception()
        if not age in range(10, 21):
            raise Exception()
        if not age in range(0, 10**8+1):
            raise Exception()
        self.id = id
        self.gender = gender
        self.grade = grade
        self.age = age
        self.score = score

amount = int(input())
participants = []
for i in range(amount):
    inp = get_multi_input()
    p = Participant(int(inp[0]), inp[1], int(inp[2]), int(inp[3]), int(inp[4]))
    participants.append(p)

amount = int(input())
olympics = {input().replace("\r", "").replace("\n", ""): [] for i in range(amount)}
pos = {"IOI": get_IOI, "CEOI": get_CEOI, "EGOI": get_EGOI, "EJOI": get_EJOI,
       "BaltOI": get_BaltOI, "BalkOI": get_BalkOI, "JBOI": get_JBOI}

for ol in olympics.keys():
    if ol in pos:
        olympics[ol] = sorted(pos[ol](participants), key=lambda x: x.id)
        print(ol)
        for p in olympics[ol]:
            print(p.id)
    else:
        print(f"No '{ol}' in possibles")
    #print()
