#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> tshirts(n, vector<int>(m));
    vector<vector<int>> requested(n, vector<int>(m));

    // Read the remaining T-shirts after distribution
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> tshirts[i][j];
        }
    }

    // Read the participants' requested T-shirts
    int totalRequested = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> requested[i][j];
            totalRequested += requested[i][j];
        }
    }

    // Calculate which T-shirts were extra and which ones need to be ordered
    vector<vector<int>> extra(n, vector<int>(m, 0));
    vector<vector<int>> toOrder(n, vector<int>(m, 0));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (tshirts[i][j] >= requested[i][j]) {
                extra[i][j] = tshirts[i][j] - requested[i][j];
            } else {
                int remainingRequested = requested[i][j] - tshirts[i][j];
                int remainingSize = m - j;
                int remainingColor = n - i;

                for (int k = 0; k < remainingSize; ++k) {
                    if (j + k < m) {
                        if (tshirts[i][j + k] >= remainingRequested) {
                            extra[i][j + k] = tshirts[i][j + k] - remainingRequested;
                            remainingRequested = 0;
                            break;
                        } else {
                            remainingRequested -= tshirts[i][j + k];
                            extra[i][j + k] = 0;
                        }
                    }
                }

                if (remainingRequested > 0) {
                    for (int k = 0; k < remainingSize; ++k) {
                        if (j + k < m) {
                            toOrder[i][j + k] += remainingRequested;
                        }
                    }
                }
            }
        }
    }

    // Output the result
    cout << "Extra T-shirts:\n";
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << extra[i][j] << " ";
        }
        cout << "\n";
    }

    cout << "T-shirts to order:\n";
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << toOrder[i][j] << " ";
        }
        cout << "\n";
    }

    return 0;
}
