#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> availableTshirts(n, vector<int>(m, 0));  // Matrix for available T-shirts
    vector<vector<int>> requestedTshirts(n, vector<int>(m, 0));  // Matrix for requested T-shirts

    // Input available T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> availableTshirts[i][j];
        }
    }

    // Input requested T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> requestedTshirts[i][j];
        }
    }

    // Process T-shirts
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            if (requestedTshirts[i][j] > availableTshirts[i][j]) {
                // T-shirt not available, find an alternative
                bool found = false;

                // Search for the same size but different color
                for (int k = 0; k < n; ++k) {
                    if (k != i && requestedTshirts[k][j] < availableTshirts[k][j]) {
                        swap(availableTshirts[i][j], availableTshirts[k][j]);
                        found = true;
                        break;
                    }
                }

                // If not found, search for larger size with priority color
                if (!found) {
                    for (int k = i + 1; k < n; ++k) {
                        if (requestedTshirts[i][j] == availableTshirts[k][j]) {
                            swap(availableTshirts[i][j], availableTshirts[k][j]);
                            found = true;
                            break;
                        }
                    }
                }

                // If still not found, search for larger size
                if (!found) {
                    for (int k = i + 1; k < n; ++k) {
                        if (requestedTshirts[i][j] != availableTshirts[k][j]) {
                            swap(availableTshirts[i][j], availableTshirts[k][j]);
                            found = true;
                            break;
                        }
                    }
                }

                // If still not found, mark as missing
                if (!found) {
                    requestedTshirts[i][j] = 0;
                }
            }
        }
    }

    // Output extra T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << availableTshirts[i][j] << " ";
        }
        cout << endl;
    }

    // Output T-shirts to be ordered
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << requestedTshirts[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
