#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id, grade, age, score;
    string gender;
};

bool compareById(const Participant &a, const Participant &b) {
    return a.id < b.id;
}

bool compareByScore(const Participant &a, const Participant &b) {
    return a.score > b.score;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Participant> participants(n);

    // Read participant information
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareByScore);

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        vector<Participant> team;

        if (olympiad == "IOI") {
            for (const auto &participant : participants) {
                if (team.size() == 4) break;
                team.push_back(participant);
            }
        } else if (olympiad == "CEOI") {
            for (const auto &participant : participants) {
                if (team.size() == 4) break;
                team.push_back(participant);
            }
        } else if (olympiad == "EGOI") {
            int girlsCount = 0;
            for (const auto &participant : participants) {
                if (participant.gender == "female" && girlsCount < 4) {
                    team.push_back(participant);
                    girlsCount++;
                }
                if (team.size() == 4) break;
            }
        } else if (olympiad == "EJOI") {
            for (const auto &participant : participants) {
                if (participant.age <= 15 && team.size() < 4) {
                    team.push_back(participant);
                }
                if (team.size() == 4) break;
            }
        } else if (olympiad == "BaltOI") {
            for (const auto &participant : participants) {
                if (team.size() == 6) break;
                team.push_back(participant);
            }
        } else if (olympiad == "BalkOI") {
            for (const auto &participant : participants) {
                if (participant.grade != 11 && team.size() < 4) {
                    team.push_back(participant);
                }
                if (team.size() == 4) break;
            }
        } else if (olympiad == "JBOI") {
            for (const auto &participant : participants) {
                if (participant.grade != 11 && participant.grade != 10 && team.size() < 4) {
                    team.push_back(participant);
                }
                if (team.size() == 4) break;
            }
        }

        sort(team.begin(), team.end(), compareById);

        // Output the team composition
        cout << olympiad << " ";
        for (const auto &participant : team) {
            cout << participant.id << " ";
        }
        cout << "\n";
    }

    return 0;
}
