#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> colorCircles(n);

    // Read colors from each color circle
    for (int i = 0; i < n; ++i) {
        int colorCount;
        cin >> colorCount;

        colorCircles[i].resize(colorCount);

        for (int j = 0; j < colorCount; ++j) {
            cin >> colorCircles[i][j];
        }
    }

    // Function to find the longest subsegment of uncrossed colors
    auto findLongestSubsegment = [&](vector<int>& colors) {
        int maxLength = 0;
        int currentLength = 0;

        for (int color : colors) {
            if (color == -1) {
                currentLength = 0;
            } else {
                ++currentLength;
                maxLength = max(maxLength, currentLength);
            }
        }

        return maxLength;
    };

    int maxUncutLength = 0;

    // Choose m more colors
    for (int i = 0; i < m; ++i) {
        int maxSubsegmentLength = 0;
        int selectedColor = -1;

        // Find the longest subsegment among all color circles
        for (int j = 0; j < n; ++j) {
            int subsegmentLength = findLongestSubsegment(colorCircles[j]);

            if (subsegmentLength > maxSubsegmentLength) {
                maxSubsegmentLength = subsegmentLength;
                selectedColor = colorCircles[j][subsegmentLength / 2];
            }
        }

        // Cross out the selected color
        for (int j = 0; j < n; ++j) {
            auto it = find(colorCircles[j].begin(), colorCircles[j].end(), selectedColor);
            if (it != colorCircles[j].end()) {
                *it = -1;
            }
        }

        maxUncutLength = max(maxUncutLength, maxSubsegmentLength);
    }

    cout << maxUncutLength << endl;

    return 0;
}
