using System;
using System.Collections.Generic;
using System.Linq;

class Solution {
    public static void Main(string[] args) {
        List<Participant> participants = new List<Participant>();

        int count = int.Parse(Console.ReadLine());

        for(int i = 0; i < count; i++) {
            string[] input = Console.ReadLine().Split(' ');

            participants.Add(new Participant() {
                id = int.Parse(input[0]),
                isMale = input[1] == "male",
                grade = int.Parse(input[2]),
                age = int.Parse(input[3]),
                score = int.Parse(input[4])
            });
        }

        List<string> olympiads = new List<string>();

        count = int.Parse(Console.ReadLine());

        for(int i = 0; i < count; i++) {
            olympiads.Add(Console.ReadLine());
        }

        var sortedParticipants = participants.OrderByDescending(e => e.score);

        foreach(string olympiad in olympiads) {
            Console.WriteLine(olympiad);

            if(olympiad == "IOI" || olympiad == "CEOI") {
                PrintParticipants(sortedParticipants.Take(4));
            }
            else if(olympiad == "EGOI") {
                PrintParticipants(sortedParticipants.Where(e => !e.isMale).Take(4));
            }
            else if(olympiad == "EJOI") {
                PrintParticipants(sortedParticipants.Where(e => e.age <= 15).Take(4));
            }
            else if(olympiad == "BaltOI") {
                PrintParticipants(sortedParticipants.Take(6));
            }
            else if(olympiad == "BalkOI") {
                PrintParticipants(sortedParticipants.Where(e => e.grade < 11).Take(4));
            }
            else if(olympiad == "JBOI") {
                PrintParticipants(sortedParticipants.Where(e => e.grade < 10).Take(4));
            }
            
            Console.WriteLine("\n");
        }
    }

    public static void PrintParticipants(IEnumerable<Participant> participants) {
        IEnumerable<int> sorted = participants.Select(e => e.id).OrderBy(e => e);

        foreach(int s in sorted) {
            Console.WriteLine(s);
        }
    }
}

public class Participant {
    public int id;
    public bool isMale;
    public int grade;
    public int age;
    public int score;
}
