 import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        // Read input data
        Scanner scanner = new Scanner(System.in);
        int[] weights = new int[4];
        int[] boxes = new int[4];

        for (int i = 0; i < 4; i++) {
            weights[i] = scanner.nextInt();
        }

        for (int i = 0; i < 4; i++) {
            boxes[i] = scanner.nextInt();
        }

        // Find the item to move
        int itemToMove = findItemToMove(boxes);

        // Output the result
        System.out.println(itemToMove != -1 ? itemToMove : -1);
    }

    // Find the item to move
    private static int findItemToMove(int[] boxes) {
        int[] boxWeights = new int[3];

        for (int i = 0, j = 0; i < 4; i++) {
            int box = boxes[i];
            int weight = scanner.nextInt();

            if (box == 1) {
                boxWeights[j++] = weight;
            }
        }

        int minWeightBox = findMinWeightBox(boxWeights);

        for (int i = 0; i < 4; i++) {
            if (boxes[i] != minWeightBox) {
                return i + 1;
            }
        }

        return -1;
    }

    // Find the box with the minimum total weight
    private static int findMinWeightBox(int[] boxWeights) {
        int minWeightBox = 1;
        int minTotalWeight = calculateTotalWeight(boxWeights);

        for (int i = 2; i <= 3; i++) {
            int totalWeight = calculateTotalWeight(boxWeights);

            if (totalWeight < minTotalWeight) {
                minWeightBox = i;
                minTotalWeight = totalWeight;
            }
        }

        return minWeightBox;
    }

    // Calculate the total weight of a box
    private static int calculateTotalWeight(int[] boxWeights) {
        int totalWeight = 0;

        for (int weight : boxWeights) {
            totalWeight += weight;
        }

        return totalWeight;
    }
}
