 #include <iostream>
#include <vector>
#include <algorithm>

int main() {
    // Зчитуємо вхідні дані
    int n, m;
    std::cin >> n >> m;

    // Зчитуємо розміри футболок
    std::vector<std::string> sizes(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
    }

    // Читаємо кількість футболок кожного кольору та розміру
    std::vector<std::vector<int>> available(n, std::vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> available[i][j];
        }
    }

    // Зчитуємо кількість переможців
    int k;
    std::cin >> k;

    // Підготовка до обробки запитів переможців
    std::vector<std::vector<int>> remaining(n, std::vector<int>(m, 0));
    std::vector<std::vector<int>> to_order(n, std::vector<int>(m, 0));

    // Обробка запитів переможців
    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        std::cin >> c >> s;

        // Знаходимо індекс розміру футболки в sizes
        int size_index = std::find(sizes.begin(), sizes.end(), std::string(1, s)) - sizes.begin();

        // Перевіряємо наявність футболок
        bool found = false;
        for (int j = size_index; j < m; ++j) {
            if (available[c - 1][j] > 0) {
                available[c - 1][j]--;
                found = true;
                break;
            }
        }

        // Якщо не знайшли потрібного розміру, шукаємо інший розмір
        if (!found) {
            for (int j = 0; j < size_index; ++j) {
                if (available[c - 1][j] > 0) {
                    available[c - 1][j]--;
                    remaining[c - 1][j]++;
                    found = true;
                    break;
                }
            }
        }

        // Якщо і тут не знайшли, докуповуємо футболку більшого розміру
        int larger_size_index = std::find(sizes.begin(), sizes.end(), sizes[size_index] + "L") - sizes.begin();
        for (int j = larger_size_index; j < m; ++j) {
            if (available[c - 1][j] > 0) {
                available[c - 1][j]--;
                to_order[c - 1][j]++;
                found = true;
                break;
            }
        }

        // Якщо і це не допомогло, докуповуємо футболку ще більшого розміру
        int largest_size_index = std::find(sizes.begin(), sizes.end(), sizes[larger_size_index] + "L") - sizes.begin();
        for (int j = largest_size_index; j < m; ++j) {
            if (available[c - 1][j] > 0) {
                available[c - 1][j]--;
                to_order[c - 1][j]++;
                found = true;
                break;
            }
        }

        // Якщо так і не знайшли, фіксуємо відсутність футболки
        if (!found) {
            remaining[c - 1][size_index]++;
        }
    }

    // Виводимо результат
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << remaining[i][j] << " ";
        }
        std::cout << std::endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << to_order[i][j] << " ";
        }
        std::cout << std::endl;
    }

    return 0;
}