 import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Зчитуємо вхідні дані
        int n = scanner.nextInt();
        int m = scanner.nextInt();

        // Зчитуємо розміри футболок
        String[] sizes = new String[m];
        for (int i = 0; i < m; i++) {
            sizes[i] = scanner.next();
        }

        // Читаємо кількість футболок кожного кольору та розміру
        int[][] available = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                available[i][j] = scanner.nextInt();
            }
        }

        // Зчитуємо кількість переможців
        int k = scanner.nextInt();

        // Підготовка до обробки запитів переможців
        int[][] remaining = new int[n][m];
        int[][] toOrder = new int[n][m];

        // Обробка запитів переможців
        for (int i = 0; i < k; i++) {
            int c = scanner.nextInt();
            char s = scanner.next().charAt(0);

            // Знаходимо індекс розміру футболки в sizes
            int sizeIndex = 0;
            for (int j = 0; j < m; j++) {
                if (sizes[j].charAt(0) == s) {
                    sizeIndex = j;
                    break;
                }
            }

            // Перевіряємо наявність футболок
            boolean found = false;
            for (int j = sizeIndex; j < m; j++) {
                if (available[c - 1][j] > 0) {
                    available[c - 1][j]--;
                    found = true;
                    break;
                }
            }

            // Якщо не знайшли потрібного розміру, шукаємо інший розмір
            if (!found) {
                for (int j = 0; j < sizeIndex; j++) {
                    if (available[c - 1][j] > 0) {
                        available[c - 1][j]--;
                        remaining[c - 1][j]++;
                        found = true;
                        break;
                    }
                }
            }

            // Якщо і тут не знайшли, докуповуємо футболку більшого розміру
            int largerSizeIndex = 0;
            for (int j = sizeIndex + 1; j < m; j++) {
                if (available[c - 1][j] > 0) {
                    available[c - 1][j]--;
                    toOrder[c - 1][j]++;
                    found = true;
                    break;
                }
            }

            // Якщо і це не допомогло, докуповуємо футболку ще більшого розміру
            if (!found) {
                for (int j = 0; j < sizeIndex; j++) {
                    if (available[c - 1][j] > 0) {
                        available[c - 1][j]--;
                        toOrder[c - 1][j]++;
                        break;
                    }
                }
            }

            // Якщо так і не знайшли, фіксуємо відсутність футболки
            if (!found) {
                remaining[c - 1][sizeIndex]++;
            }
        }

        // Виводимо результат
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(remaining[i][j] + " ");
            }
            System.out.println();
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(toOrder[i][j] + " ");
            }
            System.out.println();
        }
    }
}
