import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        long m = scanner.nextLong();
        long[] colors = new long[n];

        for (int i = 0; i < n; i++) {
            colors[i] = scanner.nextLong();
        }

        
        long result = maxSubsegmentLength(n, m, colors);
        System.out.println(result);

    }

    private static long maxSubsegmentLength(int n, long m, long[] colors) {
        long totalColors = Arrays.stream(colors).sum();
        long maxLength = Math.min(totalColors, m);

        long remainingColors = m - maxLength;

        Arrays.sort(colors);
        for (int i = 0; i < n - 1; i++) {
            remainingColors += Math.min(colors[i], colors[i + 1]) / 2;
        }

        return maxLength + Math.min(remainingColors, totalColors);
    }
}