from collections import defaultdict

def get_participants(olympiads, participants):
    olympiad_participants = defaultdict(list)

    for participant in participants:
        id, gender, grade, age, score = participant.split()
        if int(score) >= 0:  # Ensure the score is a non-negative integer
            olympiad_participants['IOI'].append((id, int(score)))
            if gender == 'female':
                olympiad_participants['EGOI'].append((id, int(score)))
            if int(grade) < 11:
                olympiad_participants['BalkOI'].append((id, int(score)))
            if int(grade) < 10 or int(grade) == 11 and int(age) <= 15:
                olympiad_participants['EJOI'].append((id, int(score)))
            if int(grade) < 10 or int(grade) == 11 and int(age) not in [10, 11]:
                olympiad_participants['JBOI'].append((id, int(score)))
            if int(score) >= 0:  # Ensure the score is a non-negative integer
                olympiad_participants['CEOI'].append((id, int(score)))
            if int(score) >= 0:  # Ensure the score is a non-negative integer
                olympiad_participants['BaltOI'].append((id, int(score)))

    results = {}
    for olympiad in olympiads:
        participants = sorted(olympiad_participants[olympiad], key=lambda x: (-x[1], int(x[0])))
        results[olympiad] = [participant[0] for participant in participants[:min(len(participants), 6 if olympiad == 'BaltOI' else 4)]]

    return results

def main():
    n = int(input())
    participants = [input() for _ in range(n)]
    m = int(input())
    olympiads = [input() for _ in range(m)]

    teams = get_participants(olympiads, participants)

    for olympiad in olympiads:
        print(olympiad)
        for participant_id in teams[olympiad]:
            print(participant_id)

if __name__ == "__main__":
    main()
