def read_input():
    n = int(input())
    participants = []
    for _ in range(n):
        id, gender, grade, age, score = input().split()
        participants.append((int(id), gender, int(grade), int(age), int(score)))
    m = int(input())
    olympiads = []
    for _ in range(m):
        olympiads.append(input())
    return participants, olympiads

def determine_team(participants, olympiad):
    if olympiad == "IOI":
        return sorted(participants, key=lambda p: p[4], reverse=True)[:4]
    elif olympiad == "CEOI":
        return sorted(participants, key=lambda p: p[4], reverse=True)[:4]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        if len(female_participants) < 4:
            return None
        else:
            return sorted(female_participants, key=lambda p: p[4], reverse=True)[:4]
    elif olympiad == "EJOI":
        young_participants = [p for p in participants if p[2] <= 15]
        if len(young_participants) < 4:
            return None
        else:
            return sorted(young_participants, key=lambda p: p[4], reverse=True)[:4]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda p: p[4], reverse=True)[:6]
    elif olympiad == "BalkOI":
        not_11th_grade_participants = [p for p in participants if p[2] != 11]
        if len(not_11th_grade_participants) < 4:
            return None
        else:
            return sorted(not_11th_grade_participants, key=lambda p: p[4], reverse=True)[:4]
    elif olympiad == "JBOI":
        not_11th_or_10th_grade_participants = [p for p in participants if p[2] not in [11, 10]]
        if len(not_11th_or_10th_grade_participants) < 4:
            return None
        else:
            return sorted(not_11th_or_10th_grade_participants, key=lambda p: p[4], reverse=True)[:4]

if __name__ == "__main__":
    participants, olympiads = read_input()
    teams = [determine_team(participants, olympiad) for olympiad in olympiads]

    # Check for any 'None' values in the teams list
    if any(team is None for team in teams):
        print("Not enough participants for all olympiads")
    else:
        print_output(olympiads, teams)
