#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int maxUnmarkedLength(int n, long long m, vector<long long>& wheels) {
    long long maxLength = *max_element(wheels.begin(), wheels.end());

    if (m >= n) {
        return maxLength;
    }

    sort(wheels.begin(), wheels.end());

    long long left = 1;
    long long right = maxLength;
    while (left < right) {
        long long mid = (left + right + 1) / 2;
        long long count = 0;

        for (long long wheel : wheels) {
            count += wheel / mid;
        }

        if (count >= m) {
            left = mid;
        } else {
            right = mid - 1;
        }
    }

    return left;
}

int main() {
    int n;
    long long m;
    cin >> n >> m;

    vector<long long> wheels(n);
    for (int i = 0; i < n; ++i) {
        cin >> wheels[i];
    }

    int result = maxUnmarkedLength(n, m, wheels);
    cout << result << endl;

    return 0;
}
