from collections import defaultdict

def select_team(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "EGOI":
        females = [p for p in participants if p[1] == "female"]
        return sorted(females, key=lambda x: x[4], reverse=True)[:min(4, len(females))]
    elif olympiad == "EJOI":
        juniors = [p for p in participants if p[3] <= 15]
        return sorted(juniors, key=lambda x: x[4], reverse=True)[:min(4, len(juniors))]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: x[4], reverse=True)[:6]
    elif olympiad == "BalkOI":
        non_11_graders = [p for p in participants if p[2] != 11]
        return sorted(non_11_graders, key=lambda x: x[4], reverse=True)[:min(4, len(non_11_graders))]
    elif olympiad == "JBOI":
        non_11_10_graders = [p for p in participants if p[2] not in {10, 11}]
        return sorted(non_11_10_graders, key=lambda x: x[4], reverse=True)[:min(4, len(non_11_10_graders))]
    else:
        return []

def main():
    n = int(input())
    participants = [list(map(str, input().split())) for _ in range(n)]
    m = int(input())

    participants_dict = defaultdict(list)
    for participant in participants:
        participants_dict[participant[0]].extend(participant[1:])

    for _ in range(m):
        olympiad = input()
        team = select_team(olympiad, participants)
        team_ids = sorted([participant[0] for participant in team])
        print(olympiad)
        print(*team_ids, sep="\n")

if __name__ == "__main__":
    main()
