class Person:

    def __init__(self, pid, gender, grade, age, score):
        self.pid = int(pid)
        self.gender = gender
        self.grade = int(grade)
        self.age = int(age)
        self.score = int(score)


def get_inputs() -> dict:
    """Get input data, return dict"""
    participant_count = int(input())
    participants = []
    for _ in range(participant_count):
        participant = Person(*input().split())
        participants.append(participant)

    olympiad_count = int(input())
    olympiads = []
    for _ in range(olympiad_count):
        olympiads.append(input())

    data = {"participants": participants, "olympiads": olympiads}
    return data


data = get_inputs()
for olympiad in data["olympiads"]:
    if "IOI" in olympiad:
        winners = sorted(data["participants"][::], key=lambda x: x.score, reverse=True)
        print("IOI")
        if len(winners) < 5:
            print("\n".join(list(map(str, sorted([x.pid for x in winners])))))
        else:
            print("\n".join(list(map(str, sorted([x.pid for x in winners[:4]])))))
    if "CEOI" in olympiad:
        winners = sorted(data["participants"][::], key=lambda x: x.score, reverse=True)
        print("CEOI")
        if len(winners) < 5:
            print("\n".join(list(map(str, sorted([x.pid for x in winners])))))
        else:
            print("\n".join(list(map(str, sorted([x.pid for x in winners[:4]])))))
    if "EGOI" in olympiad:
        participants = [x for x in data["participants"] if x.gender == "female"]
        winners = sorted(participants, key=lambda x: x.score, reverse=True)
        print("EGOI")
        if len(winners) < 5:
            print("\n".join(list(map(str, sorted([x.pid for x in winners])))))
        else:
            print("\n".join(list(map(str, sorted([x.pid for x in winners[:4]])))))
    if "EJOI" in olympiad:
        participants = [x for x in data["participants"] if x.age < 16]
        winners = sorted(participants, key=lambda x: x.score, reverse=True)
        print("EJOI")
        if len(winners) < 5:
            print("\n".join(list(map(str, sorted([x.pid for x in winners])))))
        else:
            print("\n".join(list(map(str, sorted([x.pid for x in winners[:4]])))))
    if "BaltOI" in olympiad:
        winners = sorted(data["participants"][::], key=lambda x: x.score, reverse=True)
        print("BaltOI")
        if len(winners) < 7:
            print("\n".join(list(map(str, sorted([x.pid for x in winners])))))
        else:
            print("\n".join(list(map(str, sorted([x.pid for x in winners[:6]])))))
    if "BalkOI" in olympiad:
        participants = [x for x in data["participants"] if x.grade != 11]
        winners = sorted(participants, key=lambda x: x.score, reverse=True)
        print("BalkOI")
        if len(winners) < 5:
            print("\n".join(list(map(str, sorted([x.pid for x in winners])))))
        else:
            print("\n".join(list(map(str, sorted([x.pid for x in winners[:4]])))))
    if "JBOI" in olympiad:
        participants = [x for x in data["participants"] if x.grade not in [10, 11]]
        winners = sorted(participants, key=lambda x: x.score, reverse=True)
        print("JBOI")
        if len(winners) < 5:
            print("\n".join(list(map(str, sorted([x.pid for x in winners])))))
        else:
            print("\n".join(list(map(str, sorted([x.pid for x in winners[:4]])))))