#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> to_order(n, vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        cin >> c >> s;

        // Convert size character to index
        int size_index = find(sizes.begin(), sizes.end(), string(1, s)) - sizes.begin();

        // Check if the requested size is available
        if (available[c - 1][size_index] > 0) {
            available[c - 1][size_index]--;
        } else {
            // Try to find the same size with a different color
            int color_index = 0;
            while (color_index < n && available[color_index][size_index] == 0) {
                color_index++;
            }

            if (color_index < n) {
                available[color_index][size_index]--;
                remaining[color_index][size_index]++;
            } else {
                // Try to find a larger size
                int larger_size_index = size_index + 1;
                while (larger_size_index < m && available[c - 1][larger_size_index] == 0) {
                    larger_size_index++;
                }

                if (larger_size_index < m) {
                    available[c - 1][larger_size_index]--;
                    remaining[c - 1][larger_size_index]++;
                } else {
                    // If no suitable option is found, mark the requested size as to be ordered
                    to_order[c - 1][size_index]++;
                }
            }
        }
    }

    // Output remaining and to_order matrices
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
