#include <iostream>
#include <vector>
#include <algorithm>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& a, const Participant& b) {
    return a.score > b.score || (a.score == b.score && a.id < b.id);
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender
                 >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    std::sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    std::cin >> m;

    for (int i = 0; i < m; ++i) {
        std::string olympiad;
        std::cin >> olympiad;

        std::vector<Participant> team;

        if (olympiad == "IOI") {
            for (const auto& participant : participants) {
                if (team.size() == 4) {
                    break;
                }
                team.push_back(participant);
            }
        } else if (olympiad == "CEOI") {
            for (const auto& participant : participants) {
                if (team.size() == 4) {
                    break;
                }
                team.push_back(participant);
            }
        } else if (olympiad == "EGOI") {
            for (const auto& participant : participants) {
                if (team.size() == 4 && participant.gender == "female") {
                    break;
                }
                if (participant.gender == "female") {
                    team.push_back(participant);
                }
            }
        } else if (olympiad == "EJOI") {
            for (const auto& participant : participants) {
                if (team.size() == 4 && participant.age <= 15) {
                    break;
                }
                if (participant.age <= 15) {
                    team.push_back(participant);
                }
            }
        } else if (olympiad == "BaltOI") {
            for (const auto& participant : participants) {
                if (team.size() == 6) {
                    break;
                }
                team.push_back(participant);
            }
        } else if (olympiad == "BalkOI") {
            for (const auto& participant : participants) {
                if (team.size() == 4 && participant.grade != 11) {
                    break;
                }
                if (participant.grade != 11) {
                    team.push_back(participant);
                }
            }
        } else if (olympiad == "JBOI") {
            for (const auto& participant : participants) {
                if (team.size() == 4 && participant.grade != 11 && participant.grade != 10) {
                    break;
                }
                if (participant.grade != 11 && participant.grade != 10) {
                    team.push_back(participant);
                }
            }
        }

        std::cout << olympiad << std::endl;
        for (const auto& participant : team) {
            std::cout << participant.id << std::endl;
        }
    }

    return 0;
}
