#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;

    Participant(int i, string g, int gr, int a, int s)
        : id(i), gender(g), grade(gr), age(a), score(s) {}
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.score > p2.score || (p1.score == p2.score && p1.id < p2.id);
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants;
    for (int i = 0; i < n; ++i) {
        int id, grade, age, score;
        string gender;
        cin >> id >> gender >> grade >> age >> score;
        participants.emplace_back(id, gender, grade, age, score);
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    map<string, set<int>> olympiadTeams;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        int teamSize;
        if (olympiad == "IOI" || olympiad == "CEOI") {
            teamSize = 4;
        } else if (olympiad == "EGOI") {
            teamSize = 4;
        } else if (olympiad == "EJOI") {
            teamSize = min(4, n);
        } else if (olympiad == "BaltOI") {
            teamSize = min(6, n);
        } else if (olympiad == "BalkOI") {
            teamSize = min(4, n);
        } else if (olympiad == "JBOI") {
            teamSize = min(4, n);
        }

        set<int> team;
        for (const auto& participant : participants) {
            if (olympiad == "EGOI" && participant.gender == "male") {
                continue;
            }
            if (olympiad == "EJOI" && participant.age > 15) {
                continue;
            }
            if (olympiad == "BalkOI" && participant.grade == 11) {
                continue;
            }
            if (olympiad == "JBOI" && (participant.grade == 11 || participant.grade == 10)) {
                continue;
            }

            team.insert(participant.id);
            if (team.size() == teamSize) {
                break;
            }
        }

        olympiadTeams[olympiad] = team;
    }

    for (const auto& entry : olympiadTeams) {
        cout << entry.first << endl;
        for (int id : entry.second) {
            cout << id << endl;
        }
    }

    return 0;
}