def define_teams(n, participants, olympiads):
    teams = {}

    for olympiad in olympiads:
        olympiad = olympiad.strip()  # Видаляємо символи перенесення рядка
        if olympiad == 'IOI':
            ioi_participants = sorted(participants, key=lambda x: (-x[4], x[0]))
            teams['IOI'] = [str(id) for id, gender, grade, age, score in ioi_participants[:min(4, len(ioi_participants))]]
        elif olympiad == 'CEOI':
            ceoi_participants = sorted(participants, key=lambda x: (-x[4], x[0]))
            teams['CEOI'] = [str(id) for id, gender, grade, age, score in ceoi_participants[:min(4, len(ceoi_participants))]]
        elif olympiad == 'EGOI':
            egoi_participants = sorted([x for x in participants if x[1] == 'female'], key=lambda x: (-x[4], x[0]))
            teams['EGOI'] = [str(id) for id, gender, grade, age, score in egoi_participants[:min(4, len(egoi_participants))]]
        elif olympiad == 'EJOI':
            ejo_participants = sorted([x for x in participants if x[3] <= 15], key=lambda x: (-x[4], x[0]))
            teams['EJOI'] = [str(id) for id, gender, grade, age, score in ejo_participants[:min(4, len(ejo_participants))]]
        elif olympiad == 'BaltOI':
            baltoi_participants = sorted(participants, key=lambda x: (-x[4], x[0]))
            teams['BaltOI'] = [str(id) for id, gender, grade, age, score in baltoi_participants[:min(6, len(baltoi_participants))]]
        elif olympiad == 'BalkOI':
            balkoi_participants = sorted([x for x in participants if x[2] != 11], key=lambda x: (-x[4], x[0]))
            teams['BalkOI'] = [str(id) for id, gender, grade, age, score in balkoi_participants[:min(4, len(balkoi_participants))]]
        elif olympiad == 'JBOI':
            jboi_participants = sorted([x for x in participants if x[2] not in [10, 11]], key=lambda x: (-x[4], x[0]))
            teams['JBOI'] = [str(id) for id, gender, grade, age, score in jboi_participants[:min(4, len(jboi_participants))]]
    return teams

n = int(input())
participants = []
for i in range(n):
    participant = input().split()
    participant[0] = int(participant[0])
    participant[3] = int(participant[3])
    participant[4] = int(participant[4])
    participants.append(participant)

m = int(input())
olympiads = [input() for _ in range(m)]

teams = define_teams(n, participants, olympiads)
for olympiad in olympiads:
    olympiad = olympiad.strip()  # Видаляємо символи перенесення рядка
    print(olympiad)
    for participant in teams[olympiad]:
        print(participant)    