from operator import itemgetter

def select_team(participants, olympiad):
    if olympiad == 'IOI':
        return sorted([p for p in participants], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'CEOI':
        return sorted([p for p in participants], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'EGOI':
        return sorted([p for p in participants if p['gender'] == 'female'], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'EJOI':
        return sorted([p for p in participants if p['age'] <= 15], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'BaltOI':
        return sorted([p for p in participants], key=itemgetter('score'), reverse=True)[:6]
    elif olympiad == 'BalkOI':
        return sorted([p for p in participants if p['grade'] != 11], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'JBOI':
        return sorted([p for p in participants if p['grade'] not in [10, 11]], key=itemgetter('score'), reverse=True)[:4]
    else:
        return []

n = int(input())
participants = []
for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append({'id': int(id), 'gender': gender, 'grade': int(grade), 'age': int(age), 'score': int(score)})

m = int(input())
olympiads = [input() for _ in range(m)]

for olympiad in olympiads:
    team = select_team(participants, olympiad)
    print(olympiad)
    for participant in sorted(team, key=itemgetter('id')):
        print(participant['id'])
