from collections import defaultdict

def process_gifts(n, m, sizes, initial_inventory, orders):
    remaining_inventory = defaultdict(lambda: defaultdict(int))
    additional_orders = defaultdict(lambda: defaultdict(int))
    excess_inventory = defaultdict(lambda: defaultdict(int))

    # Copy initial inventory
    for color in range(n):
        for size_index, size in enumerate(sizes):
            remaining_inventory[color][size] = initial_inventory[color][size_index]

    for i in range(len(orders)):
        color, size = orders[i]
        size_index = sizes.index(size)

        # Check if the requested size and color are available
        if remaining_inventory[color][size] > 0:
            remaining_inventory[color][size] -= 1
        else:
            # Find a replacement according to the algorithm
            found_replacement = False
            for larger_size in sizes[size_index + 1:]:
                if remaining_inventory[color][larger_size] > 0:
                    remaining_inventory[color][larger_size] -= 1
                    found_replacement = True
                    additional_orders[color][larger_size] += 1
                    break

            # If no replacement is found, mark the order as excess
            if not found_replacement:
                excess_inventory[color][size] += 1

    # Display remaining inventory
    display_inventory(remaining_inventory)

    # Display additional orders
    display_inventory(additional_orders)

    # Display excess inventory
    display_inventory(excess_inventory)

def display_inventory(inventory):
    for color, sizes in inventory.items():
        print(" ".join(str(sizes[size]) for size in sizes))

# Input processing
n, m = map(int, input().split())
sizes = input().split()
initial_inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
orders = [tuple(input().split()) for _ in range(k)]

# Process gifts
process_gifts(n, m, sizes, initial_inventory, orders)
