from collections import defaultdict

def process_gifts(n, m, sizes, inventory, winners):
    remaining, additional, excess = defaultdict(lambda: defaultdict(int)), defaultdict(lambda: defaultdict(int)), defaultdict(lambda: defaultdict(int))
    for c in range(n):
        for i, s in enumerate(sizes):
            remaining[c][s] = inventory[c][i]

    def find_replacement(c, s, larger=False):
        for color, sizes in remaining.items():
            if sizes[s] > 0:
                sizes[s] -= 1
                return color, s
        return find_replacement(c, sizes[sizes.index(s) + 1], True) if larger else None

    for c, s in winners:
        size_index = sizes.index(s)
        if remaining[c][s] > 0:
            remaining[c][s] -= 1
        else:
            replacement = find_replacement(c, s)
            if replacement:
                color, size = replacement
                additional[color][size] += 1
            else:
                replacement = find_replacement(c, s, True)
                if replacement:
                    color, size = replacement
                    additional[color][size] += 1
                else:
                    excess[c][s] += 1

    display_inventory(remaining)
    display_inventory(additional)

def display_inventory(inventory):
    for color, sizes in inventory.items():
        print(" ".join(str(sizes[s]) for s in sizes))

# Зчитуємо вхідні дані
n, m = map(int, input().split())
sizes = input().split()
initial_inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [tuple(input().split()) for _ in range(k)]

# Обробляємо замовлення та виводимо результати
process_gifts(n, m, sizes, initial_inventory, winners)
