#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    map<string, int> size_mapping;
    for (int i = 0; i < m; i++)
    {
        string s; cin >> s;
        size_mapping[s] = i;
    }
    vector<vector<int>> have_f(n, vector<int>());
    vector<vector<int>> need_f(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            int inp; cin >> inp;
            have_f[i].push_back(inp);
        }
    }
    int k; cin >> k;
    for (int i = 0; i < k; i++)
    {
        int color, size; string s_size;
        cin >> color >> s_size; size = size_mapping[s_size];
        color--;
        bool found = false;
        for (int j = size; j < m; j++)
        {
            if (have_f[color][j] != 0)
            {
                have_f[color][j]--;
                found = true;
                break;
            }
            for (int c = 0; c < n; c++)
            {
                if (have_f[c][j] != 0)
                {
                    have_f[c][j]--;
                    found = true;
                    break;
                }
            }
            if (found) break;
        }
        if (!found) 
        {
            need_f[color][size]++;
        }
    }

    for (int i = 0; i < have_f.size(); i++)
    {
        for (int j = 0; j < have_f[i].size(); j++)
        {
            cout << have_f[i][j] << " ";
        }
        cout << "\n";
    }
    for (int i = 0; i < need_f.size(); i++)
    {
        for (int j = 0; j < need_f[i].size(); j++)
        {
            cout << need_f[i][j] << " ";
        }
        cout << "\n";
    }
}

