#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int max_unmarked_sequence(int n, int m, vector<int>& a) {
    sort(a.begin(), a.end());

    int left = 1;
    int right = a.back() * 2;
    int result = 0;

    while (left <= right) {
        int mid = (left + right) / 2;
        int count = 0;

        for (int i = 0; i < n; ++i) {
            count += (a[i] + mid) / (mid + 1);
        }

        if (count <= m) {
            result = mid;
            right = mid - 1;
        } else {
            left = mid + 1;
        }
    }

    return result;
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cout << max_unmarked_sequence(n, m, a) << endl;

    return 0;
}