using System;
using System.Linq;
using System.Collections.Generic;

class Solution {
    static void Main ()
    {
        int n = int.Parse(Console.ReadLine());
        List<Gender> parts = new List<Gender>();

        for (int i = 0; i < n; i++) {
            string[] input = Console.ReadLine().Split();
            int id = int.Parse(input[0]);
            string gender = input[1];
            int grade = int.Parse(input[2]);
            int age = int.Parse(input[3]);
            int score = int.Parse(input[4]);

            parts.Add(new Gender(id, gender, grade, age, score));
        }

        int m = int.Parse(Console.ReadLine());

        for (int i = 0; i < m; i++) {
            string olympiad = Console.ReadLine();

            List<int> teamIds = GetTeamIds(parts, olympiad);

            Console.WriteLine(olympiad);
            foreach (var id in teamIds) {
                Console.WriteLine(id);
            }
        }
    }

    static List<int> GetTeamIds (List<Gender> participants, string olympiad)
    {
        List<int> teamIds = new List<int>();

        switch (olympiad) {
            case "IOI":
            case "CEOI":
                teamIds = participants
                    .OrderByDescending(p => p.Score)
                    .Take(4)
                    .Select(p => p.Id)
                    .ToList();
                break;

            case "EGOI":
                teamIds = participants
                    .Where(p => p.gender == "female")
                    .OrderByDescending(p => p.Score)
                    .Take(4)
                    .Select(p => p.Id)
                    .ToList();
                break;

            case "EJOI":
                teamIds = participants
                    .Where(p => p.Age <= 15)
                    .OrderByDescending(p => p.Score)
                    .Take(4)
                    .Select(p => p.Id)
                    .ToList();
                break;

            case "BaltOI":
            case "JBOI":
                teamIds = participants
                    .OrderByDescending(p => p.Score)
                    .Take(6)
                    .Select(p => p.Id)
                    .ToList();
                break;

            case "BalkOI":
                teamIds = participants
                    .Where(p => p.Grade != 11)
                    .OrderByDescending(p => p.Score)
                    .Take(4)
                    .Select(p => p.Id)
                    .ToList();
                break;
        }

        return teamIds;
    }
}

class Gender
{
    public int Id { get; }
    public string gender { get; }
    public int Grade { get; }
    public int Age { get; }
    public int Score { get; }

    public Gender (int id, string gender, int grade, int age, int score)
    {
        Id = id;
        this.gender = gender;
        Grade = grade;
        Age = age;
        Score = score;
    }
}