using System;
using System.Collections.Generic;
public class Wheel
{
    public List<bool> Colors { get; set; }
    public int markCount { get; set; }

    public Wheel (int colorsCount)
    {
        Colors = new List<bool>(colorsCount);
        for (int i = 0; i < colorsCount; i++) {
            Colors.Add(false);
        }
        markCount = 1;
    }

    public void MarkColor (int index)
    {
        if (!Colors[index]) {
            Colors[index] = true;
            markCount++;
        }
    }

    public int GetUnmark (int startIndex)
    {
        int length = 0;
        while (startIndex < Colors.Count && !Colors[startIndex]) {
            length++;
            startIndex++;
        }
        return length;
    }
}

class Solution
{
    public static void Main (string[] args)
    {
        string[] line1 = Console.ReadLine().Split(' ');
        int n = int.Parse(line1[0]);
        int m = int.Parse(line1[1]);

        string[] line2 = Console.ReadLine().Split(' ');
        int[] ai = new int[n];
        for (int i = 0; i < n; i++) {
            ai[i] = int.Parse(line2[i]);
        }

        List<Wheel> wheels = new List<Wheel>();
        for (int i = 0; i < n; i++) {
            wheels.Add(new Wheel(ai[i] + 1));
        }

        int colorsCount = 0;
        while (colorsCount < m + n) {
            int longestSeq = 0;
            Wheel chosenWheel = null;
            int chosenIndex = -1;
            for (int i = 0; i < n; i++) {
                Wheel wheel = wheels[i];
                int unmarkedSeq = wheel.GetUnmark(wheel.markCount);
                if (unmarkedSeq > longestSeq) {
                    longestSeq = unmarkedSeq;
                    chosenWheel = wheel;
                    chosenIndex = wheel.markCount;
                }
                else if (unmarkedSeq == longestSeq) {
                    chosenWheel = wheel;
                    chosenIndex = wheel.markCount;
                    break;
                }
            }

            chosenWheel.MarkColor(chosenIndex);
            colorsCount++;
        }

        int maxLength = 0;
        for (int i = 0; i < n; i++) {
            maxLength = Math.Max(maxLength, wheels[i].GetUnmark(wheels[i].markCount));
        }

        Console.WriteLine(maxLength);
    }
}
