n = int(input())

participants = {}

for _ in range(n):
    participant_info = input().split()
    id, gender, grade, age, score = map(int, participant_info)
    participants[id] = {'gender': gender, 'grade': grade, 'age': age, 'score': score}

m = int(input())

olympiads = {olympiad: [] for olympiad in ['IOI', 'CEOI', 'EGOI', 'EJOI', 'BaltOI', 'BalkOI', 'JBOI']}

for _ in range(m):
    olympiad = input()

    if olympiad == 'IOI' or olympiad == 'CEOI':
        participants_sorted = sorted(participants.keys(), key=lambda x: participants[x]['score'], reverse=True)
        olympiads[olympiad] = participants_sorted[:4]
    elif olympiad == 'EGOI':
        female_participants = [id for id in participants.keys() if participants[id]['gender'] == 'female']
        female_participants_sorted = sorted(female_participants, key=lambda x: participants[x]['score'], reverse=True)
        olympiads[olympiad] = female_participants_sorted[:4]
    elif olympiad == 'EJOI':
        junior_participants = [id for id in participants.keys() if participants[id]['age'] <= 15]
        junior_participants_sorted = sorted(junior_participants, key=lambda x: participants[x]['score'], reverse=True)
        olympiads[olympiad] = junior_participants_sorted[:4]
    elif olympiad == 'BaltOI':
        participants_sorted = sorted(participants.keys(), key=lambda x: participants[x]['score'], reverse=True)
        olympiads[olympiad] = participants_sorted[:6]
    elif olympiad == 'BalkOI':
        non_11th_grade_participants = [id for id in participants.keys() if participants[id]['grade'] != 11]
        non_11th_grade_participants_sorted = sorted(non_11th_grade_participants, key=lambda x: participants[x]['score'], reverse=True)
        olympiads[olympiad] = non_11th_grade_participants_sorted[:4]
    elif olympiad == 'JBOI':
        non_11th_10th_grade_participants = [id for id in participants.keys() if participants[id]['grade'] not in [10, 11]]
        non_11th_10th_grade_participants_sorted = sorted(non_11th_10th_grade_participants, key=lambda x: participants[x]['score'], reverse=True)
        olympiads[olympiad] = non_11th_10th_grade_participants_sorted

for olympiad in ['IOI', 'CEOI', 'EGOI', 'EJOI', 'BaltOI', 'BalkOI', 'JBOI']:
    print(olympiad)
    for participant_id in sorted(olympiads[olympiad]):
        print(participant_id)
