#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<std::string> sizes(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
    }

    std::vector<std::vector<int>> available(n, std::vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> available[i][j];
        }
    }

    int k;
    std::cin >> k;

    std::vector<std::vector<int>> remaining(n, std::vector<int>(m, 0));
    std::vector<std::vector<int>> to_order(n, std::vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        std::cin >> c >> s;
        
        int size_index = std::find(sizes.begin(), sizes.end(), std::string(1, s)) - sizes.begin();

        bool found = false;
        if (available[c - 1][size_index] > 0) {
            --available[c - 1][size_index];
            found = true;
        } else {
            for (int j = 0; j < n; ++j) {
                if (available[j][size_index] > 0) {
                    --available[j][size_index];
                    remaining[j][size_index]++;
                    found = true;
                    break;
                }
            }
        }
        for (int j = size_index + 1; j < m && !found; ++j) {
            for (int l = 0; l < n; ++l) {
                if (available[l][j] > 0) {
                    --available[l][j];
                    remaining[l][j]++;
                    found = true;
                    break;
                }
            }
        }
        for (int j = size_index - 1; j >= 0 && !found; --j) {
            for (int l = 0; l < n; ++l) {
                if (available[l][j] > 0) {
                    --available[l][j];
                    remaining[l][j]++;
                    found = true;
                    break;
                }
            }
        }

        if (!found) {
            to_order[c - 1][size_index]++;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << remaining[i][j] << ' ';
        }
        std::cout << '\n';
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << to_order[i][j] << ' ';
        }
        std::cout << '\n';
    }

    return 0;
}
