from collections import defaultdict

# Функція для визначення складу команди на олімпіаду
def determine_team(olympiad, participants):
    team = []
    
    if olympiad == 'IOI' or olympiad == 'CEOI':
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:min(4, len(participants))]
    elif olympiad == 'EGOI':
        female_participants = [participant for participant in participants if participant[1] == 'female']
        team = sorted(female_participants, key=lambda x: x[4], reverse=True)[:min(4, len(female_participants))]
    elif olympiad == 'EJOI':
        under_16_participants = [participant for participant in participants if participant[3] <= 15]
        team = sorted(under_16_participants, key=lambda x: x[4], reverse=True)[:min(4, len(under_16_participants))]
    elif olympiad == 'BaltOI':
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:min(6, len(participants))]
    elif olympiad == 'BalkOI':
        grade_not_11_participants = [participant for participant in participants if participant[2] != 11]
        team = sorted(grade_not_11_participants, key=lambda x: x[4], reverse=True)[:min(4, len(grade_not_11_participants))]
    elif olympiad == 'JBOI':
        grade_not_11_or_10_participants = [participant for participant in participants if participant[2] not in [10, 11]]
        team = sorted(grade_not_11_or_10_participants, key=lambda x: x[4], reverse=True)[:min(4, len(grade_not_11_or_10_participants))]
    
    return [member[0] for member in team]

n = int(input())
participants = []

# Зчитування інформації про учасників
for _ in range(n):
    participant_info = input().split()
    participant_info[0] = int(participant_info[0])
    participant_info[3] = int(participant_info[3])
    participant_info[4] = int(participant_info[4])
    participants.append(participant_info)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Сортування учасників за id
participants.sort(key=lambda x: x[0])

# Формування команд для кожної олімпіади
teams = defaultdict(list)
for olympiad in olympiads:
    teams[olympiad] = determine_team(olympiad, participants)

# Виведення результатів
for olympiad in olympiads:
    team_members = teams[olympiad]
    print(olympiad)
    print(*team_members)
