#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m;

    map<string, int> sizeIndex;
    vector<string> sizeOrder(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizeOrder[i];
        sizeIndex[sizeOrder[i]] = i;
    }

    vector<vector<int>> stock(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> stock[i][j];
        }
    }

    cin >> k;
    vector<vector<int>> order(n, vector<int>(m, 0));
    while (k--) {
        int color;
        string size;
        cin >> color >> size;
        --color;

        int sizeIdx = sizeIndex[size];
        bool fulfilled = false;

        if (stock[color][sizeIdx] > 0) {
            stock[color][sizeIdx]--;
            fulfilled = true;
        } else {
            for (int c = 0; c < n && !fulfilled; ++c) {
                if (stock[c][sizeIdx] > 0) {
                    stock[c][sizeIdx]--;
                    fulfilled = true;
                }
            }
            for (int s = sizeIdx + 1; s < m && !fulfilled; ++s) {
                if (stock[color][s] > 0) {
                    stock[color][s]--;
                    fulfilled = true;
                } else {
                    for (int c = 0; c < n && !fulfilled; ++c) {
                        if (stock[c][s] > 0) {
                            stock[c][s]--;
                            fulfilled = true;
                        }
                    }
                }
            }
        }

        if (!fulfilled) {
            order[color][sizeIdx]++;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << stock[i][j] << " ";
        }
        cout << endl;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
