def select_participants(olympiad, participants):
    if olympiad in ["IOI", "CEOI", "BaltOI"]:
        filtered = participants
        team_size = 4 if olympiad != "BaltOI" else 6
    elif olympiad == "EGOI":
        filtered = [p for p in participants if p[1] == "female"]
        team_size = 4
    elif olympiad == "EJOI":
        filtered = [p for p in participants if int(p[3]) < 15]
        team_size = 4
    elif olympiad == "BalkOI":
        filtered = [p for p in participants if p[2] != "11"]
        team_size = 4
    elif olympiad == "JBOI":
        filtered = [p for p in participants if p[2] not in ["10", "11"]]
        team_size = 4

    filtered.sort(key=lambda x: (-int(x[4]), int(x[0])))
    selected_participants = filtered[:min(team_size, len(filtered))]

    return olympiad, sorted([p[0] for p in selected_participants], key=int)

n = int(input().strip())
participants = [input().strip().split() for _ in range(n)]

m = int(input().strip())
requested_olympiads = [input().strip() for _ in range(m)]

for olympiad in requested_olympiads:
    name, selected_ids = select_participants(olympiad, participants)
    print(name)
    for id in selected_ids:
        print(id)
