#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;

    vector<long long> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<long long> max_lengths(n, 0);

    // Function to find the maximum length of unmarked sequence in a wheel
    auto updateMaxLength = [&](long long index) {
        long long length = a[index];
        long long max_length = 0;
        long long p2 = 1;

        while (p2 <= m) {
            max_length = max(max_length, length);

            if (length % 2 == 0) {
                length /= 2;
            } else {
                length = length / 2 + 1;
            }

            p2 *= 2;
        }

        max_lengths[index] = max_length;
    };

    for (int i = 0; i < n; i++) {
        updateMaxLength(i);
    }

    long long global_max = *max_element(max_lengths.begin(), max_lengths.end());

    cout << global_max << endl;

    return 0;
}
