import java.util.*;

class Participant {
    int id, grade, age, score;
    String gender;

    public Participant(int id, String gender, int grade, int age, int score) {
        this.id = id;
        this.gender = gender;
        this.grade = grade;
        this.age = age;
        this.score = score;
    }
}

public class TeamSelection {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        List<Participant> participants = new ArrayList<>();

        for (int i = 0; i < n; i++) {
            int id = scanner.nextInt();
            String gender = scanner.next();
            int grade = scanner.nextInt();
            int age = scanner.nextInt();
            int score = scanner.nextInt();
            participants.add(new Participant(id, gender, grade, age, score));
        }

        int m = scanner.nextInt();
        for (int i = 0; i < m; i++) {
            String olympiad = scanner.next();
            List<Integer> team = selectTeam(olympiad, participants);
            
            System.out.println(olympiad);
            for (int participantId : team) {
                System.out.println(participantId);
            }
        }
    }

    public static List<Integer> selectTeam(String olympiad, List<Participant> participants) {
        List<Participant> results = new ArrayList<>();

        for (Participant participant : participants) {
            if ((olympiad.equals("IOI") || olympiad.equals("CEOI")) && (participant.grade == 10 || participant.grade == 11)) {
                results.add(participant);
            } else if (olympiad.equals("EGOI") && participant.gender.equals("female")) {
                results.add(participant);
            } else if (olympiad.equals("EJOI") && participant.age <= 15) {
                results.add(participant);
            } else if (olympiad.equals("BaltOI")) {
                results.add(participant);
            } else if (olympiad.equals("BalkOI") && participant.grade != 11) {
                results.add(participant);
            } else if (olympiad.equals("JBOI") && participant.grade < 10) {
                results.add(participant);
            }
        }

        results.sort(Comparator.comparingInt(p -> -p.score));

        List<Integer> team = new ArrayList<>();
        for (int i = 0; i < Math.min(results.size(), getTeamSize(olympiad)); i++) {
            team.add(results.get(i).id);
        }

        return team;
    }

    public static int getTeamSize(String olympiad) {
        switch (olympiad) {
            case "IOI":
            case "CEOI":
                return 4;
            case "EGOI":
            case "EJOI":
            case "JBOI":
                return 4;
            case "BaltOI":
            case "BalkOI":
                return 6;
            default:
                return 0;
        }
    }
}
