def main():
    n = int(input())
    participants = []
    for _ in range(n):
        participant_info = input().split()
        participant = {
            "id": int(participant_info[0]),
            "gender": participant_info[1],
            "grade": int(participant_info[2]),
            "age": int(participant_info[3]),
            "score": int(participant_info[4])
        }
        participants.append(participant)

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    participants.sort(key=lambda x: x["score"], reverse=True)

    for olympiad in olympiads:
        team_size = get_team_size(olympiad)
        selected_participants = get_selected_participants(participants, olympiad, team_size)
        selected_participants.sort(key=lambda x: x["id"])
        
        print(olympiad)
        for participant in selected_participants:
            print(participant["id"])

def get_team_size(olympiad):
    if olympiad in ["IOI", "CEOI"]:
        return 4
    elif olympiad == "EGOI":
        return 4
    elif olympiad == "EJOI":
        return 4
    elif olympiad == "BaltOI":
        return 6
    elif olympiad == "BalkOI":
        return 4
    elif olympiad == "JBOI":
        return 4

def get_selected_participants(participants, olympiad, team_size):
    selected_participants = []
    
    if olympiad == "EGOI":
        female_participants = [p for p in participants if p["gender"] == "female"]
        selected_participants = female_participants[:team_size]
    elif olympiad == "EJOI":
        selected_participants = [p for p in participants if p["age"] <= 15][:team_size]
    elif olympiad == "BalkOI":
        selected_participants = [p for p in participants if p["grade"] < 11][:team_size]
    elif olympiad == "JBOI":
        selected_participants = [p for p in participants if p["grade"] < 10][:team_size]
    else:
        selected_participants = participants[:team_size]
    
    return selected_participants

if __name__ == "__main__":
    main()
