n, m = map(int, input().split())
a = list(map(int, input().split()))

# Initialize a list to represent color wheels with their selected colors
color_wheels = [[i+1] for i in range(n)]

# Function to find the maximum length of unmarked colors
def max_unmarked_length():
    return max(len(seq) for seq in color_wheels)

# Initial maximum length of the sequence of unmarked colors
max_length = max_unmarked_length()

# Helper function to update color wheels after selecting a color
def update_color_wheels():
    for wheel in color_wheels:
        if wheel:
            wheel.pop()

# Iterate to select m more colors
for i in range(m):
    # Find the maximum length before selecting the (m+n)-th color
    max_length = max(max_length, max_unmarked_length())

    # Find the color wheel with the longest sequence of unmarked colors
    max_seq_wheel = max(color_wheels, key=len)

    # Find the middle index of the sequence
    middle_index = len(max_seq_wheel) // 2

    # Mark the color as used
    selected_color = max_seq_wheel.pop(middle_index)

    # Update color wheels
    update_color_wheels()

    # Add the selected color to the color wheel list
    color_wheels.append([selected_color])

# Output the maximum length of the sequence of unmarked colors
print(max_length)
