#include <iostream>
#include <vector>
#include <tuple>

void process_gifts(int n, int m, std::vector<std::string>& sizes, std::vector<std::vector<int>>& quantities, int k, std::vector<std::tuple<std::string, std::string>>& winners) {
    std::vector<std::vector<int>> remaining_shirts(n, std::vector<int>(m, 0));
    std::vector<std::vector<int>> needed_shirts(n, std::vector<int>(m, 0));
    std::vector<std::vector<int>> excess_shirts(n, std::vector<int>(m, 0));
    std::vector<std::vector<int>> unfulfilled_requests(n, std::vector<int>(m, 0));

    // Copy quantities to remaining_shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            remaining_shirts[i][j] = quantities[i][j];
        }
    }

    for (int i = 0; i < k; ++i) {
        std::string color = std::get<0>(winners[i]);
        std::string size = std::get<1>(winners[i]);
        int size_index = -1;

        // Find the index of the size
        for (int j = 0; j < m; ++j) {
            if (sizes[j] == size) {
                size_index = j;
                break;
            }
        }

        // Check if there is a shirt of the specified color and size
        if (remaining_shirts[std::stoi(color) - 1][size_index] > 0) {
            remaining_shirts[std::stoi(color) - 1][size_index] -= 1;
        } else {
            // Find a shirt of the same size but different color
            bool found_alternative = false;
            for (int j = 0; j < n; ++j) {
                if (remaining_shirts[j][size_index] > 0) {
                    remaining_shirts[j][size_index] -= 1;
                    excess_shirts[j][size_index] += 1;
                    found_alternative = true;
                    break;
                }
            }

            // If no alternative is found, find the smallest available size
            if (!found_alternative) {
                for (int j = size_index + 1; j < m; ++j) {
                    for (int k = 0; k < n; ++k) {
                        if (remaining_shirts[k][j] > 0) {
                            remaining_shirts[k][j] -= 1;
                            excess_shirts[k][j] += 1;
                            break;
                        }
                    }
                }
            }
        }

        // Update the needed shirts count
        needed_shirts[std::stoi(color) - 1][size_index] += 1;
    }

    // Display the excess and unfulfilled shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << excess_shirts[i][j] << " ";
        }
        std::cout << std::endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << unfulfilled_requests[i][j] << " ";
        }
        std::cout << std::endl;
    }
}

int main() {
    int n, m, k;
    std::cin >> n >> m;

    std::vector<std::string> sizes(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
    }

    std::vector<std::vector<int>> quantities(n, std::vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> quantities[i][j];
        }
    }

    std::cin >> k;

    std::vector<std::tuple<std::string, std::string>> winners(k);
    for (int i = 0; i < k; ++i) {
        std::cin >> std::get<0>(winners[i]) >> std::get<1>(winners[i]);
    }

    process_gifts(n, m, sizes, quantities, k, winners);

    return 0;
}
