#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> to_order(n, vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        cin >> c >> s;
        int size_index = find(sizes.begin(), sizes.end(), string(1, s)) - sizes.begin();

        if (available[c - 1][size_index] > 0) {
            available[c - 1][size_index]--;
        } else {
            int size_to_try = size_index;
            while (size_to_try < m && available[c - 1][size_to_try] == 0) {
                size_to_try++;
            }

            if (size_to_try == m) {
                int size_to_order = size_index;
                while (size_to_order < m && remaining[c - 1][size_to_order] == 0) {
                    size_to_order++;
                }

                if (size_to_order == m) {
                    to_order[c - 1][size_index]++;
                } else {
                    remaining[c - 1][size_to_order]--;
                    available[c - 1][size_to_order]++;
                }
            } else {
                available[c - 1][size_to_try]--;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << available[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
