#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& a, const Participant& b) {
    return a.score > b.score || (a.score == b.score && a.id < b.id);
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    map<string, int> selectedParticipants;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        int teamSize;
        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "EGOI" || olympiad == "EJOI") {
            teamSize = 4;
        } else if (olympiad == "BaltOI") {
            teamSize = 6;
        } else {
            teamSize = 4;
        }

        vector<int> teamMembers;
        for (int j = 0; j < n && teamMembers.size() < teamSize; ++j) {
            if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "EGOI" || olympiad == "EJOI") {
                if (participants[j].gender == "female" && olympiad == "EGOI") {
                    teamMembers.push_back(participants[j].id);
                } else if (participants[j].grade <= 10 && olympiad == "EJOI") {
                    teamMembers.push_back(participants[j].id);
                } else if (olympiad != "EGOI" && olympiad != "EJOI") {
                    teamMembers.push_back(participants[j].id);
                }
            } else if (olympiad == "BaltOI") {
                teamMembers.push_back(participants[j].id);
            } else if (olympiad == "BalkOI") {
                if (participants[j].grade != 11) {
                    teamMembers.push_back(participants[j].id);
                }
            } else if (olympiad == "JBOI") {
                if (participants[j].grade != 11 && participants[j].grade != 10) {
                    teamMembers.push_back(participants[j].id);
                }
            }
        }

        sort(teamMembers.begin(), teamMembers.end());

        for (int memberId : teamMembers) {
            selectedParticipants[olympiad]++;
            cout << olympiad << "\n" << memberId << "\n";
        }
    }

    return 0;
}
