from collections import defaultdict

def select_team(participants, olympiad):
    if olympiad == 'IOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'CEOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'EGOI':
        return sorted((p for p in participants if p[1] == 'female'), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'EJOI':
        return sorted((p for p in participants if p[3] <= 15), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'BaltOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == 'BalkOI':
        return sorted((p for p in participants if p[3] != 11), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == 'JBOI':
        return sorted((p for p in participants if p[3] not in {10, 11}), key=lambda x: (-x[4], x[0]))[:4]

def main():
    n = int(input())
    participants = [tuple(input().split()) for _ in range(n)]
    participants = [(int(id), gender, int(grade), int(age), int(score)) for id, gender, grade, age, score in participants]

    m = int(input())
    olympiads = [input() for _ in range(m)]

    participants_by_olympiad = defaultdict(list)
    for olympiad in olympiads:
        participants_by_olympiad[olympiad] = select_team(participants, olympiad)

    for olympiad in olympiads:
        print(olympiad)
        for participant in participants_by_olympiad[olympiad]:
            print(participant[0])

if __name__ == "__main__":
    main()
