#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void processGifts(int n, int m, const vector<string>& sizes, vector<vector<int>>& available, const vector<pair<int, string>>& winners) {
    vector<vector<int>> remainingGifts(n, vector<int>(m, 0));
    vector<vector<int>> requiredGifts(n, vector<int>(m, 0));

    for (const auto& winner : winners) 
    {
        int color = winner.first - 1;
        string size = winner.second;
        auto sizeIndex = find(sizes.begin(), sizes.end(), size) - sizes.begin();

        if (available[color][sizeIndex] > 0) 
        {
            available[color][sizeIndex]--;
        } else {
            for (size_t j = sizeIndex + 1; j < sizes.size(); ++j) 
            {
                auto it = find(available[color].begin() + j, available[color].end(), 0);
                if (it != available[color].end()) 
                {
                    auto index = distance(available[color].begin(), it);
                    available[color][index]--;
                    requiredGifts[color][index]++;
                    break;
                }
            }
        }
    }

    for (const auto& row : available) 
    {
        for (int count : row) 
        {
            cout << count << " ";
        }
        cout << endl;
    }

    for (const auto& row : requiredGifts) 
    {
        for (int count : row) 
        {
            cout << count << " ";
        }
        cout << endl;
    }
}

int main() 
{
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) 
    {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) 
    {
        for (int j = 0; j < m; ++j) 
        {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<pair<int, string>> winners(k);
    for (int i = 0; i < k; ++i) 
    {
        cin >> winners[i].first >> winners[i].second;
    }

    processGifts(n, m, sizes, available, winners);

    return 0;
}
