#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant 
{
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant &a, const Participant &b) 
{
    return a.score > b.score;
}

int main() {
    int n, m;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; i++) 
    {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    cin >> m;
    map<string, vector<int>> teams;

    for (int i = 0; i < m; i++) 
    {
        string olympiad;
        cin >> olympiad;
        teams[olympiad] = vector<int>();
    }

    for (const auto &participant : participants) 
    {
        if (participant.gender == "female" && participant.age <= 15 && teams["EJOI"].size() < 4) {
            teams["EJOI"].push_back(participant.id);
        }

        if (participant.gender == "female" && teams["EGOI"].size() < 4) 
        {
            teams["EGOI"].push_back(participant.id);
        }

        if (participant.age <= 10 && teams["JBOI"].size() < 4) 
        {
            teams["JBOI"].push_back(participant.id);
        }

        if (participant.grade != 11 && teams["BalkOI"].size() < 4) 
        {
            teams["BalkOI"].push_back(participant.id);
        }

        if (teams["IOI"].size() < 4) 
        {
            teams["IOI"].push_back(participant.id);
        }
    }

    for (const auto &team : teams) 
    {
        cout << team.first << endl;
        for (const auto &id : team.second) 
        {
            cout << id << " ";
        }
        cout << endl;
    }

    return 0;
}
