from collections import defaultdict

def determine_team(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants, key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == "EGOI":
        females = [participant for participant in participants if participant['gender'] == 'female']
        return sorted(females, key=lambda x: x['score'], reverse=True)[:min(4, len(females))]
    elif olympiad == "EJOI":
        juniors = [participant for participant in participants if participant['age'] <= 15]
        return sorted(juniors, key=lambda x: x['score'], reverse=True)[:min(4, len(juniors))]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: x['score'], reverse=True)[:6]
    elif olympiad == "BalkOI":
        non_11th_graders = [participant for participant in participants if participant['grade'] != 11]
        return sorted(non_11th_graders, key=lambda x: x['score'], reverse=True)[:min(4, len(non_11th_graders))]
    elif olympiad == "JBOI":
        non_11th_10th_graders = [participant for participant in participants if participant['grade'] not in {10, 11}]
        return sorted(non_11th_10th_graders, key=lambda x: x['score'], reverse=True)[:min(4, len(non_11th_10th_graders))]


n = int(input())
participants = []
for _ in range(n):
    id, gender, grade, age, score = map(int, input().split())
    participants.append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    team = determine_team(olympiad, participants)
    print(olympiad)
    for member in team:
        print(member['id'], end=' ')
    print()
