def main():
    n, m = map(int, input().split())
    sizes = input().split()
    sizes_count = len(sizes)

    in_stock = []
    for _ in range(n):
        in_stock.append(list(map(int, input().split())))

    k = int(input())
    order_requests = [input().split() for _ in range(k)]

    available = [list(row) for row in in_stock]  # Copy of the in_stock list

    for request in order_requests:
        color, size = request[1][0], sizes.index(request[1])
        if in_stock[int(request[0]) - 1][size] > 0:
            in_stock[int(request[0]) - 1][size] -= 1
        elif any(in_stock[i][size] > 0 for i in range(n)):
            # Find a shirt with the same size but different color
            other_colors = [i for i in range(n) if in_stock[i][size] > 0]
            other_color = min(other_colors)
            in_stock[other_color][size] -= 1
        else:
            # Find a larger size with the same color
            larger_sizes = [i for i in range(sizes_count) if i > size]
            if any(in_stock[int(request[0]) - 1][larger_size] > 0 for larger_size in larger_sizes):
                size = min(larger_sizes)
                in_stock[int(request[0]) - 1][size] -= 1
            else:
                # Find a larger size with a different color
                for i in range(n):
                    if any(in_stock[i][larger_size] > 0 for larger_size in larger_sizes):
                        size = min(larger_sizes)
                        in_stock[i][size] -= 1
                        break

    # Print the remaining stock
    for row in in_stock:
        print(*row)

    # Print the needed shirts
    for i in range(n):
        row = [available[i][j] - in_stock[i][j] for j in range(sizes_count)]
        print(*row)


if __name__ == "__main__":
    main()
