from collections import defaultdict

def select_team(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        participants.sort(reverse=True, key=lambda x: x[4])
        return participants[:4]
    elif olympiad == "EGOI":
        female_participants = [participant for participant in participants if participant[1] == "female"]
        female_participants.sort(reverse=True, key=lambda x: x[4])
        return female_participants[:4]
    elif olympiad == "EJOI":
        junior_participants = [participant for participant in participants if participant[3] <= 15]
        junior_participants.sort(reverse=True, key=lambda x: x[4])
        return junior_participants[:4]
    elif olympiad == "BaltOI":
        participants.sort(reverse=True, key=lambda x: x[4])
        return participants[:6]
    elif olympiad == "BalkOI":
        non_11th_graders = [participant for participant in participants if participant[2] != 11]
        non_11th_graders.sort(reverse=True, key=lambda x: x[4])
        return non_11th_graders[:4]
    elif olympiad == "JBOI":
        non_11th_10th_graders = [participant for participant in participants if participant[2] not in [10, 11]]
        non_11th_10th_graders.sort(reverse=True, key=lambda x: x[4])
        return non_11th_10th_graders[:4]

def main():
    n = int(input())
    participants = []
    for _ in range(n):
        participant_info = input().split()
        participant_info[0] = int(participant_info[0])
        participant_info[3] = int(participant_info[3])
        participant_info[4] = int(participant_info[4])
        participants.append(participant_info)

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    participants_by_olympiad = defaultdict(list)
    for olympiad in olympiads:
        selected_team = select_team(olympiad, participants)
        selected_team_ids = [str(participant[0]) for participant in selected_team]
        participants_by_olympiad[olympiad] = selected_team_ids

    for olympiad in olympiads:
        print(olympiad)
        print('\n'.join(participants_by_olympiad[olympiad]))

if __name__ == "__main__":
    main()
