def max_subarray_length(n, m, colors):
    left, right = 0, sum(colors)
    result = 0

    while left <= right:
        mid = (left + right) // 2
        current_sum = 0
        cnt = 0

        for color in colors:
            if current_sum + color <= mid:
                current_sum += color
            else:
                cnt += 1
                current_sum = color

        cnt += 1  # last subarray
        if cnt <= m:
            result = mid
            right = mid - 1
        else:
            left = mid + 1

    return result

# Reading input
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Outputting the result
print(max_subarray_length(n, m, colors))
