#include <iostream>
#include <map>
#include <vector>
#include <string>

using namespace std;

int main() {
    int colors, sizes;
    cin >> colors >> sizes;

    vector<vector<int>> shirts{};
    vector<vector<int>> missing{};

    map<string, int> size_symbols{};

    for (int i = 0; i < sizes; i++) {
        string symbol;
        cin >> symbol;

        size_symbols[symbol] = i;
    }

    for (int i = 0; i < colors; i++) {
        shirts.push_back(vector<int>{});
        missing.push_back(vector<int>{});

        for (int j = 0; j < sizes; j++) {
            int count;
            cin >> count;
            
            shirts[i].push_back(count);
            missing[i].push_back(0);
        }
    }

    int winners;
    cin >> winners;

    for (int winner = 0; winner < winners; winner++) {
        int color;
        cin >> color;

        color -= 1;

        string size_symbol;
        cin >> size_symbol;

        int size = size_symbols[size_symbol];
        int taken_size = -1;
        int taken_color = -1;

        for (int new_size = size; new_size < sizes; new_size++) {
            if (shirts[color][new_size] > 0) {
                taken_size = new_size;
                taken_color = color;
                break;
            }

            bool found = false;

            for (int new_color = 0; new_color < colors; new_color++) {
                if (shirts[new_color][new_size] > 0) {
                    taken_size = new_size;
                    taken_color = new_color;
                    found = true;
                    break;
                }
            }

            if (found) {
                break;
            }
        }

        if (taken_size > -1 && taken_color > -1) {
            shirts[taken_color][taken_size] -= 1;
        } else {
            missing[color][size] += 1;
        }
    }

    for (int i = 0; i < colors; i++) {
        for (int j = 0; j < sizes; j++) {
            cout << shirts[i][j] << " ";
        }

        cout << "\n";
    }

    for (int i = 0; i < colors; i++) {
        for (int j = 0; j < sizes; j++) {
            cout << missing[i][j] << " ";
        }

        cout << "\n";
    }

    return 0;
}
