def organize_gifts(n, m, sizes, quantities, winners):
    remaining_gifts = [[quantities[i][j] for j in range(m)] for i in range(n)]
    ordered_gifts = [[0] * m for _ in range(n)]

    for winner in winners:
        color, size = winner[0] - 1, sizes.index(winner[1])
        if remaining_gifts[color][size] > 0:
            remaining_gifts[color][size] -= 1
        else:
            found_alternative = False

            for alt_size in range(size + 1, m):
                if remaining_gifts[color][alt_size] > 0:
                    ordered_gifts[color][alt_size] += 1
                    remaining_gifts[color][alt_size] -= 1
                    found_alternative = True
                    break

            if not found_alternative:
                for alt_color in range(color + 1, n):
                    for alt_size in range(m):
                        if remaining_gifts[alt_color][alt_size] > 0:
                            ordered_gifts[alt_color][alt_size] += 1
                            remaining_gifts[alt_color][alt_size] -= 1
                            found_alternative = True
                            break
                    if found_alternative:
                        break

    return remaining_gifts, ordered_gifts


# Input
n, m = map(int, input().split())
sizes = input().split()
quantities = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [tuple(map(str, input().split())) for _ in range(k)]

# Process gifts
remaining, ordered = organize_gifts(n, m, sizes, quantities, winners)

# Output
for row in remaining:
    print(*row)

for row in ordered:
    print(*row)