def process_gifts(n, m, sizes, t_shirts, k, winners):
    size_to_index = {size: index for index, size in enumerate(sizes)}

    remaining_t_shirts = [[t_shirts[i][j] for j in range(m)] for i in range(n)]
    needed_t_shirts = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = winners[i]
        color = int(color) - 1
        size_index = size_to_index[size]

        if remaining_t_shirts[color][size_index] > 0:
            remaining_t_shirts[color][size_index] -= 1
        else:
            found = False
            for j in range(size_index + 1, m):
                if remaining_t_shirts[color][j] > 0:
                    needed_t_shirts[color][j] += 1
                    remaining_t_shirts[color][j] -= 1
                    found = True
                    break
            if not found:
                for j in range(size_index + 1, m):
                    for k in range(n):
                        if remaining_t_shirts[k][j] > 0:
                            needed_t_shirts[k][j] += 1
                            remaining_t_shirts[k][j] -= 1
                            found = True
                            break
                    if found:
                        break

            if not found:
                needed_t_shirts[color][size_index] += 1

    return remaining_t_shirts, needed_t_shirts

def main():
    n, m = map(int, input().split())
    sizes = input().split()
    t_shirts = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    winners = [tuple(input().split()) for _ in range(k)]

    remaining, needed = process_gifts(n, m, sizes, t_shirts, k, winners)

    for row in remaining:
        print(*row)
    for row in needed:
        print(*row)

if __name__ == "__main__":
    main()