from collections import defaultdict

def select_team(participants, criteria, num_of_members):
    if criteria == 'EGOI':
        selected = [p for p in participants if p[1] == 'female']
    elif criteria == 'EJOI':
        selected = [p for p in participants if p[3] <= 15]
    elif criteria == 'BalkOI':
        selected = [p for p in participants if p[2] != 11]
    elif criteria == 'JBOI':
        selected = [p for p in participants if p[2] != 11 and p[2] != 10]
    else:
        selected = participants

    selected.sort(key=lambda x: x[3], reverse=True)
    team_members = selected[:num_of_members]

    return sorted([p[0] for p in team_members])

def main():
    n = int(input())
    participants = []

    for _ in range(n):
        participant_info = input().split()
        participants.append((int(participant_info[0]), participant_info[1], int(participant_info[2]), int(participant_info[3]), int(participant_info[4])))

    m = int(input())
    for _ in range(m):
        olympiad = input().strip()
        num_of_members = 4 if olympiad in ['IOI', 'CEOI'] else 6
        team_members = select_team(participants, olympiad, num_of_members)

        print(olympiad)
        for member in team_members:
            print(member)

if __name__ == "__main__":
    main()