#include <stdio.h>
#include <stdlib.h>

struct Participant {
    int id;
    char gender[10];
    int grade;
    int age;
    int score;
};

void determine_team_size(char olympiad[], int num_participants);

void determine_team_participants(char** olympiads, struct Participant* participants, int n, int m) {
    // Use an array of structures to store results
    struct {
        int score;
        int id;
    } results[1000][6];

    for (int i = 0; i < n; ++i) {
        int id, grade, age, score;
        char gender[10];
        id = participants[i].id;
        strcpy(gender, participants[i].gender);
        grade = participants[i].grade;
        age = participants[i].age;
        score = participants[i].score;

        for (int j = 0; j < m; ++j) {
            char* olympiad = olympiads[j];

            if (strcmp(olympiad, "IOI") == 0) {
                results[0][j].score = score;
                results[0][j].id = id;
            } else if (strcmp(olympiad, "CEOI") == 0) {
                results[1][j].score = score;
                results[1][j].id = id;
            } else if (strcmp(olympiad, "EGOI") == 0 && strcmp(gender, "female") == 0) {
                results[2][j].score = score;
                results[2][j].id = id;
            } else if (strcmp(olympiad, "EJOI") == 0 && age <= 15) {
                results[3][j].score = score;
                results[3][j].id = id;
            } else if (strcmp(olympiad, "BaltOI") == 0) {
                results[4][j].score = score;
                results[4][j].id = id;
            } else if (strcmp(olympiad, "BalkOI") == 0 && grade != 11) {
                results[5][j].score = score;
                results[5][j].id = id;
            } else if (strcmp(olympiad, "JBOI") == 0 && grade < 11) {
                results[6][j].score = score;
                results[6][j].id = id;
            }
        }
    }

    // Use an array to store teams
    int teams[100][4];
    for (int j = 0; j < m; ++j) {
        char* olympiad = olympiads[j];
        int team_size = determine_team_size(olympiad, n);

        // Sorting the results array
        for (int i = 0; i < n - 1; ++i) {
            for (int k = 0; k < n - i - 1; ++k) {
                if (results[i][j].score < results[i + 1][j].score) {
                    int temp_score = results[i][j].score;
                    int temp_id = results[i][j].id;

                    results[i][j].score = results[i + 1][j].score;
                    results[i][j].id = results[i + 1][j].id;

                    results[i + 1][j].score = temp_score;
                    results[i + 1][j].id = temp_id;
                }
            }
        }

        // Assigning team members
        for (int i = 0; i < team_size; ++i) {
            teams[j][i] = results[i][j].id;
        }
    }

    // Printing results
    for (int j = 0; j < m; ++j) {
        printf("%s\n", olympiads[j]);
        for (int i = 0; i < determine_team_size(olympiads[j], n); ++i) {
            printf("%d\n", teams[j][i]);
        }
    }
}

int determine_team_size(char olympiad[], int num_participants) {
    if (strcmp(olympiad, "IOI") == 0 || strcmp(olympiad, "CEOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else if (strcmp(olympiad, "EGOI") == 0 || strcmp(olympiad, "EJOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else if (strcmp(olympiad, "BaltOI") == 0) {
        return num_participants < 6 ? num_participants : 6;
    } else if (strcmp(olympiad, "BalkOI") == 0 || strcmp(olympiad, "JBOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else {
        return 0;
    }
}

int main() {
    int n, m;
    scanf("%d", &n);

    struct Participant* participants = (struct Participant*)malloc(n * sizeof(struct Participant));

    for (int i = 0; i < n; ++i) {
        int id, grade, age, score;
        char gender[10];
        scanf("%d %s %d %d %d", &id, gender, &grade, &age, &score);

        participants[i].id = id;
        strcpy(participants[i].gender, gender);
        participants[i].grade