#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int determine_team_size(char olympiad[], int num_participants);

int main() {
    int n, m;
    scanf("%d", &n);

    int id, grade, age, score;
    char gender[10];

    // Arrays to store participants' data
    int* ids = (int*)malloc(n * sizeof(int));
    char** genders = (char**)malloc(n * sizeof(char*));
    int* grades = (int*)malloc(n * sizeof(int));
    int* ages = (int*)malloc(n * sizeof(int));
    int* scores = (int*)malloc(n * sizeof(int));

    for (int i = 0; i < n; ++i) {
        scanf("%d %s %d %d %d", &id, gender, &grade, &age, &score);

        // Copy gender to heap-allocated memory
        genders[i] = (char*)malloc((strlen(gender) + 1) * sizeof(char));
        strcpy(genders[i], gender);

        ids[i] = id;
        grades[i] = grade;
        ages[i] = age;
        scores[i] = score;
    }

    scanf("%d", &m);

    // Array to store olympiads' names
    char** olympiads = (char**)malloc(m * sizeof(char*));
    for (int i = 0; i < m; ++i) {
        // Assuming the maximum length of olympiad name is 10
        olympiads[i] = (char*)malloc(11 * sizeof(char));
        scanf("%s", olympiads[i]);
    }

    // Array to store teams
    int** teams = (int**)malloc(m * sizeof(int*));
    for (int i = 0; i < m; ++i) {
        // Determine team size and allocate memory accordingly
        int team_size = determine_team_size(olympiads[i], n);
        teams[i] = (int*)malloc(team_size * sizeof(int));
    }

    // Use an array to store results
    int*** results = (int***)malloc(m * sizeof(int**));
    for (int i = 0; i < m; ++i) {
        results[i] = (int**)malloc(n * sizeof(int*));
        for (int j = 0; j < n; ++j) {
            results[i][j] = (int*)malloc(2 * sizeof(int));
            results[i][j][0] = scores[j];
            results[i][j][1] = ids[j];
        }
    }

    // Process olympiads and sort teams
    for (int j = 0; j < m; ++j) {
        int team_size = determine_team_size(olympiads[j], n);

        // Sorting the results array
        for (int i = 0; i < n - 1; ++i) {
            for (int k = 0; k < n - i - 1; ++k) {
                if (results[j][k][0] < results[j][k + 1][0]) {
                    int temp_score = results[j][k][0];
                    int temp_id = results[j][k][1];

                    results[j][k][0] = results[j][k + 1][0];
                    results[j][k][1] = results[j][k + 1][1];

                    results[j][k + 1][0] = temp_score;
                    results[j][k + 1][1] = temp_id;
                }
            }
        }

        // Assigning team members
        for (int i = 0; i < team_size; ++i) {
            teams[j][i] = results[j][i][1];
        }
    }

    // Printing results
    for (int j = 0; j < m; ++j) {
        printf("%s\n", olympiads[j]);
        for (int i = 0; i < determine_team_size(olympiads[j], n); ++i) {
            printf("%d\n", teams[j][i]);
        }
    }

    // Free allocated memory
    for (int i = 0; i < n; ++i) {
        free(genders[i]);
    }
    free(ids);
    free(genders);
    free(grades);
    free(ages);
    free(scores);

    for (int i = 0; i < m; ++i) {
        free(olympiads[i]);
        free(teams[i]);
        for (int j = 0; j < n; ++j) {
            free(results[i][j]);
        }
        free(results[i]);
    }
    free(olympiads);
    free(teams);
    free(results);

    return 0;
}

int determine_team_size(char olympiad[], int num_participants) {
    if (strcmp(olympiad, "IOI") == 0 || strcmp(olympiad, "CEOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else if (strcmp(olympiad, "EGOI") == 0 || strcmp(olympiad, "EJOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else if (strcmp(olympiad, "BaltOI") == 0) {
        return num_participants < 6 ? num_participants : 6;}
        }