from collections import defaultdict

def determine_team_size(olympiad, num_participants):
   if olympiad in ['IOI', 'CEOI']:
       return min(4, num_participants)
   elif olympiad == 'EGOI':
       return min(4, num_participants)
   elif olympiad == 'EJOI':
       return min(4, num_participants)
   elif olympiad == 'BaltOI':
       return min(6, num_participants)
   elif olympiad == 'BalkOI':
       return min(4, num_participants)
   elif olympiad == 'JBOI':
       return min(4, num_participants)
   else:
       return 0

def determine_team_participants(olympiads, participants):
   rez = defaultdict(list)

   for participant in participants:
       id, gender, grade, age, score = participant

       for olympiad in olympiads:
           if olympiad == 'IOI':
               rez['IOI'].append((score, id))
           elif olympiad == 'CEOI':
               rez['CEOI'].append((score, id))
           elif olympiad == 'EGOI' and gender == 'female':
               rez['EGOI'].append((score, id))
           elif olympiad == 'EJOI' and age <= 15:
               rez['EJOI'].append((score, id))
           elif olympiad == 'BaltOI':
               rez['BaltOI'].append((score, id))
           elif olympiad == 'BalkOI' and grade != 11:
               rez['BalkOI'].append((score, id))
           elif olympiad == 'JBOI' and grade < 11:
               rez['JBOI'].append((score, id))

   comand = {}

   for olympiad in olympiads:
       scores_ids = rez[olympiad]
       scores_ids.sort(key=lambda x: (-x[0], x[1]))  # Sort scores descending, IDs ascending

       team_size = determine_team_size(olympiad, len(scores_ids))

       comand[olympiad] = [participant[1] for participant in scores_ids[:team_size]]
       comand[olympiad].sort()

   return comand

n = int(input())
participants = []

for _ in range(n):
   date = input().split()
   id, gender, grade, age, score = int(date[0]), date[1], int(date[2]), int(date[3]), int(date[4])
   participants.append((id, gender, grade, age, score))

m = int(input())
olympiads = [input().strip() for _ in range(m)]

teams = determine_team_participants(olympiads, participants)

for olympiad in olympiads:
   print(olympiad)
   for participant in teams[olympiad]:
       print(participant)