import heapq

def choose_colors(n, m, a):
    # Initialize the priority queue with the sequences of unmarked colors
    queue = [(-(ai+1)//2, -(ai+1)) for ai in a]
    heapq.heapify(queue)
    
    # Select m colors
    for _ in range(m):
        length, total = heapq.heappop(queue)
        length = -length
        total = -total
        total -= 1
        if total > 0:
            heapq.heappush(queue, (-((total+1)//2), -total))
    
    # The length of the longest sequence in the queue is the answer
    if queue:
        return -queue[0][0]
    else:
        return 0

if __name__ == "__main__":
    n, m = map(int, input().split())
    a = list(map(int, input().split()))
    print(choose_colors(n, m, a))