from heapq import heappush, heappop

# Define a class to store participant information
class Participant:
    def __init__(self, id, gender, grade, age, score):
        self.id = id
        self.gender = gender
        self.grade = grade
        self.age = age
        self.score = score

# Read the input
n = int(input())
participants = []
for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append(Participant(int(id), gender, int(grade), int(age), int(score)))

m = int(input())
olympiads = [input() for _ in range(m)]

# Create dictionaries to store participants based on olympiad criteria
olympiad_participants = {'IOI': [], 'CEOI': [], 'EGOI': [], 'EJOI': [], 'BaltOI': [], 'BalkOI': [], 'JBOI': []}

# Sort participants based on scores
participants.sort(key=lambda x: x.score, reverse=True)

# Add participants to respective olympiad lists
for participant in participants:
    if participant.gender == 'female':
        olympiad_participants['EGOI'].append(participant.id)
    if participant.grade <= 10:
        olympiad_participants['EJOI'].append(participant.id)
    if participant.grade != 11:
        olympiad_participants['BalkOI'].append(participant.id)
    if participant.grade <= 10 and participant.age <= 15:
        olympiad_participants['JBOI'].append(participant.id)
    if participant.grade != 11 or participant.age == 11:
        olympiad_participants['CEOI'].append(participant.id)
    olympiad_participants['IOI'].append(participant.id)
    olympiad_participants['BaltOI'].append(participant.id)

# Print the results for each olympiad
for olympiad in olympiads:
    print(olympiad)
    heap = []
    for participant_id in olympiad_participants[olympiad]:
        heappush(heap, participant_id)
    while heap:
        print(heappop(heap))


