def find_optimal_move(weights, boxes):
    total_weight = sum(weights)
    max_weight = max(sum(weights[i] for i in range(4) if boxes[i] == 1),
                    sum(weights[i] for i in range(4) if boxes[i] == 2))

    if max_weight * 2 <= total_weight:
        return -1

    optimal_move = -1
    for i in range(4):
        for j in range(i + 1, 4):
            new_boxes = list(boxes)
            new_boxes[i], new_boxes[j] = new_boxes[j], new_boxes[i]  # Swap items i and j
            new_max_weight = max(sum(weights[i] for i in range(4) if new_boxes[i] == 1),
                                 sum(weights[i] for i in range(4) if new_boxes[i] == 2))

            if new_max_weight < max_weight:
                return i + 1  # Item numbering starts from 1
            elif optimal_move == -1:
                optimal_move = i + 1

    return optimal_move

if __name__ == "__main__":
    weights = list(map(int, input().split()))
    boxes = list(map(int, input().split()))

    move = find_optimal_move(weights, boxes)
    print(move)
