from collections import defaultdict

def get_team(participants, olympiad, num_teams):
    if olympiad in {"IOI", "CEOI", "BaltOI"}:
        participants.sort(key=lambda x: (-x[4], x[0]))
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        female_participants.sort(key=lambda x: (-x[4], x[0]))
        participants = female_participants
    elif olympiad == "EJOI":
        young_participants = [p for p in participants if p[3] <= 15]
        young_participants.sort(key=lambda x: (-x[4], x[0]))
        participants = young_participants
    elif olympiad == "BalkOI":
        non_11th_grade_participants = [p for p in participants if p[2] != 11]
        non_11th_grade_participants.sort(key=lambda x: (-x[4], x[0]))
        participants = non_11th_grade_participants
    elif olympiad == "JBOI":
        non_10th_11th_grade_participants = [p for p in participants if p[2] not in {10, 11}]
        non_10th_11th_grade_participants.sort(key=lambda x: (-x[4], x[0]))
        participants = non_10th_11th_grade_participants

    return participants[:num_teams]

def main():
    n = int(input())
    participants = []

    for _ in range(n):
        participant_info = input().split()
        participant_info[0] = int(participant_info[0])
        participant_info[3] = int(participant_info[3])
        participant_info[4] = int(participant_info[4])
        participants.append(participant_info)

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    team_members = defaultdict(list)

    for olympiad in olympiads:
        if olympiad not in team_members:
            num_teams = 4 if olympiad != "BaltOI" else 6
            team = get_team(participants.copy(), olympiad, num_teams)
            team_ids = [member[0] for member in team]
            team_members[olympiad] = team_ids

    for olympiad in olympiads:
        print(olympiad)
        for team_member_id in sorted(team_members[olympiad]):
            print(team_member_id)

if __name__ == "__main__":
    main()
