#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant &a, const Participant &b) {
    return a.score > b.score;
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

   
    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;


        vector<Participant> tempParticipants;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            tempParticipants = participants;
        } else if (olympiad == "EGOI") {
            for (const auto &participant : participants) {
                if (participant.gender == "female") {
                    tempParticipants.push_back(participant);
                }
            }
        } else if (olympiad == "EJOI") {
            for (const auto &participant : participants) {
                if (participant.age <= 15) {
                    tempParticipants.push_back(participant);
                }
            }
        } else if (olympiad == "BalkOI") {
            for (const auto &participant : participants) {
                if (participant.grade != 11) {
                    tempParticipants.push_back(participant);
                }
            }
        } else if (olympiad == "JBOI") {
            for (const auto &participant : participants) {
                if (participant.grade != 11 && participant.grade != 10) {
                    tempParticipants.push_back(participant);
                }
            }
        }
        sort(tempParticipants.begin(), tempParticipants.end(), [](const Participant &a, const Participant &b) {
            return a.id < b.id;
        });
        cout << olympiad << endl;
        for (const auto &participant : tempParticipants) {
            cout << participant.id << ' ';
        }
        cout << endl;
    }

    return 0;
}