from collections import defaultdict

def process_gift_requests(n, m, sizes, t_shirts, k, requests):
    available_t_shirts = defaultdict(list)
    remaining_t_shirts = defaultdict(int)

    for i in range(1, n + 1):
        for j in range(1, m + 1):
            size = sizes[j - 1]
            available_t_shirts[(i, size)].append(t_shirts[i - 1][j - 1])

    for i in range(k):
        color, size = requests[i]
        if available_t_shirts[(color, size)]:
            available_t_shirts[(color, size)].pop()
        else:
            found = False
            for new_size in sizes[sizes.index(size):]:
                if available_t_shirts[(color, new_size)]:
                    available_t_shirts[(color, new_size)].pop()
                    found = True
                    break
            if not found:
                for other_color in range(1, n + 1):
                    for new_size in sizes:
                        if available_t_shirts[(other_color, new_size)]:
                            available_t_shirts[(other_color, new_size)].pop()
                            found = True
                            break
                    if found:
                        break
                if not found:
                    remaining_t_shirts[(color, size)] += 1

    return available_t_shirts, remaining_t_shirts


def print_table(table):
    for row in table:
        print(" ".join(map(str, row)))


# Input
n, m = map(int, input().split())
sizes = input().split()
t_shirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [tuple(input().split()) for _ in range(k)]

# Process requests
available_t_shirts, remaining_t_shirts = process_gift_requests(n, m, sizes, t_shirts, k, requests)

# Output
for color in range(1, n + 1):
    print_table([available_t_shirts[(color, size)] for size in sizes])
    print_table([[remaining_t_shirts[(color, size)]] for size in sizes])
