# Step 1: Parse the input
n = int(input())
participants = []

for _ in range(n):
    info = input().split()
    participant = {
        'id': int(info[0]),
        'gender': info[1],
        'grade': int(info[2]),
        'age': int(info[3]),
        'score': int(info[4])
    }
    participants.append(participant)

# Step 2: Sort participants based on different criteria for each olympiad
sorted_participants = {
    'IOI': sorted(participants, key=lambda x: (-x['score'], x['id']))[:4],
    'CEOI': sorted(participants, key=lambda x: (-x['score'], x['id']))[:4],
    'EGOI': sorted([p for p in participants if p['gender'] == 'female'], key=lambda x: (-x['score'], x['id']))[:4],
    'EJOI': sorted([p for p in participants if p['age'] < 15], key=lambda x: (-x['score'], x['id']))[:4],
    'BaltOI': sorted(participants, key=lambda x: (-x['score'], x['id']))[:6],
    'BalkOI': sorted([p for p in participants if p['grade'] != 11], key=lambda x: (-x['score'], x['id']))[:4],
    'JBOI': sorted([p for p in participants if p['grade'] not in [11, 10]], key=lambda x: (-x['score'], x['id']))[:4],
}

# Step 3 and 4: Output the results for each requested olympiad
m = int(input())
requested_olympiads = [input().strip() for _ in range(m)]

for olympiad in requested_olympiads:
    print(olympiad)
    for participant in sorted_participants.get(olympiad, []):
        print(participant['id'])

