from collections import defaultdict


participants = defaultdict(list)


def select_IOI(participants_info):
    participants_info.sort(key=lambda x: x[4], reverse=True)
    return [participant[0] for participant in participants_info[:4]]

def select_CEOI(participants_info):
    participants_info.sort(key=lambda x: x[4], reverse=True)
    return [participant[0] for participant in participants_info[:4]]

def select_EGOI(participants_info):
    females = [participant for participant in participants_info if participant[1] == 'female']
    females.sort(key=lambda x: x[4], reverse=True)
    return [participant[0] for participant in females[:4]]

def select_EJOI(participants_info):
    juniors = [participant for participant in participants_info if participant[3] <= 15]
    juniors.sort(key=lambda x: x[4], reverse=True)
    return [participant[0] for participant in juniors[:4]]

def select_BaltOI(participants_info):
    participants_info.sort(key=lambda x: x[4], reverse=True)
    return [participant[0] for participant in participants_info[:6]]

def select_BalkOI(participants_info):
    non_eleven_graders = [participant for participant in participants_info if participant[2] != 11]
    non_eleven_graders.sort(key=lambda x: x[4], reverse=True)
    return [participant[0] for participant in non_eleven_graders[:4]]

def select_JBOI(participants_info):
    non_ten_or_eleven_graders = [participant for participant in participants_info if participant[2] not in [10, 11]]
    non_ten_or_eleven_graders.sort(key=lambda x: x[4], reverse=True)
    return [participant[0] for participant in non_ten_or_eleven_graders[:4]]


def select_teams(olympiads, participants_info):
    selected_teams = []
    for olympiad in olympiads:
        if olympiad == 'IOI':
            selected = select_IOI(participants_info)
            selected_teams.append((olympiad, selected))
        elif olympiad == 'CEOI':
            selected = select_CEOI(participants_info)
            selected_teams.append((olympiad, selected))
        elif olympiad == 'EGOI':
            selected = select_EGOI(participants_info)
            selected_teams.append((olympiad, selected))
        elif olympiad == 'EJOI':
            selected = select_EJOI(participants_info)
            selected_teams.append((olympiad, selected))
        elif olympiad == 'BaltOI':
            selected = select_BaltOI(participants_info)
            selected_teams.append((olympiad, selected))
        elif olympiad == 'BalkOI':
            selected = select_BalkOI(participants_info)
            selected_teams.append((olympiad, selected))
        elif olympiad == 'JBOI':
            selected = select_JBOI(participants_info)
            selected_teams.append((olympiad, selected))
    return selected_teams


n = int(input())


participants_info = []
for _ in range(n):
    info = input().split()
    info[0] = int(info[0])
    info[3] = int(info[3])
    info[4] = int(info[4])
    participants_info.append(info)


m = int(input())


olympiads = [input() for _ in range(m)]


teams = select_teams(olympiads, participants_info)
for olympiad, team in teams:
    print(olympiad)
    for participant in team:
        print(participant)
