using System;
using System.Collections.Generic;

class Solution
{
    static void Main(string[] args)
    {
        string[] sizes = Console.ReadLine().Split();
        int n = int.Parse(sizes[0]); // Number of different colors
        int m = sizes.Length; // Number of sizes
        int[,] tShirts = new int[n, m];
        for (int i = 0; i < n; i++)
        {
            string[] quantities = Console.ReadLine().Split();
            for (int j = 0; j < m; j++)
            {
                tShirts[i, j] = int.Parse(quantities[j]);
            }
        }
        int k = int.Parse(Console.ReadLine());
        Dictionary<string, List<int[]>> requests = new Dictionary<string, List<int[]>>();
        for (int i = 0; i < k; i++)
        {
            string[] request = Console.ReadLine().Split();
            int color = int.Parse(request[0]) - 1; // Adjusting color index
            string size = request[1];
            if (!requests.ContainsKey(size))
            {
                requests[size] = new List<int[]>();
            }
            requests[size].Add(new int[] { color, i });
        }
        int[,] remainingTShirts = new int[n, m];
        int[,] neededTShirts = new int[n, m];
        foreach (var kvp in requests)
        {
            string size = kvp.Key;
            int sizeIndex = Array.IndexOf(sizes, size);
            foreach (var req in kvp.Value)
            {
                int color = req[0];
                int winnerIndex = req[1];
                if (tShirts[color, sizeIndex] > 0)
                {
                    tShirts[color, sizeIndex]--;
                    remainingTShirts[color, sizeIndex]++;
                }
                else
                {
                    int newSizeIndex = sizeIndex;
                    while (newSizeIndex < m - 1)
                    {
                        newSizeIndex++;
                        if (tShirts[color, newSizeIndex] > 0)
                        {
                            tShirts[color, newSizeIndex]--;
                            remainingTShirts[color, newSizeIndex]++;
                            break;
                        }
                    }

                    if (newSizeIndex == m - 1)
                    {
                        neededTShirts[color, sizeIndex]++;
                    }
                }
            }
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                Console.Write(remainingTShirts[i, j] + " ");
            }
            Console.WriteLine();
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                Console.Write(neededTShirts[i, j] + " ");
            }
            Console.WriteLine();
        }
    }
}


  }
}
