# Reading input values
n, m = map(int, input().split())  # Number of colors and sizes
sizes = input().split()  # Sizes of T-shirts

# Initializing the counts of T-shirts of each color and size
t_shirts = []
for _ in range(n):
    t_shirts.append(list(map(int, input().split())))

# Reading the winners' requests
k = int(input())  # Number of winners
requests = []
for _ in range(k):
    color, size = input().split()
    requests.append((int(color), size))

# Initializing counts for superfluous and needed T-shirts
superfluous = [[0 for _ in range(m)] for _ in range(n)]
needed = [[0 for _ in range(m)] for _ in range(n)]

# Processing winners' requests
for color, size in requests:
    color -= 1  # Adjusting index
    size_index = sizes.index(size)  # Getting the index of the size
    found = False
    
    # Checking for requested T-shirt and satisfying the request
    for s in range(size_index, m):
        if t_shirts[color][s] > 0:
            t_shirts[color][s] -= 1
            found = True
            break
            
    # If not found, looking for another size
    if not found:
        for s in range(size_index):
            if t_shirts[color][s] > 0:
                t_shirts[color][s] -= 1
                superfluous[color][s] += 1
                found = True
                break
    
    # If still not found, looking for a larger size
    if not found:
        for s in range(m):
            if t_shirts[color][s] > 0:
                t_shirts[color][s] -= 1
                superfluous[color][s] += 1
                needed[color][s] += 1
                found = True
                break
    
    # If no suitable T-shirt found, recording it as needed
    if not found:
        needed[color][size_index] += 1

# Printing the superfluous and needed T-shirts
for row in superfluous:
    print(' '.join(map(str, row)))
for row in needed:
    print(' '.join(map(str, row)))
