using System;

class Solution {
    public static void Main(string[] args) {
        int n = 2; // Number of different colors
        int m = 3; // Number of sizes
        string[] sizes = { "S", "M", "XL" }; // Sizes of T-shirts
        int[,] availableTshirts = { { 1, 3, 0 }, { 3, 0, 3 } }; // Number of available T-shirts of each color and size
        int k = 9; // Number of winners
        (int color, string size)[] winners = { (1, "S"), (2, "XL"), (1, "M"), (2, "XL"), (1, "M"), (2, "M"), (1, "M"), (2, "S"), (1, "XL") }; // Winners' requests
        int[,] remainingTshirts = new int[n, m];
        int[,] requiredTshirts = new int[n, m];
        foreach (var winner in winners)
        {
            int color = winner.color - 1;
            int sizeIndex = Array.IndexOf(sizes, winner.size);

            if (availableTshirts[color, sizeIndex] > 0)
            {
                availableTshirts[color, sizeIndex]--;
            }
            else
            {
                bool found = false;
                for (int i = 0; i < n; i++)
                {
                    if (availableTshirts[i, sizeIndex] > 0)
                    {
                        availableTshirts[i, sizeIndex]--;
                        found = true;
                        break;
                   }
                }
                if (!found)
                {
                    for (int i = sizeIndex + 1; i < m; i++)
                    {
                        if (availableTshirts[color, i] > 0)
                        {
                            availableTshirts[color, i]--;
                            found = true;
                            break;
                        }
                    }
                }
                if (!found)
                {
                    requiredTshirts[color, sizeIndex]++;
                }
            }
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                Console.Write(availableTshirts[i, j] + " ");
            }
            Console.WriteLine();
        }

        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                Console.Write(requiredTshirts[i, j] + " ");
            }
            Console.WriteLine();
        }

    }
}
