#include <bits/stdc++.h>
using namespace std;
using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

class OlympiadTeamBuilder {
private:
    vector<Participant> participants;
public:
    OlympiadTeamBuilder(vector<Participant>& participants) : participants(participants) {}
    vector<Participant> buildTeam(string olympiadName) {
        vector<Participant> team;
        vector<Participant> sortedParticipants = participants;
        sort(sortedParticipants.begin(), sortedParticipants.end(), [](const Participant& a, const Participant& b) {
            return a.score > b.score;
        });
        if (olympiadName == "IOI" || olympiadName == "CEOI") {
            team = vector<Participant>(sortedParticipants.begin(), sortedParticipants.begin() + 4);
        } else if (olympiadName == "EGOI") {
            vector<Participant> femaleParticipants;
            for (const Participant& participant : participants) {
                if (participant.gender == "female") {
                    femaleParticipants.push_back(participant);
                }
            }
            sort(femaleParticipants.begin(), femaleParticipants.end(), [](const Participant& a, const Participant& b) {
                return a.score > b.score;
            });
            team = vector<Participant>(femaleParticipants.begin(), femaleParticipants.begin() + 4);
        } else if (olympiadName == "EJOI") {
            vector<Participant> youngParticipants;
            for (const Participant& participant : participants) {
                if (participant.age <= 15) {
                    youngParticipants.push_back(participant);
                }
            }
            sort(youngParticipants.begin(), youngParticipants.end(), [](const Participant& a, const Participant& b) {
                return a.score > b.score;
            });
            team = vector<Participant>(youngParticipants.begin(), youngParticipants.begin() + 4);
        } else if (olympiadName == "BaltOI") {
            team = vector<Participant>(sortedParticipants.begin(), sortedParticipants.begin() + 6);
        } else if (olympiadName == "BalkOI") {
            vector<Participant> non11GradeParticipants;
            for (const Participant& participant : participants) {
                if (participant.grade != 11) {
                    non11GradeParticipants.push_back(participant);
                }
            }
            sort(non11GradeParticipants.begin(), non11GradeParticipants.end(), [](const Participant& a, const Participant& b) {
                return a.score > b.score;
            });
            team = vector<Participant>(non11GradeParticipants.begin(), non11GradeParticipants.begin() + 4);
        } else if (olympiadName == "JBOI") {
            vector<Participant> non1110GradeParticipants;
            for (const Participant& participant : participants) {
                if (participant.grade != 11 && participant.grade != 10) {
                    non1110GradeParticipants.push_back(participant);
                }
            }
            sort(non1110GradeParticipants.begin(), non1110GradeParticipants.end(), [](const Participant& a, const Participant& b) {
                return a.score > b.score;
            });
            team = vector<Participant>(non1110GradeParticipants.begin(), non1110GradeParticipants.begin() + 4);
        }

        return team;
    }
};


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    cin >> m;

    vector<string> olympiads(m);
    for (int i = 0; i < m; ++i) {
        cin >> olympiads[i];
    }

    OlympiadTeamBuilder builder(participants);

    for (const string& olympiad : olympiads) {
        vector<Participant> team = builder.buildTeam(olympiad);
        cout<<olympiad << ":\n";
        for (const Participant& participant : team) {
            cout<< participant.id << "\n";
        }
        cout << "\n";
    }
}
