def process_gifts(colors, sizes, stock, requests):
    remaining_stock = [[stock[i][j] for j in range(len(sizes))] for i in range(len(colors))]
    additional_orders = [[0 for _ in range(len(sizes))] for _ in range(len(colors))]
    
    for request in requests:
        color_index = colors.index(request[1])
        size_index = sizes.index(request[2])
        
        if remaining_stock[color_index][size_index] > 0:
            remaining_stock[color_index][size_index] -= 1
        else:
            found_alternative = False
            for alt_size_index in range(size_index + 1, len(sizes)):
                if remaining_stock[color_index][alt_size_index] > 0:
                    remaining_stock[color_index][alt_size_index] -= 1
                    additional_orders[color_index][alt_size_index] += 1
                    found_alternative = True
                    break
            
            if not found_alternative:
                for larger_size_index in range(size_index + 1, len(sizes)):
                    for alt_color_index in range(color_index + 1, len(colors)):
                        if remaining_stock[alt_color_index][larger_size_index] > 0:
                            remaining_stock[alt_color_index][larger_size_index] -= 1
                            additional_orders[alt_color_index][larger_size_index] += 1
                            found_alternative = True
                            break
                    if found_alternative:
                        break
            
            if not found_alternative:
                additional_orders[color_index][size_index] += 1
    
    return remaining_stock, additional_orders

def print_table(table):
    for row in table:
        print(" ".join(map(str, row)))

if __name__ == "__main__":
    n, m = map(int, input().split())
    sizes = input().split()
    
    colors_stock = [list(map(int, input().split())) for _ in range(n)]
    
    k = int(input())
    requests = [input().split() for _ in range(k)]
    
    remaining_stock, additional_orders = process_gifts(list(range(1, n + 1)), sizes, colors_stock, requests)
    
    print_table(remaining_stock)
    print_table(additional_orders)
