from heapq import nlargest, nsmallest

def determine_team(olympiad, participants):
    if olympiad == 'IOI' or olympiad == 'CEOI':
        team = nlargest(4, participants, key=lambda x: x[4])
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p[1] == 'female']
        team = nlargest(4, female_participants, key=lambda x: x[4])
    elif olympiad == 'EJOI':
        young_participants = [p for p in participants if p[3] <= 15]
        team = nlargest(min(4, len(young_participants)), young_participants, key=lambda x: x[4])
    elif olympiad == 'BaltOI':
        team = nlargest(6, participants, key=lambda x: x[4])
    elif olympiad == 'BalkOI':
        not_11th_grade_participants = [p for p in participants if p[2] != 11]
        team = nlargest(4, not_11th_grade_participants, key=lambda x: x[4])
    elif olympiad == 'JBOI':
        not_10th_11th_grade_participants = [p for p in participants if p[2] not in {10, 11}]
        team = nlargest(4, not_10th_11th_grade_participants, key=lambda x: x[4])
    
    team_ids = sorted(p[0] for p in team)
    return team_ids

n = int(input())
participants = [list(map(str, input().split())) for _ in range(n)]

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    team_ids = determine_team(olympiad, participants)
    print(olympiad)
    print(*team_ids)
