def solve(weights, boxes):
  # Calculate the initial weights of each box
  box_weights = [0] * 2
  for i in range(4):
    box_weights[boxes[i] - 1] += weights[i]

  # Find the item to move
  item_to_move = None
  min_max_weight = float('inf')
  for i in range(4):
    for j in range(2):
      # Try moving item i to box j
      new_box_weights = box_weights.copy()
      new_box_weights[j] += weights[i]
      new_box_weights[(boxes[i] - 1) % 2] -= weights[i]
      max_weight = max(new_box_weights)

      # Update the minimum maximum weight and item to move if necessary
      if max_weight < min_max_weight:
        min_max_weight = max_weight
        item_to_move = i + 1

  # Return the item to move or -1 if no change is needed
  return item_to_move if item_to_move else -1

def main():
  # Read the input data
  weights = list(map(int, input().split()))
  boxes = list(map(int, input().split()))

  # Find the item to move
  item_to_move = solve(weights, boxes)

  # Print the result
  print(item_to_move)

if __name__ == "__main__":
  main()