#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> toOrder(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> toOrder[i][j];
        }
    }

    int k;
    cin >> k;

    map<pair<string, string>, int> requests;
    for (int i = 0; i < k; ++i) {
        int c;
        string size;
        cin >> c >> size;
        requests[{size, to_string(c)}]++;
    }

    vector<vector<int>> leftOver(n, vector<int>(m, 0));
    vector<vector<int>> toBuy(n, vector<int>(m, 0));

    for (auto const& [key, val] : requests) {
        string size = key.first;
        int count = stoi(key.second);

        bool found = false;
        for (int i = 0; i < n; ++i) {
            if (toOrder[i][0] >= count && sizes[0] == size) {
                toOrder[i][0] -= count;
                found = true;
                break;
            }
        }

        if (!found) {
            int sizeIndex = -1;
            for (int j = 0; j < m; ++j) {
                if (sizes[j] == size) {
                    sizeIndex = j;
                    break;
                }
            }

            if (sizeIndex == -1) continue;

            for (int i = 0; i < n; ++i) {
                if (toOrder[i][m - 1] > 0) {
                    toOrder[i][m - 1]--;
                    toOrder[i][sizeIndex]++;
                    break;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << toOrder[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (toOrder[i][j] < 0) {
                toBuy[i][j] = abs(toOrder[i][j]);
                toOrder[i][j] = 0;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << toBuy[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
