#include <iostream>
#include <vector>
#include <algorithm>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.score > p2.score || (p1.score == p2.score && p1.id < p2.id);
}

int main() {
    std::vector<Participant> participants;
    int n;
    std::cin >> n;

    for (int i = 0; i < n; ++i) {
        Participant p;
        std::cin >> p.id >> p.gender >> p.grade >> p.age >> p.score;
        participants.push_back(p);
    }

    int m;
    std::cin >> m;
    std::vector<std::string> olympiads(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> olympiads[i];
    }

    for (const auto& olympiad : olympiads) {
        if (olympiad == "IOI" || olympiad == "CEOI") {
            std::partial_sort(participants.begin(), participants.begin() + 4, participants.end(), compareParticipants);
            std::cout << olympiad << std::endl;
            for (int i = 0; i < 4; ++i) {
                std::cout << participants[i].id << std::endl;
            }
        } else if (olympiad == "EGOI") {
            std::vector<Participant> femaleParticipants;
            for (const auto& p : participants) {
                if (p.gender == "female") {
                    femaleParticipants.push_back(p);
                }
            }
            std::partial_sort(femaleParticipants.begin(), femaleParticipants.begin() + 4, femaleParticipants.end(), compareParticipants);
            std::cout << olympiad << std::endl;
            for (int i = 0; i < std::min(4, static_cast<int>(femaleParticipants.size())); ++i) {
                std::cout << femaleParticipants[i].id << std::endl;
            }
        } 
        // Додайте аналогічні умови для інших олімпіад
        
    }

    return 0;
}
