#include <iostream>
#include <vector>
#include <map>
#include <algorithm> // Доданий заголовок

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant &a, const Participant &b) {
    return a.score > b.score;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    std::map<std::string, std::vector<int>> teams;
    for (int i = 0; i < m; ++i) {
        std::string olympiad;
        std::cin >> olympiad;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "EGOI" || olympiad == "BaltOI" || olympiad == "BalkOI" || olympiad == "JBOI") {
            std::vector<Participant> temp = participants;

            if (olympiad == "IOI" || olympiad == "CEOI") {
                std::sort(temp.begin(), temp.end(), compareParticipants);
                temp.resize(4);
            } else if (olympiad == "EGOI") {
                std::sort(temp.begin(), temp.end(), compareParticipants);
                temp.erase(std::remove_if(temp.begin(), temp.end(), [](const Participant &p) { return p.gender != "female"; }), temp.end());
                temp.resize(std::min(4, static_cast<int>(temp.size())));
            } else if (olympiad == "EJOI") {
                std::sort(temp.begin(), temp.end(), compareParticipants);
                temp.erase(std::remove_if(temp.begin(), temp.end(), [](const Participant &p) { return p.age > 15; }), temp.end());
                temp.resize(std::min(4, static_cast<int>(temp.size())));
            } else if (olympiad == "BaltOI") {
                std::sort(temp.begin(), temp.end(), compareParticipants);
                temp.resize(6);
            } else if (olympiad == "BalkOI") {
                std::sort(temp.begin(), temp.end(), compareParticipants);
                temp.erase(std::remove_if(temp.begin(), temp.end(), [](const Participant &p) { return p.grade == 11; }), temp.end());
                temp.resize(std::min(4, static_cast<int>(temp.size())));
            } else if (olympiad == "JBOI") {
                std::sort(temp.begin(), temp.end(), compareParticipants);
                temp.erase(std::remove_if(temp.begin(), temp.end(), [](const Participant &p) { return p.grade >= 10; }), temp.end());
                temp.resize(std::min(4, static_cast<int>(temp.size())));
            }

            std::vector<int> teamIds;
            for (const auto &participant : temp) {
                teamIds.push_back(participant.id);
            }
            teams[olympiad] = teamIds;
        }
    }

    for (int i = 0; i < m; ++i) {
        std::string olympiad;
        std::cin >> olympiad;

        if (teams.find(olympiad) != teams.end()) {
            std::cout << olympiad << std::endl;
            for (const auto &id : teams[olympiad]) {
                std::cout << id << std::endl;
            }
        }
    }

    return 0;
}