#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

struct Competitor {
    int id, grade, age, score;
    std::string gender;
};

// Функція для фільтрації учасників за критеріями для кожної олімпіади
std::map<std::string, std::vector<int>> getTeams(std::vector<Competitor>& competitors, std::vector<std::string>& olympiads) {
    std::map<std::string, std::vector<int>> teams;

    for (const auto& olympiad : olympiads) {
        if (olympiad == "IOI" || olympiad == "CEOI") {
            std::sort(competitors.begin(), competitors.end(), [](const Competitor& a, const Competitor& b) {
                return (a.score > b.score || (a.score == b.score && a.id < b.id));
            });
            std::vector<int> filtered;
            for (const auto& competitor : competitors) {
                if (filtered.size() == 4) break;
                filtered.push_back(competitor.id);
            }
            teams[olympiad] = filtered;
        } else if (olympiad == "EGOI") {
            std::sort(competitors.begin(), competitors.end(), [](const Competitor& a, const Competitor& b) {
                return ((a.gender == "female") && (a.score > b.score || (a.score == b.score && a.id < b.id)));
            });
            std::vector<int> filtered;
            for (const auto& competitor : competitors) {
                if (competitor.gender == "female" && filtered.size() == 4) break;
                if (competitor.gender == "female") filtered.push_back(competitor.id);
            }
            teams[olympiad] = filtered;
        }
        // Додайте решту умов для інших олімпіад
        // ...
    }

    return teams;
}

int main() {
    int n; // Кількість учасників
    std::cin >> n;

    std::vector<Competitor> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m; // Кількість олімпіад
    std::cin >> m;

    std::vector<std::string> olympiads(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> olympiads[i];
    }

    std::map<std::string, std::vector<int>> teams = getTeams(participants, olympiads);

    for (const auto& olympiad : olympiads) {
        std::cout << olympiad << std::endl;
        for (const auto& participant : teams[olympiad]) {
            std::cout << participant << std::endl;
        }
    }

    return 0;
}
