#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

struct Competitor {
    int id, grade, age, score;
    std::string gender;
};

std::map<std::string, std::vector<int>> getTeams(std::vector<Competitor>& competitors, std::vector<std::string>& olympiads) {
    std::map<std::string, std::vector<int>> teams;

    for (const auto& olympiad : olympiads) {
        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            std::sort(competitors.begin(), competitors.end(), [](const Competitor& a, const Competitor& b) {
                return (a.score > b.score || (a.score == b.score && a.id < b.id));
            });
            std::vector<int> filtered;
            int count = (olympiad == "BaltOI") ? 6 : 4;
            for (const auto& competitor : competitors) {
                if (filtered.size() == count) break;
                filtered.push_back(competitor.id);
            }
            teams[olympiad] = filtered;
        } else if (olympiad == "EGOI" || olympiad == "EJOI" || olympiad == "BalkOI") {
            std::sort(competitors.begin(), competitors.end(), [](const Competitor& a, const Competitor& b) {
                return ((a.gender == "female" && a.score > b.score) || (a.gender == "female" && a.score == b.score && a.id < b.id));
            });
            std::vector<int> filtered;
            int count = (olympiad == "EJOI") ? 4 : 6;
            for (const auto& competitor : competitors) {
                if (competitor.gender == "female" && filtered.size() == count) break;
                if (competitor.gender == "female") filtered.push_back(competitor.id);
            }
            teams[olympiad] = filtered;
        } else if (olympiad == "JBOI") {
            std::sort(competitors.begin(), competitors.end(), [](const Competitor& a, const Competitor& b) {
                return (((a.grade != 11 && a.grade != 10) && a.score > b.score) || ((a.grade != 11 && a.grade != 10) && a.score == b.score && a.id < b.id));
            });
            std::vector<int> filtered;
            for (const auto& competitor : competitors) {
                if ((competitor.grade != 11 && competitor.grade != 10) && filtered.size() == 4) break;
                if (competitor.grade != 11 && competitor.grade != 10) filtered.push_back(competitor.id);
            }
            teams[olympiad] = filtered;
        }
        // Додайте решту умов для інших олімпіад
        // ...
    }

    return teams;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Competitor> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    std::vector<std::string> olympiads(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> olympiads[i];
    }

    std::map<std::string, std::vector<int>> teams = getTeams(participants, olympiads);

    for (const auto& olympiad : olympiads) {
        std::cout << olympiad << std::endl;
        for (const auto& participant : teams[olympiad]) {
            std::cout << participant << std::endl;
        }
    }

    return 0;
}
