#include <iostream>
using namespace std;

struct node {
    int id;
    string gender;
    int grade;
    int age;
    int score;
}contestants[10003];
int n, massiv[6], k;
string a;

void quicksort_contestants(int low, int high) {
    int i = low;
    int j = high;
    int pivot = contestants[(i + j) / 2].score;
    while (i <= j) {
        while (contestants[i].score > pivot) {
            i++;
        }
        while (contestants[j].score < pivot) {
            j--;
        }
        if (i <= j) {
            node temp = contestants[i];
            contestants[i] = contestants[j];
            contestants[j] = temp;
            i++;
            j--;
        }
    }
    if (i < high) {
        quicksort_contestants(i, high);
    }
    if (j > low) {
        quicksort_contestants(low, j);
    }
}

void quicksort_winners(int low, int high) {
    int i = low;
    int j = high;
    int pivot = massiv[(i + j) / 2];
    while (i <= j) {
        while (massiv[i] < pivot) {
            i++;
        }
        while (massiv[j] > pivot) {
            j--;
        }
        if (i <= j) {
            int temp = massiv[i];
            massiv[i] = massiv[j];
            massiv[j] = temp;
            i++;
            j--;
        }
    }
    if (i < high) {
        quicksort_winners(i, high);
    }
    if (j > low) {
        quicksort_winners(low, j);
    }
}

void IOI() {
    cout << "IOI" << '\n';
    int index = 0;
    int i = 0;
    while (index < 4 && i < n) {
        massiv[index] = contestants[i].id;
        i++;
        index++;
    }
    quicksort_winners(0, index - 1);
    for (int i = 0; i < index; i++) {
        cout << massiv[i] << '\n';
    }
    return;
}

void CEOI() {
    cout << "CEOI" << '\n';
    int index = 0;
    int i = 0;
    while (index < 4 && i < n) {
        massiv[index] = contestants[i].id;
        i++;
        index++;
    }
    quicksort_winners(0, index - 1);
    for (int i = 0; i < index; i++) {
        cout << massiv[i] << '\n';
    }
    return;
}

void EGOI() {
    cout << "EGOI" << '\n';
    int index = 0;
    int i = 0;
    while (index < 4 && i < n) {
        if (contestants[i].gender == "female") {
            massiv[index] = contestants[i].id;
            index++;
        }
        i++;
    }
    quicksort_winners(0, index - 1);
    for (int i = 0; i < index; i++) {
        cout << massiv[i] << '\n';
    }
    return;
}

void EJOI() {
    cout << "EJOI" << '\n';
    int index = 0;
    int i = 0;
    while (index < 4 && i < n) {
        if (contestants[i].age <= 15) {
            massiv[index] = contestants[i].id;
            index++;
        }
        i++;
    }
    quicksort_winners(0, index - 1);
    for (int i = 0; i < index; i++) {
        cout << massiv[i] << '\n';
    }
    return;
}

void BaltOI() {
    cout << "BaltOI" << '\n';
    int index = 0;
    int i = 0;
    while (index < 6 && i < n) {
        massiv[index] = contestants[i].id;
        i++;
        index++;
    }
    quicksort_winners(0, index - 1);
    for (int i = 0; i < index; i++) {
        cout << massiv[i] << '\n';
    }
    return;
}

void BalkOI() {
    cout << "BalkOI" << '\n';
    int index = 0;
    int i = 0;
    while (index < 4 && i < n) {
        if (contestants[i].grade != 11) {
            massiv[index] = contestants[i].id;
            index++;
        }
        i++;
    }
    quicksort_winners(0, index - 1);
    for (int i = 0; i < index; i++) {
        cout << massiv[i] << '\n';
    }
    return;
}

void JBOI() {
    cout << "JBOI" << '\n';
    int index = 0;
    int i = 0;
    while (index < 4 && i < n) {
        if (contestants[i].grade < 10) {
            massiv[index] = contestants[i].id;
            index++;
        }
        i++;
    }
    quicksort_winners(0, index - 1);
    for (int i = 0; i < index; i++) {
        cout << massiv[i] << '\n';
    }
    return;
}

int main()
{
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> contestants[i].id;
        cin >> contestants[i].gender;
        cin >> contestants[i].grade >> contestants[i].age >> contestants[i].score;
    }
    quicksort_contestants(0, n - 1);
    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> a;
        if (a == "IOI") {
            IOI();
        }
        else if (a == "CEOI") {
            CEOI();
        }
        else if (a == "EGOI") {
            EGOI();
        }
        else if (a == "EJOI") {
            EJOI();
        }
        else if (a == "BaltOI") {
            BaltOI();
        }
        else if (a == "BalkOI") {
            BalkOI();
        }
        else if (a == "JBOI") {
            JBOI();
        }
    }
}