#include <iostream>
#include <vector>
#include <string>
#include <map>
using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    map<string, int> sizeMap;
    vector<string> sizes = {"XS", "S", "M", "L", "XL", "2XL"};
    for (int i = 0; i < m; ++i) {
        string size;
        cin >> size;
        sizeMap[size] = i;
    }

    vector<vector<int>> shirts(n, vector<int>(m));
    vector<vector<int>> extraShirts(n, vector<int>(m, 0));
    vector<vector<int>> neededShirts(n, vector<int>(m, 0));

    // Reading the available shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> shirts[i][j];
        }
    }

    int k;
    cin >> k;
    for (int i = 0; i < k; ++i) {
        int color;
        string size;
        cin >> color >> size;
        --color;
        int sizeIndex = sizeMap[size];

        // Find a shirt for the participant
        bool found = false;
        for (int j = sizeIndex; j < m && !found; ++j) {
            if (shirts[color][j] > 0) {
                --shirts[color][j];
                found = true;
            }
        }

        if (!found) {
            neededShirts[color][sizeIndex]++;
        }
    }

    // Calculate extra shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            extraShirts[i][j] = shirts[i][j];
        }
    }

    // Output the remaining shirts
    for (const auto& row : extraShirts) {
        for (int val : row) {
            cout << val << " ";
        }
        cout << endl;
    }

    // Output the needed shirts
    for (const auto& row : neededShirts) {
        for (int val : row) {
            cout << val << " ";
        }
        cout << endl;
    }

    return 0;
}

