#include <iostream>
#include <vector>
#include <string>
#include <map>

int main() {
    int n, m, k;
    std::cin >> n >> m;
    std::vector<std::string> sizes(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
    }

    std::map<std::string, int> sizeIndex;
    for (int i = 0; i < m; ++i) {
        sizeIndex[sizes[i]] = i;
    }

    std::vector<std::vector<int>> inventory(n, std::vector<int>(m));
    std::vector<std::vector<int>> order(n, std::vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> inventory[i][j];
        }
    }

    std::cin >> k;
    while (k--) {
        int color;
        std::string size;
        std::cin >> color >> size;
        color--;

        bool fulfilled = false;
        int sIdx = sizeIndex[size];

        if (inventory[color][sIdx] > 0) {
            inventory[color][sIdx]--;
            fulfilled = true;
        } else {

            for (int i = 0; i < n && !fulfilled; ++i) {
                if (inventory[i][sIdx] > 0) {
                    inventory[i][sIdx]--;
                    fulfilled = true;
                }
            }

            for (int sz = sIdx + 1; sz < m && !fulfilled; ++sz) {
                if (inventory[color][sz] > 0) {
                    inventory[color][sz]--;
                    fulfilled = true;
                } else {
                    for (int i = 0; i < n && !fulfilled; ++i) {
                        if (inventory[i][sz] > 0) {
                            inventory[i][sz]--;
                            fulfilled = true;
                        }
                    }
                }
            }
        }

        if (!fulfilled) {
            order[color][sIdx]++;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << inventory[i][j] << " ";
        }
        std::cout << std::endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << order[i][j] << " ";
        }
        std::cout << std::endl;
    }

    return 0;
}
