from collections import defaultdict

# Function to find the T-shirts based on the algorithm
def find_tshirts(n, m, sizes, tshirts, winners):
    remaining = defaultdict(lambda: defaultdict(int))
    needed = defaultdict(lambda: defaultdict(int))

    for color, size in winners:
        size_index = sizes.index(size)
        found = False

        # Check for the requested size and color
        if tshirts[color - 1][size_index] > 0:
            remaining[color][size_index] += 1
            tshirts[color - 1][size_index] -= 1
            found = True

        # If not found, check for larger sizes based on color priority
        if not found:
            for next_size in range(size_index + 1, m):
                if tshirts[color - 1][next_size] > 0:
                    remaining[color][next_size] += 1
                    tshirts[color - 1][next_size] -= 1
                    found = True
                    break

        # If still not found, check for any available size regardless of color
        if not found:
            for c in range(n):
                for next_size in range(size_index, m):
                    if tshirts[c][next_size] > 0:
                        remaining[c + 1][next_size] += 1
                        tshirts[c][next_size] -= 1
                        found = True
                        break
                if found:
                    break

        # If still not found, mark as needed
        if not found:
            needed[color][size_index] += 1

    return remaining, needed

# Reading input
n, m = map(int, input().split())
sizes = input().split()
tshirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(map(lambda x: int(x) if x.isdigit() else x, input().split())) for _ in range(k)]

# Getting the result
remaining, needed = find_tshirts(n, m, sizes, tshirts, winners)

# Printing remaining T-shirts
for color in range(n):
    print(*[remaining[color].get(size, 0) for size in range(m)])

# Printing T-shirts needed to be purchased
for color in range(n):
    print(*[needed[color].get(size, 0) for size in range(m)])
