import heapq

def max_unmarked_sequence_length(n, m, a):
    total_colors = sum(a)
    if m >= total_colors:
        return n * (max(a) + 1)

    odd_lengths = [-((ai + 1) // 2) for ai in a]
    even_lengths = [-ai // 2 for ai in a]

    heapq.heapify(odd_lengths)
    heapq.heapify(even_lengths)

    max_length = 0

    for _ in range(m):
        if odd_lengths and even_lengths:
            odd_length = -heapq.heappop(odd_lengths)
            even_length = -heapq.heappop(even_lengths)

            if odd_length % 2 == 1:
                max_length = max(max_length, odd_length)
                heapq.heappush(odd_lengths, -((odd_length + 1) // 2))
                heapq.heappush(even_lengths, -even_length // 2)
            else:
                max_length = max(max_length, even_length)
                heapq.heappush(odd_lengths, -odd_length // 2)
                heapq.heappush(even_lengths, -((even_length + 1) // 2))
        elif odd_lengths:
            odd_length = -heapq.heappop(odd_lengths)
            max_length = max(max_length, odd_length)
            heapq.heappush(odd_lengths, -((odd_length + 1) // 2))
        elif even_lengths:
            even_length = -heapq.heappop(even_lengths)
            max_length = max(max_length, even_length)
            heapq.heappush(even_lengths, -even_length // 2)

    return max_length

# Read input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output the result
result = max_unmarked_sequence_length(n, m, a)
print(result)
