import heapq

def max_unmarked_sequence(n, m, wheels):
    total_colors = sum(wheels)
    unmarked_sequence = [-(a + 1) for a in wheels]  # Use negative values for max heap
    heapq.heapify(unmarked_sequence)

    while m > 0:
        length = -heapq.heappop(unmarked_sequence)
        if length % 2 == 1:
            middle = (length + 1) // 2
            m -= 1
        else:
            middle = length // 2
            m -= 2

        if m <= 0:
            return total_colors + m

        for _ in range(middle - 1):
            heapq.heappush(unmarked_sequence, -middle)

    return total_colors

# Input parsing
n, m = map(int, input().split())
wheels = list(map(int, input().split()))

# Output
print(max_unmarked_sequence(n, m, wheels))
