def max_unmarked_sequence_length(n, m, a):
    max_seq_length = max(a)  # Initial maximum sequence length

    total_colors = sum(a)
    remaining_colors = m + n

    if remaining_colors <= total_colors:
        return max_seq_length  # If all colors can be picked, return the max_seq_length

    remaining_picks = remaining_colors - total_colors

    # Calculate the additional length of the sequence based on the remaining picks
    additional_seq_length = remaining_picks // n * max_seq_length

    # Calculate the remaining picks after the whole sequences are exhausted
    remaining_picks %= n

    # Calculate the remaining sequence lengths for the remaining picks
    remaining_seqs = sorted(a)[:remaining_picks]
    if remaining_seqs:
        additional_seq_length += remaining_seqs[-1]

    return additional_seq_length

# Reading input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Calculate and print the maximum length of the sequence of unmarked colors
result = max_unmarked_sequence_length(n, m, a)
print(result)
