def max_unmarked_sequence(n, m, wheel_sizes):
    # Initialize the sequence of unmarked colors
    unmarked_sequence = [size - 1 for size in wheel_sizes]

    # Function to find the longest unmarked sequence
    def find_longest_sequence():
        longest_sequence = max(unmarked_sequence)
        return [i for i, length in enumerate(unmarked_sequence) if length == longest_sequence]

    # Function to choose the next color
    def choose_next_color(sequence):
        middle = len(sequence) // 2
        chosen_index = sequence[middle]
        unmarked_sequence[chosen_index] -= 1
        return chosen_index

    # Simulate Miss M's color selection process
    for _ in range(m):
        longest_sequence_indices = find_longest_sequence()
        chosen_wheel = longest_sequence_indices[0]  # Choose the first in case of a tie
        choose_next_color(longest_sequence_indices)

    # Calculate the maximum length of the unmarked sequence
    max_length = max(unmarked_sequence)

    return max_length

# Input
n, m = map(int, input().split())
wheel_sizes = list(map(int, input().split()))

# Call the function
result = max_unmarked_sequence(n, m, wheel_sizes)

