import math

class Field:
    def __init__(self, rows, cols):
        self.rows = rows
        self.cols = cols

class Robot:
    def __init__(self, field):
        self.field = field

    def get_max_flowers(self):
        max_flowers = 0
        max_iterations = self.field.rows * self.field.cols

        for iterations in range(1, max_iterations + 1):
            total_flowers = 0

            for row in range(self.field.rows):
                for col in range(self.field.cols):
                    if (row + col) % iterations == 0:
                        total_flowers += 1

            max_flowers = max(max_flowers, total_flowers)

        return max_flowers

field = Field(2, 5) # Example of a field with 2 rows and 5 columns
robot = Robot(field)
max_flowers = robot.get_max_flowers()
print(f"{max_flowers}")