def process_olympiad(participants, olympiad_type):
    qualified_participants = []

    if olympiad_type == "IOI":
        qualified_participants = sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad_type == "CEOI":
        qualified_participants = sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad_type == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        qualified_participants = sorted(female_participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad_type == "EJOI":
        young_participants = [p for p in participants if p[3] <= 15]
        qualified_participants = sorted(young_participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad_type == "BaltOI":
        qualified_participants = sorted(participants, key=lambda x: x[4], reverse=True)[:6]
    elif olympiad_type == "BalkOI":
        non_11th_grade_participants = [p for p in participants if p[2] != 11]
        qualified_participants = sorted(non_11th_grade_participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad_type == "JBOI":
        non_10th_11th_grade_participants = [p for p in participants if p[2] not in {10, 11}]
        qualified_participants = sorted(non_10th_11th_grade_participants, key=lambda x: x[4], reverse=True)[:4]

    return qualified_participants


# Input
n = int(input())
participants = [tuple(input().split()) for _ in range(n)]

m = int(input())
olympiads = [input() for _ in range(m)]

# Process each olympiad
for olympiad_type in olympiads:
    qualified_participants = process_olympiad(participants, olympiad_type)

    # Output results
    print(olympiad_type)
    for participant in sorted(qualified_participants, key=lambda x: x[0]):
        print(participant[0])
