#include <iostream>
#include <string>
#include <vector>
#include <map>

using namespace std;

int n, m, k;
map<string, int> sizes;
vector<vector<int>> stock, need;

int main() {
    cin >> n >> m;

    for (int i = 1; i <= m; i++) {
        string s;
        cin >> s;
        sizes[s] = i;
    }

    stock.resize(n + 1, vector<int>(m + 1, 0));
    need.resize(n + 1, vector<int>(m + 1, 0));

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            cin >> stock[i][j];

    cin >> k;

    for (int i = 0; i < k; i++) {
        int c;
        string s;
        cin >> c >> s;

        int sizeIdx = sizes[s];

        if (stock[c][sizeIdx] > 0) {
            stock[c][sizeIdx]--;
        }
        else {
            bool found = false;

            for (int j = sizeIdx + 1; j <= m; j++) {
                if (stock[c][j] > 0) {
                    stock[c][j]--;
                    need[c][j]++;
                    found = true;
                    break;
                }
            }

            if (!found) {
                for (int j = 1; j <= sizeIdx; j++) {
                    if (stock[c][j] > 0) {
                        stock[c][j]--;
                        need[c][j]++;
                        found = true;
                        break;
                    }
                }
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++)
            cout << stock[i][j] << ' ';
        cout << endl;
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++)
            cout << need[i][j] << ' ';
        cout << endl;
    }

    return 0;
}
