import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int m = scanner.nextInt();
        String[] sizes = new String[m];
        for (int i = 0; i < m; i++) {
            sizes[i] = scanner.next();
        }
        int[][] shirts = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                shirts[i][j] = scanner.nextInt();
            }
        }
        int k = scanner.nextInt();
        int[][] requests = new int[k][2];
        for (int i = 0; i < k; i++) {
            requests[i][0] = scanner.nextInt();
            requests[i][1] = getIndex(sizes, scanner.next());
        }
        scanner.close();

        int[][] remaining = new int[n][m];
        int[][] toOrder = new int[n][m];

        for (int i = 0; i < k; i++) {
            int color = requests[i][0] - 1;
            int size = requests[i][1];
            if (shirts[color][size] > 0) {
                shirts[color][size]--;
            } else {
                int nextSize = getNextSize(shirts, color, size);
                if (nextSize != -1) {
                    shirts[color][nextSize]--;
                    toOrder[color][nextSize]++;
                } else {
                    int nextColor = getNextColor(shirts, color, size);
                    if (nextColor != -1) {
                        shirts[nextColor][size]--;
                        toOrder[nextColor][size]++;
                    } else {
                        toOrder[color][size]++;
                    }
                }
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                remaining[i][j] = shirts[i][j];
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(remaining[i][j] + " ");
            }
            System.out.println();
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(toOrder[i][j] + " ");
            }
            System.out.println();
        }
    }

    private static int getIndex(String[] sizes, String size) {
        for (int i = 0; i < sizes.length; i++) {
            if (sizes[i].equals(size)) {
                return i;
            }
        }
        return -1;
    }

    private static int getNextSize(int[][] shirts, int color, int size) {
        for (int i = size + 1; i < shirts[color].length; i++) {
            if (shirts[color][i] > 0) {
                return i;
            }
        }
        return -1;
    }

    private static int getNextColor(int[][] shirts, int color, int size) {
        for (int i = color + 1; i < shirts.length; i++) {
            if (shirts[i][size] > 0) {
                return i;
            }
        }
        return -1;
    }
}