def process_gifts(n, m, sizes, available, winners):
    remaining_gifts = [[0] * m for _ in range(n)]
    required_gifts = [[0] * m for _ in range(n)]

    for i in range(len(winners)):
        color, size = winners[i][0], winners[i][1]
        color_index = colors.index(color)
        size_index = sizes.index(size)

        if available[color_index][size_index] > 0:
            available[color_index][size_index] -= 1
        else:
            found = False
            for j in range(size_index + 1, m):
                if available[color_index][j] > 0:
                    available[color_index][j] -= 1
                    found = True
                    break

            if not found:
                for j in range(size_index + 1, m):
                    if remaining_gifts[color_index][j] > 0:
                        remaining_gifts[color_index][j] -= 1
                        found = True
                        break

            if not found:
                for j in range(size_index + 1, m):
                    if required_gifts[color_index][j] > 0:
                        required_gifts[color_index][j] -= 1
                        found = True
                        break

            if not found:
                required_gifts[color_index][size_index] += 1

    return remaining_gifts, required_gifts


def print_table(table):
    for row in table:
        print(" ".join(map(str, row)))


# Read input
n, m = map(int, input().split())
sizes = input().split()
colors = [str(i) for i in range(1, n + 1)]

available_gifts = []
for _ in range(n):
    available_gifts.append(list(map(int, input().split())))

k = int(input())
winners = [input().split() for _ in range(k)]

# Process gifts
remaining, required = process_gifts(n, m, sizes, available_gifts, winners)

# Print output
print_table(remaining)
print_table(required)
