def find_item_to_move(weights, boxes): 
    # Calculate initial weights of boxes 
    box_1_weight = sum(weights[i] for i in range(4) if boxes[i] == 1) 
    box_2_weight = sum(weights[i] for i in range(4) if boxes[i] == 2) 
 
    # Calculate the max weight among the boxes 
    max_weight = max(box_1_weight, box_2_weight) 
 
    # Check each item and its effect on box weights 
    for i in range(4): 
        current_box = boxes[i] 
        other_box = 3 - current_box + 1  # Finding the other box 
        new_box_1_weight = box_1_weight + (current_box == 2) * weights[i] - (current_box == 1) * weights[i] 
        new_box_2_weight = box_2_weight + (current_box == 1) * weights[i] - (current_box == 2) * weights[i] 
        new_max_weight = max(new_box_1_weight, new_box_2_weight) 
 
        if new_max_weight < max_weight: 
            return i + 1  # Return the item index (1-based) 
 
    return -1  # No item needs to be moved 
 
# Take input 
weights = list(map(int, input().split())) 
boxes = list(map(int, input().split())) 
 
# Find the item to move 
result = find_item_to_move(weights, boxes) 
print(result)