def find_unused_and_needed(n, m, sizes, initial_counts, winners):
    available_counts = {size: [0] * n for size in sizes}
    needed_counts = {size: [0] * n for size in sizes}

    for i in range(n):
        for j in range(m):
            available_counts[sizes[j]][i] = initial_counts[i][j]

    for winner in winners:
        color, size = int(winner[0]) - 1, winner[1]
        if available_counts[size][color] > 0:
            available_counts[size][color] -= 1
        else:
            alt_color = min(range(n), key=lambda x: (available_counts[size][x], x))
            available_counts[size][alt_color] -= 1

        needed_counts[size][color] += 1

    return available_counts, needed_counts


def print_table(counts):
    for row in counts:
        print(" ".join(map(str, row)))


n, m = map(int, input().split())
sizes = input().split()
initial_counts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [tuple(input().split()) for _ in range(k)]

available_counts, needed_counts = find_unused_and_needed(n, m, sizes, initial_counts, winners)

print_table(available_counts.values())
print_table(needed_counts.values())
