import copy

def find_optimal_move(inventory, order, colors, sizes):
    remaining_inventory = copy.deepcopy(inventory)
    to_order = [[0] * len(sizes) for _ in range(len(colors))]

    for color, size in order:
        size_index = sizes.index(size)

        if remaining_inventory[color][size_index] > 0:
            remaining_inventory[color][size_index] -= 1
        else:
            alt_color = next((c for c in range(len(colors)) if remaining_inventory[c][size_index] > 0), None)
            if alt_color is not None:
                remaining_inventory[alt_color][size_index] -= 1
                to_order[alt_color][size_index] += 1
            else:
                alt_size_index = next((i for i in range(size_index + 1, len(sizes)) if remaining_inventory[color][i] > 0), None)
                if alt_size_index is not None:
                    remaining_inventory[color][alt_size_index] -= 1
                    to_order[color][alt_size_index] += 1
                else:
                    to_order[color][size_index] += 1

    return remaining_inventory, to_order

def main():
    n, m = map(int, input().split())
    sizes = input().split()
    colors = [i for i in range(n)]

    inventory = [list(map(int, input().split())) for _ in range(n)]

    k = int(input())
    orders = [input().split() for _ in range(k)]
    orders = [(int(color), size) for color, size in orders]  # Convert color to int

    remaining_inventory, to_order = find_optimal_move(inventory, orders, colors, sizes)

    for row in remaining_inventory:
        print(*row)

    for row in to_order:
        print(*row)

if __name__ == "__main__":
    main()

