def determine_team(participants, olympiad):
    if olympiad == 'IOI':
        return sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'CEOI':
        return sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'EGOI':
        females = [participant for participant in participants if participant[1] == 'female']
        return sorted(females, key=lambda x: x[4], reverse=True)[:min(4, len(females))]
    elif olympiad == 'EJOI':
        juniors = [participant for participant in participants if participant[3] <= 15]
        return sorted(juniors, key=lambda x: x[4], reverse=True)[:min(4, len(juniors))]
    elif olympiad == 'BaltOI':
        return sorted(participants, key=lambda x: x[4], reverse=True)[:6]
    elif olympiad == 'BalkOI':
        non_eleven_graders = [participant for participant in participants if participant[2] != 11]
        return sorted(non_eleven_graders, key=lambda x: x[4], reverse=True)[:min(4, len(non_eleven_graders))]
    elif olympiad == 'JBOI':
        non_eleven_or_ten_graders = [participant for participant in participants if participant[2] not in {10, 11}]
        return sorted(non_eleven_or_ten_graders, key=lambda x: x[4], reverse=True)[:min(4, len(non_eleven_or_ten_graders))]


def main():
    n = int(input())
    participants = [tuple(input().split()) for _ in range(n)]

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    for olympiad in olympiads:
        team = determine_team(participants, olympiad)
        print(olympiad)
        for member in sorted(team, key=lambda x: int(x[0])):
            print(member[0])


if __name__ == "__main__":
    main()
