def max_sequence_length(n, m, a):
    lengths = [ai for ai in a]  # Initial lengths of color sequences on each wheel
    remaining_colors = m

    while remaining_colors > 0:
        max_length = max(lengths)
        if max_length % 2 == 1:
            # If the maximum length is odd, choose the middle color
            remaining_colors -= 1
        else:
            # If the maximum length is even, choose one of the two middle colors
            remaining_colors -= min(max_length // 2, remaining_colors)

        # Update lengths after choosing colors
        lengths = [min(remaining_colors, length // 2) if length % 2 == 0 else length for length in lengths]

    return max(lengths)

# Read input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Print the result
result = max_sequence_length(n, m, a)
print(result)
