import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        long m = scanner.nextLong();
        long[] a = new long[n];

        for (int i = 0; i < n; i++) {
            a[i] = scanner.nextLong();
        }

        long result = findMaxSubarrayLength(n, m, a);
        System.out.println(result);
    }

    private static long findMaxSubarrayLength(int n, long m, long[] a) {
        long left = 1;
        long right = (long) 1e18;

        while (left < right) {
            long mid = (left + right + 1) / 2;

            if (check(n, m, a, mid)) {
                left = mid;
            } else {
                right = mid - 1;
            }
        }

        return left;
    }

    private static boolean check(int n, long m, long[] a, long length) {
        long additionalColors = m;
        for (int i = 0; i < n; i++) {
            additionalColors -= Math.max(0, a[i] - length + 1);
            if (additionalColors <= 0) {
                return true;
            }
        }
        return false;
    }
}

