def max_subarray_length(n, m, colors):
    left, right = 1, 10**18

    while left < right:
        mid = (left + right + 1) // 2

        if check_length(n, m, colors, mid):
            left = mid
        else:
            right = mid - 1

    return left


def check_length(n, m, colors, length):
    additional_colors = m
    for i in range(n):
        additional_colors -= max(0, colors[i] - length + 1)
        if additional_colors <= 0:
            return True
    return False


if __name__ == "__main__":
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    result = max_subarray_length(n, m, colors)
    print(result)



