from collections import defaultdict

def process_requests(t_shirts, requests):
    remaining_t_shirts = defaultdict(lambda: defaultdict(int))
    needed_t_shirts = defaultdict(lambda: defaultdict(int))

    for color, size in requests:
        if t_shirts[color][size] > 0:
            t_shirts[color][size] -= 1
        else:
            found_alternative = False
            for alt_color in range(1, len(t_shirts) + 1):
                if alt_color != color and t_shirts[alt_color][size] > 0:
                    t_shirts[alt_color][size] -= 1
                    found_alternative = True
                    break
            
            if not found_alternative:
                for alt_size in range(sizes.index(size) + 1, m):
                    alt_size_name = sizes[alt_size]
                    if t_shirts[color][alt_size_name] > 0:
                        t_shirts[color][alt_size_name] -= 1
                        found_alternative = True
                        break

                if not found_alternative:
                    for alt_size in range(sizes.index(size) + 1, m):
                        alt_size_name = sizes[alt_size]
                        for alt_color in range(1, len(t_shirts) + 1):
                            if alt_color != color and t_shirts[alt_color][alt_size_name] > 0:
                                t_shirts[alt_color][alt_size_name] -= 1
                                found_alternative = True
                                break
                        if found_alternative:
                            break
            
            if not found_alternative:
                needed_t_shirts[color][size] += 1

        remaining_t_shirts[color][size] += 1

    return remaining_t_shirts, needed_t_shirts


n, m = map(int, input().split())
sizes = input().split()
t_shirts = defaultdict(lambda: defaultdict(int))

for i in range(1, n + 1):
    t_shirts[i] = dict(zip(sizes, map(int, input().split())))

k = int(input())
requests = [tuple(input().split()) for _ in range(k)]

remaining_t_shirts, needed_t_shirts = process_requests(t_shirts, requests)


for color in range(1, n + 1):
    print(" ".join(str(remaining_t_shirts[color][size]) for size in sizes))

for color in range(1, n + 1):
    print(" ".join(str(needed_t_shirts[color][size]) for size in sizes))
