def process_tshirt_requests(n, m, sizes, tshirt_inventory, k, requests):
    remaining_tshirts = [row[:] for row in tshirt_inventory]
    needed_tshirts = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = requests[i]
        color = int(color) - 1  
        size_index = sizes.index(size)

        if remaining_tshirts[color][size_index] > 0:
            remaining_tshirts[color][size_index] -= 1
        else:
            found_alternative = False
            for alt_color in range(n):
                if alt_color != color and remaining_tshirts[alt_color][size_index] > 0:
                    remaining_tshirts[alt_color][size_index] -= 1
                    found_alternative = True
                    break

            for alt_size in range(size_index + 1, m):
                if any(remaining_tshirts[c][alt_size] > 0 for c in range(n)):
                    remaining_tshirts[color][alt_size] -= 1
                    found_alternative = True
                    break
                for alt_color in range(n):
                    if alt_color != color and remaining_tshirts[alt_color][alt_size] > 0:
                        remaining_tshirts[alt_color][alt_size] -= 1
                        found_alternative = True
                        break

                if found_alternative:
                    break

            if not found_alternative:
                needed_tshirts[color][size_index] += 1

    return remaining_tshirts, needed_tshirts


n, m = map(int, input().split())
sizes = input().split()
tshirt_inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [tuple(map(str, input().split())) for _ in range(k)]

remaining, needed = process_tshirt_requests(n, m, sizes, tshirt_inventory, k, requests)

for row in remaining:
    print(*row)

for row in needed:
    print(*row)
