def process_tshirt_requests(n, m, sizes, tshirt_inventory, k, requests):
    remaining_tshirts = [row[:] for row in tshirt_inventory]
    needed_tshirts = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = requests[i]
        color = int(color) - 1  
        size_index = sizes.index(size)

        print(f"\nProcessing request {i + 1}: Color {color + 1}, Size {size}")

        if remaining_tshirts[color][size_index] > 0:
            remaining_tshirts[color][size_index] -= 1
            print("Found requested T-shirt")
        else:
            print("Requested T-shirt not available. Trying alternatives...")

            print("After processing request:")
            print("Remaining T-shirts:")
            for row in remaining_tshirts:
                print(*row)
            print("Needed T-shirts:")
            for row in needed_tshirts:
                print(*row)

    return remaining_tshirts, needed_tshirts


n, m = map(int, input().split())
sizes = input().split()
tshirt_inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [tuple(map(str, input().split())) for _ in range(k)]

remaining, needed = process_tshirt_requests(n, m, sizes, tshirt_inventory, k, requests)

print("Remaining T-shirts after all requests:")
for row in remaining:
    print(*row)

print("Needed T-shirts after all requests:")
for row in needed:
    print(*row)
