from collections import defaultdict

def select_participants(participants, olympiad):
    selected_participants = []

    if olympiad == 'IOI' or olympiad == 'CEOI':
        selected_participants = sorted(participants, key=lambda x: (-x[4], x[0]))[:min(4, len(participants))]
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p[1] == 'female']
        selected_participants = sorted(female_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(female_participants))]
    elif olympiad == 'EJOI':
        under_15_participants = [p for p in participants if p[3] < 15]
        selected_participants = sorted(under_15_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(under_15_participants))]
    elif olympiad == 'BaltOI':
        selected_participants = sorted(participants, key=lambda x: (-x[4], x[0]))[:min(6, len(participants))]
    elif olympiad == 'BalkOI':
        non_11th_grade_participants = [p for p in participants if p[2] != 11]
        selected_participants = sorted(non_11th_grade_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(non_11th_grade_participants))]
    elif olympiad == 'JBOI':
        non_11th_10th_grade_participants = [p for p in participants if p[2] not in {10, 11}]
        selected_participants = sorted(non_11th_10th_grade_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(non_11th_10th_grade_participants))]

    return selected_participants

def main():
    n = int(input())
    participants = []

    for _ in range(n):
        participant_info = input().split()
        participants.append((int(participant_info[0]), participant_info[1], int(participant_info[2]), int(participant_info[3]), int(participant_info[4])))

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    participants_by_olympiad = defaultdict(list)

    for olympiad in olympiads:
        selected_participants = select_participants(participants, olympiad)
        participants_by_olympiad[olympiad] = selected_participants

    for olympiad, selected_participants in participants_by_olympiad.items():
        print(olympiad)
        for participant in selected_participants:
            print(participant[0])

if __name__ == "__main__":
    main()
