class BitaculandiaOlympiads:
    """
    Class to represent the different programming olympiads held in Bitaculandia.

    Attributes:
    - olympiads: list
        List of the seven programming olympiads held in Bitaculandia.
    """

    def __init__(self):
        """
        Constructor to initialize the BitaculandiaOlympiads class.

        Initializes the list of olympiads with their names.
        """

        self.olympiads = [
            "IOI - International Olympiad in Informatics",
            "CEOI - Central-Eventora Olympiad in Informatics",
            "EGOI - Eventora Girls Olympiad in Informatics",
            "EJOI - Eventora Junior Olympiad in Informatics",
            "BaltOI - Balticodian Olympiad in Informatics",
            "BalkOI - Balkolian Olympiad in Informatics",
            "JBOI - Junior Balkolian Olympiad in Informatics"
        ]

    def get_olympiads(self):
        """
        Returns the list of programming olympiads held in Bitaculandia.

        Returns:
        - list:
            List of the seven programming olympiads.
        """

        return self.olympiads



bitaculandia_olympiads = BitaculandiaOlympiads()

olympiads_list = bitaculandia_olympiads.get_olympiads()

#print("Programming Olympiads in Bitaculandia:")
for olympiad in olympiads_list:
    print(olympiad)