#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& a, const Participant& b) {
    return a.score > b.score; // Сортування за балами у спадаючому порядку
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        vector<int> teamIds;

        if (olympiad == "IOI" || olympiad == "CEOI") {
            for (int j = 0; j < min(4, n); ++j) {
                teamIds.push_back(participants[j].id);
            }
        }
        else if (olympiad == "EGOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; ++j) {
                if (participants[j].gender == "female") {
                    teamIds.push_back(participants[j].id);
                    count++;
                }
            }
        }
        else if (olympiad == "EJOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; ++j) {
                if (participants[j].age <= 15) {
                    teamIds.push_back(participants[j].id);
                    count++;
                }
            }
        }
        else if (olympiad == "BaltOI") {
            for (int j = 0; j < min(6, n); ++j) {
                teamIds.push_back(participants[j].id);
            }
        }
        else if (olympiad == "BalkOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; ++j) {
                if (participants[j].grade != 11) {
                    teamIds.push_back(participants[j].id);
                    count++;
                }
            }
        }
        else if (olympiad == "JBOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; ++j) {
                if (participants[j].grade != 11 && participants[j].grade != 10) {
                    teamIds.push_back(participants[j].id);
                    count++;
                }
            }
        }

        cout << olympiad << "\n";
        sort(teamIds.begin(), teamIds.end());
        for (int id : teamIds) {
            cout << id << "\n";;
        }
    }

    return 0;
}
