def main():
    n = int(input())
    participants = []
    for _ in range(n):
        id, gender, grade, age, score = input().split()
        participants.append({'id': int(id), 'gender': gender, 'grade': int(grade), 'age': int(age), 'score': int(score)})

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    for olympiad in olympiads:
        algorithm = get_algorithm(olympiad)
        teams = algorithm(participants)
        print_team(teams)


def get_algorithm(olympiad):
    if olympiad == 'IOI':
        return lambda participants: sorted(participants, key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'CEOI':
        return lambda participants: sorted(participants, key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'EGOI':
        return lambda participants: sorted([p for p in participants if p['gender'] == 'female'], key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'EJOI':
        return lambda participants: sorted([p for p in participants if p['age'] <= 15], key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'BaltOI':
        return lambda participants: sorted(participants, key=lambda x: x['score'], reverse=True)[:6]
    elif olympiad == 'BalkOI':
        return lambda participants: sorted([p for p in participants if p['grade'] != 11], key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'JBOI':
        return lambda participants: sorted([p for p in participants if p['grade'] not in {10, 11}], key=lambda x: x['score'], reverse=True)[:4]


def print_team(team):
    print(*[participant['id'] for participant in team])


if __name__ == "__main__":
    main()