def main():
    n = int(input())
    participants = []

    for _ in range(n):
        id, gender, grade, age, score = input().split()
        participants.append({'id': int(id), 'gender': gender, 'grade': int(grade), 'age': int(age), 'score': int(score)})

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    for olympiad in olympiads:
        teams = get_team(participants, olympiad)
        print_team(teams)


def get_team(participants, olympiad):
    if olympiad in ['IOI', 'CEOI', 'BaltOI']:
        key = 'score'
    elif olympiad in ['EGOI', 'EJOI']:
        key = 'score'
        participants = [p for p in participants if (olympiad == 'EGOI' and p['gender'] == 'female') or (olympiad == 'EJOI' and p['age'] <= 15)]
    elif olympiad in ['BalkOI', 'JBOI']:
        key = 'score'
        participants = [p for p in participants if (olympiad == 'BalkOI' and p['grade'] != 11) or (olympiad == 'JBOI' and p['grade'] not in {10, 11})]

    return sorted(participants, key=lambda x: x[key], reverse=True)[:min(6, len(participants))]


def print_team(team):
    print(*[participant['id'] for participant in team])


if __name__ == "__main__":
    main()