#include <iostream>
#include <map>

using namespace std;

void input_sizes_sheet(map <string, int> &sizes, int q_sizes){
    string c_size;
    for (int i = 0; i < q_sizes; i++){
        cin >> c_size;
        sizes[c_size] = i;
    }
}

void input_available_T_shirts(int T_shirts[][6], int order[][6], int q_sizes, int q_colors){
    for (int i = 0; i < q_colors; i++)
        for (int j = 0; j < q_sizes; j++){
            cin >> T_shirts[i][j]; 
            order[i][j] = 0;   
        }
}

bool find_T_shirt(int c_size, int prior_color, int q_sizes, int q_colors, int T_shirts[][6]){
    if (c_size == q_sizes)
        return false;
        
    if (T_shirts[prior_color][c_size]){
        --T_shirts[prior_color][c_size];
        return true;
    }

    int c_color = 0;
    while (c_color < q_colors){
        if (T_shirts[c_color][c_size]){
            --T_shirts[c_color][c_size];
            return true;
        }
        ++c_color;
    }

    return false;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    
    int q_sizes, q_colors; cin >> q_colors >> q_sizes;

    map <string, int> sizes;
    input_sizes_sheet(sizes, q_sizes);
    
    int T_shirts[q_colors][6], order[q_colors][6];
    input_available_T_shirts(T_shirts, order, q_sizes, q_colors);

    int q_winners; cin >> q_winners;
    string prior_size;
    for (int i = 0, prior_color, c_size; i < q_winners; i++){
        cin >> prior_color >> prior_size; prior_color--;
        c_size = sizes[prior_size];

        while(!find_T_shirt(c_size, prior_color, q_sizes, q_colors, T_shirts) && c_size < q_sizes){
            ++c_size;
        }
        if (c_size == q_sizes){
            ++order[prior_color][sizes[prior_size]]; 
        }
    }

    for (int i = 0; i < q_colors; i++){
        for (int j = 0; j < q_sizes; j++)
            cout << T_shirts[i][j] << ' ';
        cout << '\n';
    }
    for (int i = 0; i < q_colors; i++){
        for (int j = 0; j < q_sizes; j++)
            cout << order[i][j] << ' ';
        cout << '\n';
    }
    
    return 0;
}
