def solve(n, m, sizes, stock, winners):
    remaining_stock = [[0] * m for _ in range(n)]
    order = []

    for i in range(n):
        for j in range(m):
            remaining_stock[i][j] = stock[i][j]

    for winner in winners:
        color, size = winner[0] - 1, sizes.index(winner[1])
        available_sizes = []

        for s in range(size, m):
            if remaining_stock[color][s] > 0:
                available_sizes.append((s, color))
                break

        while not available_sizes and size >= 0:
            size -= 1
            for s in range(m):
                if remaining_stock[color][s] > 0:
                    available_sizes.append((s, color))
                    break

        if not available_sizes:
            order.append((color, size))
        else:
            available_sizes.sort()
            s, c = available_sizes[0]
            remaining_stock[c][s] -= 1

    unused_stock = [[max(0, remaining_stock[i][j]) for j in range(m)] for i in range(n)]
    needed_stock = [[max(0, -remaining_stock[i][j]) for j in range(m)] for i in range(n)]

    return unused_stock, needed_stock

n, m = map(int, input().split())
sizes = input().split()
stock = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [input().split() for _ in range(k)]

winners = [(int(color), size) for color, size in winners]

unused_stock, needed_stock = solve(n, m, sizes, stock, winners)

for row in unused_stock:
    print(" ".join(map(str, row)))

for row in needed_stock:
    print(" ".join(map(str, row)))
