def find_team(participants, n, m, olympiads):
    result = []
    for olympiad in olympiads:
        team = []
        characteristic = None 

        if olympiad == "IOI" or olympiad == "CEOI" or olympiad == "BaltOI":
            characteristic = lambda x: x[4]
        elif olympiad == "EGOI":
            characteristic = lambda x: x[4] if x[1] == "female" else -1
        elif olympiad == "EJOI":
            characteristic = lambda x: x[4] if x[3] <= 15 else -1
        elif olympiad == "BalkOI":
            characteristic = lambda x: x[4] if x[2] != 11 else -1
        elif olympiad == "JBOI":
            characteristic = lambda x: x[4] if x[2] not in [10, 11] else -1

        team = sorted(participants, key=characteristic, reverse=True)[:6] if olympiad == "BaltOI" else sorted(participants, key=characteristic, reverse=True)[:4]
        result.append((olympiad, [member[0] for member in team]))

    return result

def main():
    n = int(input())
    participants = []
    for _ in range(n):
        participant_data = input().split()
        participant = []
        for data in participant_data:
            if data.isdigit():
                participant.append(int(data))
            else:
                participant.append(data)
        participants.append(participant)

    m = int(input())
    olympiads = []
    for _ in range(m):
        olympiads.append(input())

    teams = find_team(participants, n, m, olympiads)
    for olympiad, team in teams:
        print(olympiad)
        for member in team:
            print(member)

if __name__ == "__main__":
    main()



