def determine_team(olympiad, participants):
    team = []

    if olympiad == 'IOI':
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'CEOI':
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'EGOI':
        females = [participant for participant in participants if participant[1] == 'female']
        team = sorted(females, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'EJOI':
        under_15 = [participant for participant in participants if participant[3] <= 15]
        team = sorted(under_15, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'BaltOI':
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:6]
    elif olympiad == 'BalkOI':
        not_11th_graders = [participant for participant in participants if participant[2] != 11]
        team = sorted(not_11th_graders, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'JBOI':
        not_11th_or_10th_graders = [participant for participant in participants if participant[2] not in {10, 11}]
        team = sorted(not_11th_or_10th_graders, key=lambda x: x[4], reverse=True)[:4]

    return [participant[0] for participant in team]

n = int(input())
participants_list = []

for _ in range(n):
    participant_info = input().split()
    participant_info[0] = int(participant_info[0])
    participant_info[3] = int(participant_info[3])
    participant_info[4] = int(participant_info[4])
    participants_list.append(participant_info)

m = int(input())
olympiads_list = [input().strip() for _ in range(m)]

teams_by_olympiad = {}

for olympiad in olympiads_list:
    teams_by_olympiad[olympiad] = determine_team(olympiad, participants_list)

for olympiad in olympiads_list:
    print(olympiad)
    for participant_id in sorted(teams_by_olympiad[olympiad]):
        print(participant_id)





