#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.id < p2.id;
}

int main() {
    int n;
    cin >> n;

    vector<Participant> g(n);
    for (int i = 0; i < n; i++) {
        cin >> g[i].id >> g[i].gender >> g[i].grade >> g[i].age >> g[i].score;
    }

    int m;
    cin >> m;

    map<string, vector<int>> teams;
    for (int i = 0; i < m; i++) {
        string t;
        cin >> t;

        vector<Participant> selectedParticipants;
        if (t == "IOI" || t == "CEOI" || t == "EGOI" || t == "EJOI" || t == "BaltOI" || t == "BalkOI" || t == "JBOI") {
            sort(g.begin(), g.end(), [](const Participant& p1, const Participant& p2) {
                return p1.score > p2.score;
            });

            if (t == "EGOI") {
                for (const auto& participant : g) {
                    if (participant.gender == "female") {
                        selectedParticipants.push_back(participant);
                    }
                    if (selectedParticipants.size() == 4) {
                        break;
                    }
                }
            } else if (t == "EJOI") {
                for (const auto& participant : g) {
                    if (participant.age <= 15) {
                        selectedParticipants.push_back(participant);
                    }
                    if (selectedParticipants.size() == 4) {
                        break;
                    }
                }
            } else if (t == "BaltOI") {
                selectedParticipants.assign(g.begin(), g.begin() + 6);
            } else if (t == "BalkOI") {
                for (const auto& participant : g) {
                    if (participant.grade != 11) {
                        selectedParticipants.push_back(participant);
                    }
                    if (selectedParticipants.size() == 4) {
                        break;
                    }
                }
            } else if (t == "JBOI") {
                for (const auto& participant : g) {
                    if (participant.grade != 11 && participant.grade != 10) {
                        selectedParticipants.push_back(participant);
                    }
                    if (selectedParticipants.size() == 4) {
                        break;
                    }
                }
            } else {
                selectedParticipants.assign(g.begin(), g.begin() + 4);
            }
        }

        sort(selectedParticipants.begin(), selectedParticipants.end(), compareParticipants);

        vector<int> teamIds;
        for (const auto& participant : selectedParticipants) {
            teamIds.push_back(participant.id);
        }

        teams[t] = teamIds;
    }

    for (const auto& team : teams) {
        cout << team.first << endl;
        for (const auto& id : team.second) {
            cout << id << endl;
        }
    }

    return 0;
}
