from collections import defaultdict


def create_teams(participants, contests):
    participant_data = defaultdict(list)
    for participant in participants:
        id, gender, grade, age, score = participant
        participant_data['IOI'].append((id, score))
        participant_data['CEOI'].append((id, score))
        if gender == 'female':
            participant_data['EGOI'].append((id, score))
        if grade <= 10:
            participant_data['EJOI'].append((id, score))
        participant_data['BaltOI'].append((id, score))
        if grade != 11:
            participant_data['BalkOI'].append((id, score))
        if grade < 10:
            participant_data['JBOI'].append((id, score))

    teams = defaultdict(list)
    for contest in contests:
        sorted_participants = sorted(participant_data[contest], key=lambda x: (-x[1], x[0]))
        num_teams = 4 if contest not in ['BaltOI', 'EJOI', 'BalkOI'] else 6 if contest == 'BaltOI' else min(4, len(sorted_participants))
        for i in range(min(num_teams, len(sorted_participants))):
            teams[contest].append(sorted_participants[i][0])

    return teams


n = int(input())
participants = []
for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append((int(id), gender, int(grade), int(age), int(score)))

m = int(input())
contests = [input() for _ in range(m)]

teams = create_teams(participants, contests)

for contest in contests:
    print(contest)
    for participant in sorted(teams[contest]):
        print(participant)
