# Read the number of participants
n = int(input())

# Create a list to store the participants' information
participants = []

# Read the information for each participant
for i in range(n):
    # Read the id, gender, grade, age and score
    id, gender, grade, age, score = input().split()
    # Convert the grade, age and score to integers
    grade = int(grade)
    age = int(age)
    score = int(score)
    # Append the information as a tuple to the list
    participants.append((id, gender, grade, age, score))

# Read the number of olympiads
m = int(input())

# Create a dictionary to store the teams for each olympiad
teams = {}

# Read the names of the olympiads
for i in range(m):
    # Read the name of the olympiad
    name = input()
    # Initialize an empty list for the team
    teams[name] = []

# Define the criteria for each olympiad
criteria = {
    "IOI": lambda p: True, # All participants can take part in IOI
    "CEOI": lambda p: True, # All participants can take part in CEOI
    "EGOI": lambda p: p[1] == "female", # Only female participants can take part in EGOI
    "EJOI": lambda p: p[3] <= 15, # Only participants at most 15 years old can take part in EJOI
    "BaltOI": lambda p: True, # All participants can take part in BaltOI
    "BalkOI": lambda p: p[2] != 11, # Only participants who are not in 11th grade can take part in BalkOI
    "JBOI": lambda p: p[2] not in (10, 11) # Only participants who are not in 10th or 11th grade can take part in JBOI
}

# Define the team size for each olympiad
team_size = {
    "IOI": 4,
    "CEOI": 4,
    "EGOI": 4,
    "EJOI": 4,
    "BaltOI": 6,
    "BalkOI": 4,
    "JBOI": 4
}

# Sort the participants by their score in descending order
participants.sort(key=lambda p: -p[4])

# Loop through the participants
for p in participants:
    # Loop through the olympiads
    for name in teams:
        # Check if the participant meets the criteria for the olympiad
        if criteria[name]:
            # Check if the team is not full
            if len(teams[name]) < team_size[name]:
                # Add the participant's id to the team
                teams[name].append(p[0])

# Loop through the olympiads
for name in teams:
    # Print the name of the olympiad
    print(name)
    # Sort the team by the id in ascending order
    teams[name].sort()
    # Print the id of the team members
    print(*teams[name])
