def process_requests(n, m, sizes, available, winners):
    remaining = [[0] * m for _ in range(n)]
    needed = [[0] * m for _ in range(n)]

    for i in range(n):
        for j in range(m):
            remaining[i][j] = available[j]

    for i in range(len(winners)):
        color, size = winners[i]
        size_index = sizes.index(size)

        if remaining[color - 1][size_index] > 0:
            remaining[color - 1][size_index] -= 1
        else:
            next_size = size_index + 1
            while next_size < m:
                if remaining[color - 1][next_size] > 0:
                    remaining[color - 1][next_size] -= 1
                    needed[color - 1][next_size] += 1
                    break
                next_size += 1

    return remaining, needed


n, m = map(int, input().split())
sizes = input().split()
available = [int(x) for x in input().split()]

winners_count = int(input().split()[0])  
winners = [input().split() for _ in range(winners_count)]
winners = [(int(color), size.strip()) for color, size in winners]

remaining, needed = process_requests(n, m, sizes, available, winners)

for i in range(n):
    print(" ".join(map(str, remaining[i])))

for i in range(n):
    print(" ".join(map(str, needed[i])))


