
def process_gifts(colors, sizes, teams):
    # Ініціалізація таблиці розміром n×m для футболок кожного кольору та розміру
    remaining_gifts = {color: {size: 0 for size in sizes} for color in colors}

    # Заповнення таблиці кількістю доступних футболок кожного кольору та розміру
    for color, size, count in teams:
        remaining_gifts[color][size] += count

    # Ініціалізація таблиці для футболок, які не вдалося видати
    missing_gifts = {color: {size: 0 for size in sizes} for color in colors}

    # Обробка запитів кожного учасника та розподіл футболок
    for color, size, count in teams:
        if remaining_gifts[color][size] > 0:
            remaining_gifts[color][size] -= 1
        else:
            found = False
            for new_size in sizes[sizes.index(size):]:
                if remaining_gifts[color][new_size] > 0:
                    remaining_gifts[color][new_size] -= 1
                    found = True
                    break

            if not found:
                for new_color in colors[colors.index(color):]:
                    for new_size in sizes:
                        if remaining_gifts[new_color][new_size] > 0:
                            remaining_gifts[new_color][new_size] -= 1
                            found = True
                            break
                    if found:
                        break

            if not found:
                missing_gifts[color][size] += count

    return remaining_gifts, missing_gifts


# Приклад вхідних даних
colors = ['Red', 'Blue', 'Green']
sizes = ['S', 'M', 'L']
teams = [('Red', 'S', 2), ('Blue', 'M', 1), ('Green', 'L', 3), ('Red', 'M', 1)]

# Обробка подарунків та виведення результатів
remaining, missing = process_gifts(colors, sizes, teams)

# Виведення результатів
print("Залишилось футболок:")
print("\t" + "\t".join(sizes))
for color in colors:
    print(f"{color}\t" + "\t".join(str(remaining[color][size]) for size in sizes))

print("\nФутболок, які потрібно замовити:")
print("\t" + "\t".join(sizes))
for color in colors:
    print(f"{color}\t" + "\t".join(str(missing[color][size]) for size in sizes))
