
def find_matching_shirt(shirts, target_size, target_color):
    # Шукаємо футболку потрібного розміру та кольору
    for shirt in shirts:
        if shirt['size'] == target_size and shirt['color'] == target_color:
            return shirt

    # Якщо футболки не знайдено, шукаємо футболку того ж розміру, але іншого кольору
    matching_color_shirts = [s for s in shirts if s['size'] == target_size]
    if matching_color_shirts:
        return min(matching_color_shirts, key=lambda x: x['color'])

    # Шукаємо серед футболок наступного більшого розміру з пріоритетним кольором
    for size in range(target_size + 1, max(s['size'] for s in shirts) + 1):
        size_shirts = [s for s in shirts if s['size'] == size and s['color'] == target_color]
        if size_shirts:
            return min(size_shirts, key=lambda x: x['color'])

    # Якщо не знайдено футболку із пріоритетним кольором, вибираємо футболку з мінімальним номером
    return min(shirts, key=lambda x: x['number'])


# Приклад використання
shirts_available = [
    {'size': 1, 'color': 'red', 'number': 101},
    {'size': 2, 'color': 'blue', 'number': 102},
    # Додайте інші футболки з різними характеристиками
]

target_size = 2
target_color = 'red'

result = find_matching_shirt(shirts_available, target_size, target_color)

if result:
    print(f"Знайдено футболку: розмір {result['size']}, кольор {result['color']}, номер {result['number']}")
else:
    print("Футболка відсутня")
