def process_orders(n, m, sizes, quantities, k, winners):
    remaining_stock = {size: {color: quantity for color, quantity in enumerate(row)} for size, row in enumerate(quantities)}
    needed_stock = {size: {color: 0 for color in range(n)} for size in range(m)}

    for winner in winners:
        color, size = int(winner[1]) - 1, sizes.index(winner[0])
        remaining_stock[size][color] -= 1
        needed_stock[size][color] += 1

    for size in range(m):
        for color in range(n):
            remaining_stock[size][color] = max(remaining_stock[size][color], 0)
            needed_stock[size][color] = max(needed_stock[size][color], 0)

    return remaining_stock, needed_stock

# Приклад використання
n, m = map(int, input().split())
sizes = input().split()

quantities = []
for _ in range(n):
    quantities.append(list(map(int, input().split())))

k = int(input())

winners = []
for _ in range(k):
    winners.append(tuple(input().split()))

remaining_stock, needed_stock = process_orders(n, m, sizes, quantities, k, winners)

# Вивід залишкового та потрібного запасу
for size in range(m):
    print(" ".join(str(remaining_stock[size][color]) for color in range(n)))

for size in range(m):
    print(" ".join(str(needed_stock[size][color]) for color in range(n)))
