def distribute_gifts(n, m, sizes, quantities, winners):
    remaining_gifts = [[quantity for quantity in row] for row in quantities]
    missing_gifts = [[0] * m for _ in range(n)]

    for winner in winners:
        color, size = int(winner[0]) - 1, sizes.index(winner[1])
        if remaining_gifts[color][size] > 0:
            remaining_gifts[color][size] -= 1
        else:
            found = False
            for next_size in range(size + 1, m):
                if remaining_gifts[color][next_size] > 0:
                    remaining_gifts[color][next_size] -= 1
                    found = True
                    break
            if not found:
                for next_color in range(color + 1, n):
                    for next_size in range(m):
                        if remaining_gifts[next_color][next_size] > 0:
                            remaining_gifts[next_color][next_size] -= 1
                            found = True
                            break
                    if found:
                        break
                if not found:
                    missing_gifts[color][size] += 1

    return remaining_gifts, missing_gifts


def main():
    n, m = map(int, input().split())
    sizes = input().split()
    quantities = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    winners = [list(map(str, input().split())) for _ in range(k)]

    remaining, missing = distribute_gifts(n, m, sizes, quantities, winners)

    for row in remaining:
        print(" ".join(map(str, row)))

    for row in missing:
        print(" ".join(map(str, row)))


if __name__ == "__main__":
    main()

