#include <iostream>
#include <vector>

using namespace std;

void distribute_gifts(int n, int m, vector<vector<int>> &quantities, vector<vector<int>> &winners) {
    vector<vector<int>> remaining_gifts = quantities;
    vector<vector<int>> missing_gifts(n, vector<int>(m, 0));

    for (const auto &winner : winners) {
        int color = winner[0] - 1;
        char size = winner[1];
        int size_index = -1;

        for (int i = 0; i < m; ++i) {
            if (size == 'S' + i) {
                size_index = i;
                break;
            }
        }

        bool found = false;

        for (int i = size_index; i < m; ++i) {
            if (remaining_gifts[color][i] > 0) {
                remaining_gifts[color][i]--;
                found = true;
                break;
            }
        }

        if (!found) {
            for (int i = 0; i < m; ++i) {
                for (int j = color + 1; j < n; ++j) {
                    if (remaining_gifts[j][i] > 0) {
                        remaining_gifts[j][i]--;
                        found = true;
                        break;
                    }
                }
                if (found) {
                    break;
                }
            }
        }

        if (!found) {
            missing_gifts[color][size_index]++;
        }
    }

    // Вивід залишкових та відсутніх футболок
    for (const auto &row : remaining_gifts) {
        for (int gift : row) {
            cout << gift << " ";
        }
        cout << endl;
    }

    for (const auto &row : missing_gifts) {
        for (int missing : row) {
            cout << missing << " ";
        }
        cout << endl;
    }
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<char> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> quantities(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> quantities[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> winners(k, vector<int>(2));
    for (int i = 0; i < k; ++i) {
        cin >> winners[i][0] >> winners[i][1];
    }

    distribute_gifts(n, m, quantities, winners);

    return 0;
}
