# Функция для нахождения оптимального решения
def find_optimal(weights, boxes):
    # Суммарный вес предметов в каждой коробке
    total_weight_box1 = 0
    total_weight_box2 = 0
    
    # Номер предмета для перемещения
    item_to_move = -1
    
    for i in range(len(weights)):
        if boxes[i] == 1:
            total_weight_box1 += weights[i]
        else:
            total_weight_box2 += weights[i]
            
    # Изначальный макс. вес 
    max_weight = max(total_weight_box1, total_weight_box2)
    
    # Перебираем варианты перемещения
    for i in range(len(weights)): 
        if boxes[i] == 1:
            new_box1 = total_weight_box1 - weights[i]
            new_box2 = total_weight_box2 + weights[i]
        else:
            new_box1 = total_weight_box1 + weights[i] 
            new_box2 = total_weight_box2 - weights[i]
            
        new_max = max(new_box1, new_box2)
        
        # Если новый макс. вес меньше - запоминаем решение    
        if new_max < max_weight:
            max_weight = new_max
            item_to_move = i + 1
            
    return item_to_move

# Тестирование
weights = [int(num) for num in input().split()]  
boxes = [int(num) for num in input().split()]
print(find_optimal(weights, boxes))



# weights1 = [5, 2, 4, 3]
# boxes1 = [1, 2, 2, 1]
# print(find_optimal(weights1, boxes1)) # -1

# weights2 = [4, 2, 3, 7]  
# boxes2 = [2, 1, 1, 2]
# print(find_optimal(weights2, boxes2)) # 1