from collections import defaultdict

def find_shirt(sizes, inventory, winners):
    shirts_available = defaultdict(lambda: defaultdict(int))
    for i, row in enumerate(inventory, start=1):
        for j, count in enumerate(row):
            shirts_available[i][sizes[j]] = count
    
    shirts_needed = defaultdict(lambda: defaultdict(int))

    for winner in winners:
        color_idx, size = winner
        found = False
        
        if shirts_available[color_idx][size] > 0:
            shirts_available[color_idx][size] -= 1
            found = True
        else:
            for color in shirts_available.keys():
                if shirts_available[color][size] > 0:
                    shirts_available[color][size] -= 1
                    found = True
                    break
            
            if not found:
                for bigger_size in sizes[sizes.index(size) + 1:]:
                    for color in shirts_available.keys():
                        if shirts_available[color][bigger_size] > 0:
                            shirts_available[color][bigger_size] -= 1
                            shirts_needed[color][bigger_size] += 1
                            found = True
                            break
                    if found:
                        break
                if not found:
                    shirts_needed[color_idx][size] += 1

    # Вивід залишку та футболок, які потрібно замовити
    for color_idx, sizes in shirts_available.items():
        print(" ".join(str(count) for count in sizes.values()))
    
    for color_idx, sizes in shirts_needed.items():
        print(" ".join(str(count) for count in sizes.values()))

n, m = map(int, input().split())
sizes = input().split()
inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [input().split() for _ in range(k)]
winners = [(int(color_idx), size) for color_idx, size in winners]

find_shirt(sizes, inventory, winners)
