import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt(); // кількість кольорових кіл
        long m = scanner.nextLong(); // кількість кольорів, які треба ще взяти

        long[] colors = new long[n];
        for (int i = 0; i < n; i++) {
            colors[i] = scanner.nextLong();
        }

        long maxSubsequenceLength = calculateMaxSubsequenceLength(n, m, colors);
        System.out.println(maxSubsequenceLength);
    }

    public static long calculateMaxSubsequenceLength(int n, long m, long[] colors) {
        // Знаходимо максимальну довжину підпослідовності незакреслених кольорів
        long maxSubsequenceLength = 0;
        for (int i = 0; i < n; i++) {
            maxSubsequenceLength = Math.max(maxSubsequenceLength, colors[i]);
        }

        long remainingColors = m - n; // кількість кольорів, які ще треба вибрати
        if (remainingColors > 0) {
            maxSubsequenceLength += remainingColors / n * maxSubsequenceLength;
            remainingColors %= n;
            for (int i = 0; i < n; i++) {
                if (colors[i] == maxSubsequenceLength) {
                    remainingColors--;
                    if (remainingColors == 0) {
                        break;
                    }
                }
            }
        }

        return maxSubsequenceLength;
    }
}
