import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt(); // кількість кольорових кіл
        long m = scanner.nextLong(); // кількість кольорів, які ще треба взяти

        long[] colors = new long[n];
        for (int i = 0; i < n; i++) {
            colors[i] = scanner.nextLong();
        }

        long maxSubsequenceLength = calculateMaxSubsequenceLength(n, m, colors);
        System.out.println(maxSubsequenceLength);
    }

    public static long calculateMaxSubsequenceLength(int n, long m, long[] colors) {
        long maxSubsequenceLength = 0;

        // Знаходимо максимальне значення кольору
        for (int i = 0; i < n; i++) {
            maxSubsequenceLength = Math.max(maxSubsequenceLength, colors[i]);
        }

        // Визначаємо кількість повних циклів та залишкові кольори для вибору
        long fullCycles = m / n;
        long remainingColors = m % n;

        // Якщо залишкові кольори є, збільшуємо максимальну довжину підпослідовності
        if (remainingColors > 0) {
            maxSubsequenceLength += fullCycles * maxSubsequenceLength;
            // Знаходимо найбільше значення серед залишкових кольорів
            for (int i = 0; i < n; i++) {
                maxSubsequenceLength = Math.max(maxSubsequenceLength, colors[i]);
            }
        } else {
            maxSubsequenceLength *= fullCycles;
        }

        return maxSubsequenceLength;
    }
}
