import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt(); // кількість кольорових кіл
        long m = scanner.nextLong(); // кількість кольорів, які ще треба взяти

        long[] colors = new long[n];
        for (int i = 0; i < n; i++) {
            colors[i] = scanner.nextLong();
        }

        long maxSubsequenceLength = calculateMaxSubsequenceLength(n, m, colors);
        System.out.println(maxSubsequenceLength);
    }

    public static long calculateMaxSubsequenceLength(int n, long m, long[] colors) {
        Arrays.sort(colors); // Сортуємо масив кольорів

        long maxSubsequenceLength = colors[n - 1]; // Запам'ятовуємо найбільше значення кольору

        long remainingColors = m; // Кількість кольорів, які ще треба вибрати

        // Вибираємо кольори з найбільшими значеннями
        for (int i = n - 2; i >= 0; i--) {
            if (remainingColors <= 0) {
                break;
            }
            maxSubsequenceLength = (maxSubsequenceLength + colors[i]) / 2; // Беремо середнє значення

            remainingColors--;
        }

        return maxSubsequenceLength;
    }
}
