import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt(); // кількість кольорових кіл
        long m = scanner.nextLong(); // кількість кольорів, які ще треба взяти

        long[] colors = new long[n];
        for (int i = 0; i < n; i++) {
            colors[i] = scanner.nextLong();
        }

        long maxSubsequenceLength = calculateMaxSubsequenceLength(n, m, colors);
        System.out.println(maxSubsequenceLength);
    }

    public static long calculateMaxSubsequenceLength(int n, long m, long[] colors) {
        Arrays.sort(colors); // Сортуємо масив кольорів

        long left = 0, right = colors[n - 1] * 2; // Ліва та права межі для бінарного пошуку

        while (left < right) {
            long mid = (left + right + 1) / 2;
            long count = 0;

            for (int i = 0; i < n; i++) {
                count += Math.max(0, colors[i] - mid + 1);
            }

            if (count >= m) {
                left = mid;
            } else {
                right = mid - 1;
            }
        }

        return left;
    }
}
