#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long calculateMaxSubsequenceLength(int n, long long m, vector<long long>& colors) {
    sort(colors.begin(), colors.end()); // Сортуємо масив кольорів

    long long left = 0;
    long long right = 1e18; // Максимальне можливе значення для пошуку
    long long ans = 0;

    while (left <= right) {
        long long mid = (left + right) / 2;
        long long count = 0;

        for (int i = 0; i < n; i++) {
            count += max(0LL, colors[i] - mid);
        }

        if (count >= m) {
            ans = mid;
            left = mid + 1;
        } else {
            right = mid - 1;
        }
    }

    return ans;
}

int main() {
    int n;
    long long m;

    cin >> n >> m; // кількість кольорових кіл та кількість кольорів, які ще треба взяти

    vector<long long> colors(n);
    for (int i = 0; i < n; i++) {
        cin >> colors[i]; // введення кольорів
    }

    long long maxSubsequenceLength = calculateMaxSubsequenceLength(n, m, colors);
    cout << maxSubsequenceLength << endl;

    return 0;
}
