from collections import defaultdict

def get_participants(olympiads, participants):
    participants_info = defaultdict(list)
    for participant in participants:
        id_num, gender, grade, age, score = participant.split()
        participants_info[olympiads[0]].append((int(score), id_num))
        if gender == 'female':
            participants_info[olympiads[2]].append((int(score), id_num))
        if int(grade) < 11:
            participants_info[olympiads[5]].append((int(score), id_num))
        if int(grade) < 10:
            participants_info[olympiads[6]].append((int(score), id_num))
        if int(age) <= 15:
            participants_info[olympiads[3]].append((int(score), id_num))
        participants_info[olympiads[1]].append((int(score), id_num))
        participants_info[olympiads[4]].append((int(score), id_num))
    
    result = {}
    for olympiad in olympiads:
        result[olympiad] = []
        candidates = sorted(participants_info[olympiad], reverse=True)[:6] if olympiad == 'BaltOI' else sorted(participants_info[olympiad], reverse=True)[:4]
        result[olympiad] = sorted([candidate[1] for candidate in candidates])

    return result

n = int(input())
participants = [input().strip() for _ in range(n)]
m = int(input())
possible_olympiads = ['IOI', 'CEOI', 'EGOI', 'EJOI', 'BaltOI', 'BalkOI', 'JBOI']
olympiads = [int(input().strip()) for _ in range(m) if input().strip() in possible_olympiads]

teams = get_participants(olympiads, participants)

for olympiad in olympiads:
    print(olympiad)
    for participant in teams[olympiad]:
        print(participant)
